/*   -*- coding: utf-8 -*-  */
/***********************************************************************
 
   Module   : ArXiv
   Commande : ArXivExplorDataShell
   Fichier  : ArXivExplorDataShell.c
   Auteur   : Jacques Ducloy
   Date     : 2015-12-18
 
************************************************************************/
#include <stdio.h>     /* for printf */
#include <stdlib.h>    /* for exit */
#include "Explor.h"

extern char *optarg;
extern int   optind;
int getopt();

SxmlNode *ExplorStepNode;
SxmlNode *ExplorStreamListSteps;

void generArXivShellCorpusBiblio()
{
  SxmlNode *listSxmlImportFile;
  char     *strListSxmlImportFile;
  SxmlNode *fileNode;

  printf("<?dilib file=\"%s/bin/%sCorpusBiblio.sh\" ?>\n", ExplorAreaDir, ExplorStreamCode );
  printf ("#!/bin/sh\n");
  printf ("# This file is generated by Dilib / ArXiv / ArXivExplorDataShells \n");
  printf ("echo \"---- Executing sh %s/bin/%sCorpusBiblio.sh\" \n", ExplorAreaDir, ExplorStreamCode );
  ExplorGenerDeleteHfd (ExplorStreamCode, "Corpus", "biblio");               /* if update */

  strListSxmlImportFile=ExplorGetFromDictK3("Area", ExplorStreamCode, "Corpus/importFile");
  if (!strListSxmlImportFile)
    {
      fprintf(stderr, "parameter * Area/%s/Corpus/importFile * is missing\n", ExplorStreamCode);
      exit(EXIT_FAILURE);
    }
  listSxmlImportFile=SxmlFromString(strListSxmlImportFile);
  printf (" (\n");
  SxmlReset (listSxmlImportFile);
  while ((fileNode=SxmlNextNode(listSxmlImportFile)))
     {
        printf ("cat %s/Import/%s   \n", ExplorAreaDir, SxmlLeafText(fileNode));
     }
  printf (" ) | SxmlUnIndent  \\\n"); 
  printf ("   | ArXivToTei  \\\n"); 
  printf ("   | TeiPutRefToIdno -t wicri:Area/%s/Corpus  \\\n", ExplorStreamCode );
  printf ("   | HfdBuild -h %s/Data/%s/Corpus/biblio\n\n",ExplorAreaDir, ExplorStreamCode);

  printf (" echo \"==== \" %s, step Corpus, biblio done\n", ExplorStreamCode);
  printf (" HfdCat %s/Data/%s/Corpus/biblio.hfd | wc \n", ExplorAreaDir, ExplorStreamCode);

  printf("<?dilib appendFile=\"%s/bin/area.mk\" ?>\n", ExplorAreaDir );
  printf("# This part is generated by Dilib / ArXiv / ArXivExplorDataShells \n");
  printf("%s/Make/%s/Corpus/biblio: ", ExplorAreaDir, ExplorStreamCode);
  SxmlReset (listSxmlImportFile);
  while ((fileNode=SxmlNextNode(listSxmlImportFile)))
     {
	printf (" \\\n");
        printf ("         %s/Import/%s", ExplorAreaDir, SxmlLeafText(fileNode));
     }
  printf("\n\tsh %s/bin/%sCorpusBiblio.sh \n", ExplorAreaDir, ExplorStreamCode );
  printf("\ttouch %s/Make/%s/Corpus/biblio\n\n", ExplorAreaDir, ExplorStreamCode);
}

void generArXivShellCurationBiblio()
{
  SxmlNode *previousStep;
  char     *codePrevious;

  printf("<?dilib file=\"%s/bin/%sCurationBiblio.sh\" ?>\n", ExplorAreaDir, ExplorStreamCode );
  printf ("#!/bin/sh\n");
  printf ("# This shell has been generated by ArXivExplorDataShells \n");
  printf ("echo \"---- Executing sh %s/bin/%sCurationBiblio.sh\" \n", ExplorAreaDir, ExplorStreamCode );
  ExplorGenerDeleteHfd(ExplorStreamCode, "Curation", "biblio");
  previousStep=SxmlPreviousSibling(ExplorStepNode);
  codePrevious=SxmlLeafText(previousStep);
  printf (" HfdCat %s/Data/%s/%s/biblio.hfd \\\n", ExplorAreaDir, ExplorStreamCode, codePrevious);
  printf ("   | SgmlFast -c 1  \\\n");
  printf ("   | TeiPutRefToIdno -t wicri:Area/%s/Curation  \\\n", ExplorStreamCode );
  printf ("   | HfdBuild -h %s/Data/%s/Curation/biblio\n\n",ExplorAreaDir, ExplorStreamCode);

  printf (" echo \"==== \" %s, step Curation, biblio done\n", ExplorStreamCode);
  printf (" HfdCat %s/Data/%s/Curation/biblio.hfd | wc \n", ExplorAreaDir, ExplorStreamCode);

  printf("<?dilib appendFile=\"%s/bin/area.mk\" ?>\n", ExplorAreaDir );
  printf("# This part is generated by ArXivExplorDataShells /  generNlmMedlineShellCurationBiblio() \n");
  printf("%s/Make/%s/Curation/biblio: \\\n", ExplorAreaDir, ExplorStreamCode);
  printf("                %s/Make/%s/%s.step \n", ExplorAreaDir, ExplorStreamCode, codePrevious);
  printf("\tsh %s/bin/%sCurationBiblio.sh \n", ExplorAreaDir, ExplorStreamCode );
  printf("\ttouch %s/Make/%s/Curation/biblio\n\n", ExplorAreaDir, ExplorStreamCode);
}

void generArXivShellCheckExplBiblio(char *step)
{
  printf("<?dilib file=\"%s/bin/%s%sBiblio.sh\" ?>\n", ExplorAreaDir, ExplorStreamCode, step );
  printf ("#!/bin/sh\n");
  printf ("# This file is generated by Dilib / ArXiv / ArXivExplorDataShells / generArXivShellCheckExplBiblio  \n");
  printf ("echo \"---- Executing sh %s/bin/%s%sBiblio.sh\" \n", ExplorAreaDir, ExplorStreamCode, step );
  ExplorGenerDeleteHfd(ExplorStreamCode, step, "biblio");
  printf (" HfdCat %s/Data/%s/Curation/biblio.hfd \\\n", ExplorAreaDir, ExplorStreamCode);
  /* printf ("   | SgmlFast -c 1  \\\n"); */
  ExplorExplorationCommonOperations(ExplorStreamCode, step, 0);
  ExplorGenerBuildBiblio(ExplorStreamCode, step, NULL);
  printf("<?dilib appendFile=\"%s/bin/area.mk\" ?>\n", ExplorAreaDir );
  printf("# This part is generated by ArXivExplorDataShells /  generArXivShellCheckExplBiblio  \n");
  printf("%s/Make/%s/%s/biblio: \\\n ", ExplorAreaDir, ExplorStreamCode, step);
  printf("                %s/Make/%s/Curation.step \n", ExplorAreaDir, ExplorStreamCode);
  printf("\tsh %s/bin/%s%sBiblio.sh\n", ExplorAreaDir, ExplorStreamCode, step );
  printf("\ttouch %s/Make/%s/%s/biblio\n\n", ExplorAreaDir, ExplorStreamCode, step);
}


int main (int argc, char **argv) 
{
   int cOption;
   char *pathParamFile;

   pathParamFile=NULL;
   ExplorStreamCode=NULL;

   while((cOption=getopt(argc,argv,"s:t:"))!=EOF)
     {switch (cOption)
	 {
	 case 's':
	   ExplorStreamCode=optarg;
	   break;
	 case 't':
	   pathParamFile=optarg;
	   break;
	 }
     }
   if ((!pathParamFile)|| (!ExplorStreamCode)) 
     {
         perror("**** Options -s stream and -t paramFile are mandatory\n");
         exit (EXIT_FAILURE);
     }
   ExplorParamInit(pathParamFile);
   ExplorStreamListSteps=SxmlFromString(ExplorGetFromDictK3("Area", ExplorStreamCode, "listSteps"));
   ExplorGenerShellCreateData( ExplorStreamCode, ExplorStreamListSteps);


   SxmlReset(ExplorStreamListSteps);
   while ((ExplorStepNode=SxmlNextNode(ExplorStreamListSteps)))
    {
      char *stepCode;
      stepCode=SxmlLeafText(ExplorStepNode);
      if(strcmp(stepCode, "Corpus")==0)
	{
	  ExplorGenerShellCreateStep(ExplorStreamCode , stepCode);
	  generArXivShellCorpusBiblio();
	  continue;
	}
      else if(strcmp(stepCode, "Curation")==0)
	{
	  ExplorGenerShellCreateStep(ExplorStreamCode , stepCode);
	  generArXivShellCurationBiblio();
	  continue;
	}
     else if(strcmp(stepCode, "Checkpoint")==0)
	{
	  ExplorGenerShellCreateStep(ExplorStreamCode , stepCode);
	  generArXivShellCheckExplBiblio(stepCode);
	  continue;
	}
    else if(strcmp(stepCode, "Exploration")==0)
	{
	  ExplorGenerShellCreateStep(ExplorStreamCode , stepCode);
	  generArXivShellCheckExplBiblio(stepCode);
	  continue;
	}
    }
   ExplorGenerAllShellsIndex(ExplorStreamCode);
   exit (EXIT_SUCCESS);
}
