#
#   Module  : Buffer
#   Fichier : Buffer.mk

include $(DILIB)/MakeDef.mk

$(DILIB)/Date/Buffer.mod: $(DILIB)/Date/Buffer.include  \
                                 $(DILIB)/Date/Buffer.lib     \
                                 $(DILIB)/Date/Buffer.bin     \
                                 $(DILIB)/Date/Buffer.man
	$(TOUCH)

#----------------------------------------------------------------
# Les Fichiers include
#

$(DILIB)/Date/Buffer.include: $(DILIB)/include/Buffer.h \
                                    $(DILIB)/include/BufferParser.h \
                                    $(DILIB)/include/BufferParserXml.h
	$(TOUCH)

$(DILIB)/include/Buffer.h:  $(DILIB_IMPORT)/Buffer/Buffer.h
	cp  $(DILIB_IMPORT)/Buffer/Buffer.h $@

$(DILIB)/include/BufferParser.h:  $(DILIB_IMPORT)/Buffer/BufferParser.h
	cp  $(DILIB_IMPORT)/Buffer/BufferParser.h $@

$(DILIB)/include/BufferParserXml.h:  $(DILIB_IMPORT)/Buffer/BufferParserXml.h
	cp  $(DILIB_IMPORT)/Buffer/BufferParserXml.h $@

#--------------------------------------------------------------------
# la librairie Dilib
#

$(DILIB)/Date/Buffer.lib: $(DILIB)/Date/Buffer.o          \
                          $(DILIB)/Date/BufferParser.o    \
                          $(DILIB)/Date/BufferFormat.o    \
                          $(DILIB)/Date/BufferTail.o      \
                          $(DILIB)/Date/BufferParserXml.o \
                          $(DILIB)/Date/BufferTime.o
	$(RANLIB) $(DILIB)/lib/libDilib.a
	$(TOUCH)

$(DILIB)/Date/Buffer.o:$(DILIB)/Date/Buffer.o1 \
                             $(DILIB)/Date/Except.o
	$(TOUCH)

$(DILIB)/Date/Buffer.o1: $(DILIB_IMPORT)/Buffer/Buffer.c \
                               $(DILIB)/include/Buffer.h     \
                               $(DILIB)/include/Except.h
	$(CC) $(DILIB_IMPORT)/Buffer/Buffer.c   -I$(DILIB)/include            \
	      -c -o Buffer.o
	ar ruv  $(DILIB)/lib/libDilib.a   Buffer.o
	$(TOUCH)

$(DILIB)/Date/BufferParser.o: $(DILIB_IMPORT)/Buffer/BufferParser.c \
                               $(DILIB)/include/Buffer.h     \
                               $(DILIB)/include/BufferParser.h     \
                               $(DILIB)/Date/Buffer.o \
                               $(DILIB)/include/Except.h
	$(CC) $(DILIB_IMPORT)/Buffer/BufferParser.c   -I$(DILIB)/include            \
	      -c -o BufferParser.o
	ar ruv  $(DILIB)/lib/libDilib.a   BufferParser.o
	$(TOUCH)

$(DILIB)/Date/BufferTime.o: $(DILIB_IMPORT)/Buffer/BufferTime.c  \
                               $(DILIB)/include/Buffer.h         \
                               $(DILIB)/Date/Buffer.o            \
                               $(DILIB)/include/Except.h
	$(CC) $(DILIB_IMPORT)/Buffer/BufferTime.c   -I$(DILIB)/include            \
	      -c -o BufferTime.o
	ar ruv  $(DILIB)/lib/libDilib.a   BufferTime.o
	$(TOUCH)

$(DILIB)/Date/BufferTail.o: $(DILIB_IMPORT)/Buffer/BufferTail.c \
                               $(DILIB)/include/Buffer.h     \
                               $(DILIB)/include/BufferParser.h     \
                               $(DILIB)/Date/Buffer.o \
                               $(DILIB)/include/Except.h
	$(CC) $(DILIB_IMPORT)/Buffer/BufferTail.c   -I$(DILIB)/include            \
	      -c -o BufferTail.o
	ar ruv  $(DILIB)/lib/libDilib.a   BufferTail.o
	$(TOUCH)

$(DILIB)/Date/BufferFormat.o: $(DILIB_IMPORT)/Buffer/BufferFormat.c \
                               $(DILIB)/include/Buffer.h     \
                               $(DILIB)/include/BufferParser.h     \
                               $(DILIB)/Date/Buffer.o \
                               $(DILIB)/include/Except.h
	$(CC) $(DILIB_IMPORT)/Buffer/BufferFormat.c   -I$(DILIB)/include            \
	      -c -o BufferFormat.o
	ar ruv  $(DILIB)/lib/libDilib.a   BufferFormat.o
	$(TOUCH)

$(DILIB)/Date/BufferParserXml.o: $(DILIB_IMPORT)/Buffer/BufferParserXml.c \
                               $(DILIB)/include/Buffer.h     \
                               $(DILIB)/include/BufferParser.h     \
                               $(DILIB)/include/BufferParserXml.h     \
                               $(DILIB)/Date/BufferParser.o \
                               $(DILIB)/include/Except.h
	$(CC) $(DILIB_IMPORT)/Buffer/BufferParserXml.c   -I$(DILIB)/include            \
	      -c -o BufferParserXml.o
	ar ruv  $(DILIB)/lib/libDilib.a   BufferParserXml.o
	$(TOUCH)


#------------------------------------------------------------------
# Les binaires
#

$(DILIB)/Date/Buffer.bin: $(DILIB)/bin/DilibHead         \
                                 $(DILIB)/bin/DilibTail         \
                                 $(DILIB)/bin/BufferSelect         \
                                 $(DILIB)/bin/BufferSelectFirstByKey 
	$(TOUCH)

$(DILIB)/bin/DilibHead: $(DILIB_IMPORT)/Buffer/DilibHead.c
	$(CC)  $(DILIB_IMPORT)/Buffer/DilibHead.c -o $@

$(DILIB)/bin/BufferSelect: $(DILIB_IMPORT)/Buffer/BufferSelect.c
	$(CC)  $(DILIB_IMPORT)/Buffer/BufferSelect.c -o $@

$(DILIB)/bin/DilibTail: $(DILIB_IMPORT)/Buffer/DilibTail.c \
                       $(DILIB)/Date/Buffer.lib
	$(CC)  $(DILIB_IMPORT)/Buffer/DilibTail.c -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a  -o $@

$(DILIB)/bin/BufferSelectFirstByKey: $(DILIB_IMPORT)/Buffer/BufferSelectFirstByKey.c \
                       $(DILIB)/Date/Buffer.lib
	$(CC)  $(DILIB_IMPORT)/Buffer/BufferSelectFirstByKey.c -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a  -o $@


#--------------------------------------------------------------------
#    La Documentation par man d'Unix

$(DILIB)/Date/Buffer.man:$(DILIB)/man/man1/BufferIntro.1  \
                                $(DILIB)/man/man1/BufferSelect.1       \
                                $(DILIB)/man/man3/Buffer.3
	$(TOUCH)

$(DILIB)/man/man1/BufferIntro.1: $(DILIB_IMPORT)/Buffer/BufferIntro.1.man
	$(MAKE_MAN) $(DILIB_IMPORT)/Buffer/BufferIntro.1.man Buffer   $@

$(DILIB)/man/man1/BufferSelect.1: $(DILIB_IMPORT)/Buffer/BufferSelect.1.man
	$(MAKE_MAN) $(DILIB_IMPORT)/Buffer/BufferSelect.1.man Buffer   $@

$(DILIB)/man/man3/Buffer.3:  $(DILIB_IMPORT)/Buffer/Buffer.3.man
	$(MAKE_MAN)  $(DILIB_IMPORT)/Buffer/Buffer.3.man Buffer  $@
	cp  $(DILIB_IMPORT)/Buffer/Buffer.3.rman $(DILIB)/man/man3/BufferGets.3
	cp  $(DILIB_IMPORT)/Buffer/Buffer.3.rman $(DILIB)/man/man3/BufferStrncat.3
	cp  $(DILIB_IMPORT)/Buffer/Buffer.3.rman $(DILIB)/man/man3/BufferStrcat.3
	cp  $(DILIB_IMPORT)/Buffer/Buffer.3.rman $(DILIB)/man/man3/BufferStrcpy.3
	cp  $(DILIB_IMPORT)/Buffer/Buffer.3.rman $(DILIB)/man/man3/BufferStrncpy.3
	cp  $(DILIB_IMPORT)/Buffer/Buffer.3.rman $(DILIB)/man/man3/BufferCreate.3
	cp  $(DILIB_IMPORT)/Buffer/Buffer.3.rman $(DILIB)/man/man3/BufferFree.3
	cp  $(DILIB_IMPORT)/Buffer/Buffer.3.rman $(DILIB)/man/man3/BufferReset.3
	cp  $(DILIB_IMPORT)/Buffer/Buffer.3.rman $(DILIB)/man/man3/BufferFromString.3
	cp  $(DILIB_IMPORT)/Buffer/Buffer.3.rman $(DILIB)/man/man3/BufferCopy.3
	cp  $(DILIB_IMPORT)/Buffer/Buffer.3.rman $(DILIB)/man/man3/BufferString.3
	cp  $(DILIB_IMPORT)/Buffer/Buffer.3.rman $(DILIB)/man/man3/BufferSave.3
	cp  $(DILIB_IMPORT)/Buffer/Buffer.3.rman $(DILIB)/man/man3/BufferCat.3
	cp  $(DILIB_IMPORT)/Buffer/Buffer.3.rman $(DILIB)/man/man3/BufferClone.3
	cp  $(DILIB_IMPORT)/Buffer/Buffer.3.rman $(DILIB)/man/man3/BufferFgets.3
	cp  $(DILIB_IMPORT)/Buffer/Buffer.3.rman $(DILIB)/man/man3/BufferSize.3
	cp  $(DILIB_IMPORT)/Buffer/Buffer.3.rman $(DILIB)/man/man3/BufferLen.3
	cp  $(DILIB_IMPORT)/Buffer/Buffer.3.rman $(DILIB)/man/man3/BufferCharCat.3
	cp  $(DILIB_IMPORT)/Buffer/Buffer.3.rman $(DILIB)/man/man3/BufferTailCmp.3
	cp  $(DILIB_IMPORT)/Buffer/Buffer.3.rman $(DILIB)/man/man3/BufferTailReplace.3
	cp  $(DILIB_IMPORT)/Buffer/Buffer.3.rman $(DILIB)/man/man3/BufferTailCut.3
	cp  $(DILIB_IMPORT)/Buffer/Buffer.3.rman $(DILIB)/man/man3/BufferIncrement.3
	cp  $(DILIB_IMPORT)/Buffer/Buffer.3.rman $(DILIB)/man/man3/BufferGetSubString.3
	cp  $(DILIB_IMPORT)/Buffer/Buffer.3.rman $(DILIB)/man/man3/BufferGetIntString.3

