.TH BufferSelect 1 "1 November 1993"
.SH NAME
BufferSelect \- records selections from streams.
.SH SYNOPSYS
.LP
.B BufferSelect
[
.B \-f
.I nFrom
] [
.B \-t
.I nTo
] [
.B \-s
.I nStep
] [
.B \-m
.I nMax
] <
.I inputFile
.SH DESCRIPTION
.LP
.B BufferSelect
selects records from standard input and writes them on standard output.
As it dont work with buffers, it can operate with any size of records.
.SH OPTIONS
.I nFrom
is the rank of first record (rank 0) to copy (implicit value 0).
.LP
.I nTo
if greater than zero, is the rank of last record to copy (implicit value 0).
Null value inhibits this control.
.LP
.I nStep
is the step between two records to be copied. 
Implicit value 1 selects all records.
.LP 
nMax
if greater than zero, indicates the maximun number of records to be copied.
Null or negative value inhibits this control.
Implicit value 0.
.SH REMARK
If you want to have a quick selection on a Hfd organization, consider using 
.BR XhfdBrowser (1)
instead.
.SH EXAMPLE
.LP
Equivalent command to Unix head
.RI \- n
(with record of any size) may be done with:
.LP
	BufferSelect -m
.I n
< my_file
.LP
Selecting one for three records for an entire file.
.LP
	BufferSelect -s 3 < my_file
.LP
WARNING: the order of -m and -t is important.
.LP
If you use:
.LP
       BufferSelect -m 10 -t 5 < my_file
.LP
you get the 6 first lines (first line is #0).
.LP
But if you use:
.LP
       BufferSelect  -t 5 -m 10 < my_file
.LP
you get the 10 first lines.
.SH "SEE ALSO"
.BR DamHfdSelect (1),
.BR BufferHead (1),
.BR BufferTail (1),
.BR XhfdBrowser (1).
.SH AUTHOR
J. DUCLOY
CRIN, INRIA Lorraine

