
# Module    Explor
# Fichier   Explor.mk

include  $(DILIB)/MakeDef.mk

$(DILIB)/Date/Explor.mod: $(DILIB)/Date/Explor.bin \
                                   $(DILIB)/Date/Explor.include \
                                   $(DILIB)/Date/Explor.css \
                                   $(DILIB)/Date/Explor.lib \
                                   $(DILIB)/Date/Explor.php \
                                   $(DILIB)/Date/Explor.data
	$(TOUCH)

#----------------------------------------------------------------
# include files
#
$(DILIB)/Date/Explor.include: $(DILIB)/include/Explor.h  \
                                     $(DILIB)/include/ExplorGenerPages.h
	$(TOUCH)

$(DILIB)/include/Explor.h: $(DILIB_IMPORT)/Explor/Explor.h \
               $(DILIB)/Date/StrSearch.include  \
               $(DILIB)/Date/SxmlNode.include
	cp $(DILIB_IMPORT)/Explor/Explor.h $@

$(DILIB)/include/ExplorGenerPages.h: $(DILIB_IMPORT)/Explor/ExplorGenerPages.h \
               $(DILIB)/Date/StrDict.include  \
               $(DILIB)/Date/SxmlNode.include
	cp $(DILIB_IMPORT)/Explor/ExplorGenerPages.h $@

#----------------------------------------------------------------
# css files
#
$(DILIB)/Date/Explor.css: $(DILIB)/css/ExplorFrame.css
	$(TOUCH)

$(DILIB)/css/ExplorFrame.css: $(DILIB_IMPORT)/Explor/ExplorFrame.css
	cp $(DILIB_IMPORT)/Explor/ExplorFrame.css $@

#----------------------------------------------------------------
# php files
#
$(DILIB)/Date/Explor.php: $(DILIB)/php/Explor/Explor.php
	$(TOUCH)

$(DILIB)/php/Explor/Explor.php: $(DILIB_IMPORT)/Explor/Explor.php
	cp $(DILIB_IMPORT)/Explor/Explor.php $@


#----------------------------------------------------------------
# data
#
$(DILIB)/Date/Explor.data:$(DILIB)/data/Explor/param.root.tab        \
                             $(DILIB)/data/icons/Nuvola_apps_important.png  \
                             $(DILIB)/data/icons/CorpusIcon.png             \
                             $(DILIB)/data/icons/RepositoryIcon.png         \
                             $(DILIB)/data/icons/CurationIcon.png           \
                             $(DILIB)/data/icons/ExplorationIcon.png        \
                             $(DILIB)/data/icons/CheckpointIcon.png         \
                             $(DILIB)/data/icons/ExtractionIcon.png         \
                             $(DILIB)/data/icons/ExplorTreeRoot.png         \
                             $(DILIB)/data/icons/Zoom-in.png                \
                             $(DILIB)/data/icons/AnalyseIcon.png            \
                             $(DILIB)/data/icons/MergingIcon.png            \
                             $(DILIB)/data/Explor/param.fr.tab              \
                             $(DILIB)/data/Explor/MainMergeParam.data.tab   \
                             $(DILIB)/data/Explor/ZoomParam.data.tab        \
                             $(DILIB)/data/Explor/ZoomParam.en.tab          \
                             $(DILIB)/data/Explor/ZoomParam.fr.tab          \
                             $(DILIB)/data/Explor/MainMergeParam.en.tab     \
                             $(DILIB)/data/Explor/MainMergeParam.fr.tab     \
                             $(DILIB)/data/Explor/ListParamTypes.tab        \
                             $(DILIB)/data/Explor/ExplorParamTable.dict     \
                             $(DILIB)/data/Explor/param.en.tab
	$(TOUCH)

$(DILIB)/data/Explor/MainMergeParam.data.tab:$(DILIB_IMPORT)/Explor/Data/MainMergeParam.data.wiki \
                                      $(DILIB)/bin/ExplorParamFromWiki
	ExplorParamFromWiki < $(DILIB_IMPORT)/Explor/Data/MainMergeParam.data.wiki > $@

$(DILIB)/data/Explor/MainMergeParam.en.tab:$(DILIB_IMPORT)/Explor/Data/MainMergeParam.en.wiki \
                                      $(DILIB)/bin/ExplorParamFromWiki
	ExplorParamFromWiki < $(DILIB_IMPORT)/Explor/Data/MainMergeParam.en.wiki > $@

$(DILIB)/data/Explor/MainMergeParam.fr.tab:$(DILIB_IMPORT)/Explor/Data/MainMergeParam.fr.wiki \
                                      $(DILIB)/bin/ExplorParamFromWiki
	ExplorParamFromWiki < $(DILIB_IMPORT)/Explor/Data/MainMergeParam.fr.wiki > $@

$(DILIB)/data/Explor/ZoomParam.data.tab:$(DILIB_IMPORT)/Explor/Data/ZoomParam.data.wiki \
                                      $(DILIB)/bin/ExplorParamFromWiki
	ExplorParamFromWiki < $(DILIB_IMPORT)/Explor/Data/ZoomParam.data.wiki > $@

$(DILIB)/data/Explor/ZoomParam.fr.tab:$(DILIB_IMPORT)/Explor/Data/ZoomParam.fr.wiki \
                                      $(DILIB)/bin/ExplorParamFromWiki
	ExplorParamFromWiki < $(DILIB_IMPORT)/Explor/Data/ZoomParam.fr.wiki > $@

$(DILIB)/data/Explor/ZoomParam.en.tab:$(DILIB_IMPORT)/Explor/Data/ZoomParam.en.wiki \
                                      $(DILIB)/bin/ExplorParamFromWiki
	ExplorParamFromWiki < $(DILIB_IMPORT)/Explor/Data/ZoomParam.en.wiki > $@

$(DILIB)/data/Explor/param.root.tab: $(DILIB_IMPORT)/Explor/Data/ExplorParam.root.wiki \
                                     $(DILIB_IMPORT)/Explor/Data/ExplorParamDataIndex.wiki \
                                      $(DILIB)/bin/ExplorParamFromWiki                      \
                                   $(DILIB_IMPORT)/Explor/buildParamDataRoot.sh                  \
                                   $(DILIB)/bin/ExplorParamDictFromWiki
	sh $(DILIB_IMPORT)/Explor/buildParamDataRoot.sh > $@

$(DILIB)/data/Explor/param.fr.tab: $(DILIB_IMPORT)/Explor/Data/ExplorParam.fr.wiki          \
                                   $(DILIB_IMPORT)/Explor/Data/ExplorParamSiteIndex.fr.wiki \
                                   $(DILIB)/bin/ExplorParamFromWiki                         \
                                   $(DILIB_IMPORT)/Explor/buildParamSiteFr.sh               \
                                   $(DILIB)/bin/ExplorParamDictFromWiki
	sh $(DILIB_IMPORT)/Explor/buildParamSiteFr.sh > $@

$(DILIB)/data/Explor/ListParamTypes.tab:  $(DILIB_ROOT)/Import/Explor/buildListParamTypes.sh  \
                                          $(DILIB_ROOT)/Import/Explor/Data/ExplorListParam.wiki \
                                          $(DILIB)/Date/MediaWiki.bin
	sh  $(DILIB_ROOT)/Import/Explor/buildListParamTypes.sh > $@

$(DILIB)/data/Explor/param.en.tab: $(DILIB_IMPORT)/Explor/Data/ExplorParam.en.wiki \
                                      $(DILIB)/bin/ExplorParamFromWiki
	ExplorParamFromWiki < $(DILIB_IMPORT)/Explor/Data/ExplorParam.en.wiki > $@

$(DILIB)/data/icons/Nuvola_apps_important.png:  $(DILIB_IMPORT)/Explor/Data/Nuvola_apps_important.png
	cp $(DILIB_IMPORT)/Explor/Data/Nuvola_apps_important.png $@

$(DILIB)/data/icons/CorpusIcon.png:  $(DILIB_IMPORT)/Explor/Data/CorpusIcon.png
	cp $(DILIB_IMPORT)/Explor/Data/CorpusIcon.png $@

$(DILIB)/data/icons/MergingIcon.png:  $(DILIB_IMPORT)/Explor/Data/MergingIcon.png
	cp $(DILIB_IMPORT)/Explor/Data/MergingIcon.png $@

$(DILIB)/data/icons/ExplorTreeRoot.png:  $(DILIB_IMPORT)/Explor/Data/ExplorTreeRoot.png
	cp $(DILIB_IMPORT)/Explor/Data/ExplorTreeRoot.png $@

$(DILIB)/data/icons/CheckpointIcon.png:  $(DILIB_IMPORT)/Explor/Data/CheckpointIcon.png
	cp $(DILIB_IMPORT)/Explor/Data/CheckpointIcon.png $@

$(DILIB)/data/icons/Zoom-in.png:  $(DILIB_IMPORT)/Explor/Data/Zoom-in.png
	cp $(DILIB_IMPORT)/Explor/Data/Zoom-in.png $@

$(DILIB)/data/icons/AnalyseIcon.png:  $(DILIB_IMPORT)/Explor/Data/Microscope_icon.svg.png
	cp $(DILIB_IMPORT)/Explor/Data/Microscope_icon.svg.png $@

$(DILIB)/data/icons/CurationIcon.png:  $(DILIB_IMPORT)/Explor/Data/CurationIcon.png
	cp $(DILIB_IMPORT)/Explor/Data/CurationIcon.png $@

$(DILIB)/data/icons/RepositoryIcon.png:  $(DILIB_IMPORT)/Explor/Data/ExplorRepository.png
	cp $(DILIB_IMPORT)/Explor/Data/ExplorRepository.png $@

$(DILIB)/data/icons/ExplorationIcon.png:  $(DILIB_IMPORT)/Explor/Data/ExplorationIcon.png
	cp $(DILIB_IMPORT)/Explor/Data/ExplorationIcon.png $@

$(DILIB)/data/icons/ExtractionIcon.png:  $(DILIB_IMPORT)/Explor/Data/ExtractionIcon.png
	cp $(DILIB_IMPORT)/Explor/Data/ExtractionIcon.png $@

$(DILIB)/data/Explor/ExplorParamTable.dict:  $(DILIB_IMPORT)/Explor/Data/ExplorParamPages.wiki \
                        $(DILIB)/Date/MediaWiki.bin
	MediaWikiCleanTable < $(DILIB_IMPORT)/Explor/Data/ExplorParamPages.wiki | MediaWikiTable2Sxml | MediaWikiTableTransformCol -k1 -t12 -E3 | sort -u > $@


#----------------------------------------------------------------
# Dilib library
#

$(DILIB)/Date/Explor.lib:$(DILIB)/Date/ExplorHtmlTools.o     \
                                $(DILIB)/Date/ExplorPhpTools.o      \
                                $(DILIB)/Date/ExplorGenerPagesTools.o      \
                                $(DILIB)/Date/ExplorGenerPhpProc.o  \
                                $(DILIB)/Date/ExplorGenerTemplateTools.o         \
                                $(DILIB)/Date/ExplorTools.o          \
                                $(DILIB)/Date/ExplorSidebar.o       \
                                $(DILIB)/Date/ExplorDataShellTools.o        
	$(RANLIB) $(DILIB)/lib/libDilib.a
	$(TOUCH)

$(DILIB)/Date/ExplorHtmlTools.o:$(DILIB_IMPORT)/Explor/ExplorHtmlTools.c \
                               $(DILIB)/Date/Explor.include \
                               $(DILIB)/Date/Wicri.include \
                               $(DILIB)/Date/CharSetBuffer.lib \
                              $(DILIB)/Date/WicriTools.o
		$(CC) $(DILIB_IMPORT)/Explor/ExplorHtmlTools.c   -I$(DILIB)/include            \
	      -c -o ExplorHtmlTools.o
	ar ruv  $(DILIB)/lib/libDilib.a   ExplorHtmlTools.o
	$(TOUCH)

$(DILIB)/Date/ExplorGenerPagesTools.o:$(DILIB_IMPORT)/Explor/ExplorGenerPagesTools.c \
                               $(DILIB)/Date/Explor.include \
                               $(DILIB)/Date/MediaWiki.include \
                               $(DILIB)/Date/Wicri.include \
                              $(DILIB)/Date/WicriTools.o
		$(CC) $(DILIB_IMPORT)/Explor/ExplorGenerPagesTools.c   -I$(DILIB)/include            \
	      -c -o ExplorGenerPagesTools.o
	ar ruv  $(DILIB)/lib/libDilib.a   ExplorGenerPagesTools.o
	$(TOUCH)


$(DILIB)/Date/ExplorPhpTools.o:$(DILIB_IMPORT)/Explor/ExplorPhpTools.c \
                               $(DILIB)/Date/Explor.include \
                              $(DILIB)/Date/WicriTools.o
		$(CC) $(DILIB_IMPORT)/Explor/ExplorPhpTools.c   -I$(DILIB)/include            \
	      -c -o ExplorPhpTools.o
	ar ruv  $(DILIB)/lib/libDilib.a   ExplorPhpTools.o
	$(TOUCH)

$(DILIB)/Date/ExplorSidebar.o:$(DILIB_IMPORT)/Explor/ExplorSidebar.c \
                               $(DILIB)/Date/Explor.include \
                              $(DILIB)/Date/WicriTools.o
		$(CC) $(DILIB_IMPORT)/Explor/ExplorSidebar.c  -Wall -I$(DILIB)/include            \
	      -c -o ExplorSidebar.o
	ar ruv  $(DILIB)/lib/libDilib.a   ExplorSidebar.o
	$(TOUCH)

$(DILIB)/Date/ExplorGenerPhpProc.o:$(DILIB_IMPORT)/Explor/ExplorGenerPhpProc.c \
                               $(DILIB)/Date/Explor.include \
                              $(DILIB)/Date/WicriTools.o
		$(CC) $(DILIB_IMPORT)/Explor/ExplorGenerPhpProc.c   -I$(DILIB)/include            \
	      -c -o ExplorGenerPhpProc.o
	ar ruv  $(DILIB)/lib/libDilib.a   ExplorGenerPhpProc.o
	$(TOUCH)

$(DILIB)/Date/ExplorTools.o:$(DILIB_IMPORT)/Explor/ExplorTools.c \
                               $(DILIB)/Date/Explor.include
		$(CC) $(DILIB_IMPORT)/Explor/ExplorTools.c   -I$(DILIB)/include            \
	      -c -o ExplorTools.o
	ar ruv  $(DILIB)/lib/libDilib.a   ExplorTools.o
	$(TOUCH)

$(DILIB)/Date/ExplorGenerTemplateTools.o:$(DILIB_IMPORT)/Explor/ExplorGenerTemplateTools.c \
                               $(DILIB)/Date/Explor.include               \
                               $(DILIB)/Date/MediaWiki.include               
		$(CC) $(DILIB_IMPORT)/Explor/ExplorGenerTemplateTools.c   -I$(DILIB)/include            \
	      -c -o ExplorGenerTemplateTools.o
	ar ruv  $(DILIB)/lib/libDilib.a   ExplorGenerTemplateTools.o
	$(TOUCH)

$(DILIB)/Date/ExplorDataShellTools.o:$(DILIB_IMPORT)/Explor/ExplorDataShellTools.c \
                               $(DILIB)/Date/Explor.include \
                              $(DILIB)/Date/WicriTools.o
		$(CC) $(DILIB_IMPORT)/Explor/ExplorDataShellTools.c   -I$(DILIB)/include            \
	      -c -o ExplorDataShellTools.o
	ar ruv  $(DILIB)/lib/libDilib.a   ExplorDataShellTools.o
	$(TOUCH)

#------------------------------------------------------------------
# binaries (or executables)
#

$(DILIB)/Date/Explor.bin: $(DILIB)/bin/ExplorParamFromWiki        \
                                   $(DILIB)/bin/ExplorGenerShell         \
                                   $(DILIB)/bin/ExplorGenerSite          \
                                   $(DILIB)/bin/ExplorGenerSiteShell     \
                                   $(DILIB)/bin/ExplorGenerSiteParam     \
                                   $(DILIB)/bin/ExplorGenerParamStep1    \
                                   $(DILIB)/bin/ExplorGenerParamStep2         \
                                   $(DILIB)/bin/ExplorGenerTemplateTop10           \
                                   $(DILIB)/bin/ExplorGenerTemplateSize            \
                                   $(DILIB)/bin/ExplorGenerTemplateInclude         \
                                   $(DILIB)/bin/ExplorMergeFromCheckpoint          \
                                   $(DILIB)/bin/ExplorMainExplorDataShells    \
                                   $(DILIB)/bin/ExplorMainExplorSiteHtmlPhp   \
                                   $(DILIB)/bin/ExplorMainExplorSiteShell     \
                                   $(DILIB)/bin/ExplorZoomDataShells          \
                                   $(DILIB)/bin/ExplorZoomSiteShell           \
                                   $(DILIB)/bin/ExplorZoomSiteHtmlPhp         \
                                   $(DILIB)/bin/ExplorExplorSiteShell         \
                                   $(DILIB)/bin/ExplorParamFromRowCol         \
                                   $(DILIB)/bin/ExplorParamFromWikiTable      \
                                   $(DILIB)/bin/ExplorCleanToTei              \
                                   $(DILIB)/bin/ExplorExtractContent          \
                                   $(DILIB)/bin/ExplorAreaUpdate              \
                                   $(DILIB)/bin/ExplorAreaRestart             \
                                   $(DILIB)/bin/ExplorAreaDataCreate          \
                                   $(DILIB)/bin/ExplorAreaDataUpdate          \
                                   $(DILIB)/bin/ExplorGenerAreaPages          \
                                   $(DILIB)/bin/ExplorParamDictFromWiki       \
                                   $(DILIB)/bin/ExplorMergeCuration           \
                                   $(DILIB)/bin/ExplorAddFullText             \
                                   $(DILIB)/bin/ExplorMergeExploration        \
                                   $(DILIB)/bin/ExplorAreaDataTrainingCreate  \
                                   $(DILIB)/bin/ExplorParamReplace            \
                                   $(DILIB)/bin/ExplorParamShellReplace     
	$(TOUCH)

$(DILIB)/bin/ExplorParamFromWiki: $(DILIB_IMPORT)/Explor/ExplorParamFromWiki.lex \
                $(DILIB)/Date/Buffer.lib
	$(LEX) $(DILIB_IMPORT)/Explor/ExplorParamFromWiki.lex
	$(CC) lex.yy.c -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -ll -o  $@

$(DILIB)/bin/ExplorGenerAreaPages:$(DILIB_IMPORT)/Explor/ExplorGenerAreaPages.c \
                          $(DILIB)/include/ExplorGenerPages.h                           \
                          $(DILIB)/Date/SxmlNode.lib                   \
                          $(DILIB)/Date/MediaWiki.lib                   \
                          $(DILIB)/Date/Explor.lib
	$(CC) $(DILIB_IMPORT)/Explor/ExplorGenerAreaPages.c -Wall -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/ExplorCleanToTei:$(DILIB_IMPORT)/Explor/ExplorCleanToTei.c \
                          $(DILIB)/Date/Buffer.lib
	$(CC) $(DILIB_IMPORT)/Explor/ExplorCleanToTei.c -Wall -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/ExplorMergeFromCheckpoint: $(DILIB_IMPORT)/Explor/ExplorMergeFromCheckpoint.c \
                         $(DILIB)/Date/Buffer.lib                      \
                         $(DILIB)/Date/Tei.lib                         \
                         $(DILIB°/Date/Utf8.lib                        \
                         $(DILIB)/Date/SxPath.lib
	$(CC) $(DILIB_IMPORT)/Explor/ExplorMergeFromCheckpoint.c -Wall -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/ExplorAddFullText: $(DILIB_IMPORT)/Explor/ExplorAddFullText.c \
                         $(DILIB)/Date/Buffer.lib                      \
                         $(DILIB)/Date/Tei.lib                         \
                         $(DILIB°/Date/Utf8.lib                        \
                         $(DILIB°/Date/Hfd.lib                        \
                         $(DILIB)/Date/SxPath.lib
	$(CC) $(DILIB_IMPORT)/Explor/ExplorAddFullText.c -Wall -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/ExplorExtractContent: $(DILIB_IMPORT)/Explor/ExplorExtractContent.c \
                         $(DILIB)/Date/Buffer.lib                      \
                         $(DILIB)/Date/Tei.lib                         \
                         $(DILIB°/Date/Utf8.lib                        \
                         $(DILIB°/Date/Hfd.lib                        \
                         $(DILIB)/Date/SxPath.lib
	$(CC) $(DILIB_IMPORT)/Explor/ExplorExtractContent.c -Wall -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/ExplorGenerTemplateTop10: $(DILIB_IMPORT)/Explor/ExplorGenerTemplateTop10.c \
                         $(DILIB)/Date/Buffer.lib                      \
                         $(DILIB°/Date/MediaWiki.lib                        \
                         $(DILIB°/Date/Explor.lib                        \
                         $(DILIB)/Date/SxPath.lib
	$(CC) $(DILIB_IMPORT)/Explor/ExplorGenerTemplateTop10.c -Wall -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@


$(DILIB)/bin/ExplorGenerTemplateSize: $(DILIB_IMPORT)/Explor/ExplorGenerTemplateSize.c \
                         $(DILIB)/Date/Buffer.lib                      \
                         $(DILIB)/Date/MediaWiki.lib                        \
                         $(DILIB)/Date/Explor.lib                        \
                         $(DILIB)/Date/Hfd.lib                        \
                         $(DILIB)/Date/SxPath.lib
	$(CC) $(DILIB_IMPORT)/Explor/ExplorGenerTemplateSize.c -Wall -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/ExplorGenerTemplateInclude: $(DILIB_IMPORT)/Explor/ExplorGenerTemplateInclude.c \
                         $(DILIB)/Date/Buffer.lib                      \
                         $(DILIB)/Date/MediaWiki.lib                        \
                         $(DILIB)/Date/Explor.lib                        \
                         $(DILIB)/Date/Hfd.lib                        \
                         $(DILIB)/Date/SxPath.lib
	$(CC) $(DILIB_IMPORT)/Explor/ExplorGenerTemplateInclude.c -Wall -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/ExplorMergeCuration: $(DILIB_IMPORT)/Explor/ExplorMergeCuration.c \
                         $(DILIB)/Date/Buffer.lib                      \
                         $(DILIB)/Date/Tei.lib                         \
                         $(DILIB)/Date/SxPath.lib
	$(CC) $(DILIB_IMPORT)/Explor/ExplorMergeCuration.c -Wall -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/ExplorMergeExploration: $(DILIB_IMPORT)/Explor/ExplorMergeExploration.c \
                         $(DILIB)/Date/Buffer.lib                      \
                         $(DILIB)/Date/Tei.lib                         \
                         $(DILIB)/Date/SxPath.lib
	$(CC) $(DILIB_IMPORT)/Explor/ExplorMergeExploration.c -Wall -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/ExplorParamFromRowCol: $(DILIB_IMPORT)/Explor/ExplorParamFromRowCol.c \
                                    $(DILIB)/Date/MediaWiki.lib    \
                         $(DILIB)/Date/SxPath.lib
	$(CC) $(DILIB_IMPORT)/Explor/ExplorParamFromRowCol.c -Wall -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@



$(DILIB)/bin/ExplorMainExplorDataShells: $(DILIB_IMPORT)/Explor/ExplorMainExplorDataShells.c \
                         $(DILIB)/Date/Buffer.lib                      \
                         $(DILIB)/Date/SxPath.lib                     \
                          $(DILIB)/Date/Explor.lib
	$(CC) $(DILIB_IMPORT)/Explor/ExplorMainExplorDataShells.c -Wall -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/ExplorZoomDataShells: $(DILIB_IMPORT)/Explor/ExplorZoomDataShells.c \
                         $(DILIB)/Date/Buffer.lib                      \
                         $(DILIB)/Date/SxPath.lib                     \
                          $(DILIB)/Date/Explor.lib
	$(CC) $(DILIB_IMPORT)/Explor/ExplorZoomDataShells.c -Wall -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/ExplorGenerShell: $(DILIB_IMPORT)/Explor/ExplorGenerShell.c \
                      $(DILIB)/Date/Buffer.o \
                      $(DILIB)/Date/StrSearch.o \
                      $(DILIB)/include/Explor.h \
                      $(DILIB)/Date/Explor.lib \
                      $(DILIB)/Date/SxmlNode.lib
	$(CC) $(DILIB_IMPORT)/Explor/ExplorGenerShell.c -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/ExplorGenerSiteShell: $(DILIB_IMPORT)/Explor/ExplorGenerSiteShell.c \
                      $(DILIB)/Date/Buffer.o \
                      $(DILIB)/Date/StrSearch.o \
                      $(DILIB)/include/Explor.h \
                      $(DILIB)/Date/Explor.lib \
                      $(DILIB)/Date/SxmlNode.lib
	$(CC) $(DILIB_IMPORT)/Explor/ExplorGenerSiteShell.c -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/ExplorExplorSiteShell: $(DILIB_IMPORT)/Explor/ExplorExplorSiteShell.c \
                            $(DILIB)/Date/StrSearch.lib   \
                            $(DILIB)/Date/Explor.lib
	$(CC)  $(DILIB_IMPORT)/Explor/ExplorExplorSiteShell.c   -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/ExplorZoomSiteShell: $(DILIB_IMPORT)/Explor/ExplorZoomSiteShell.c \
                            $(DILIB)/Date/StrSearch.lib   \
                            $(DILIB)/Date/Explor.lib
	$(CC)  $(DILIB_IMPORT)/Explor/ExplorZoomSiteShell.c   -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/ExplorZoomSiteHtmlPhp: $(DILIB_IMPORT)/Explor/ExplorZoomSiteHtmlPhp.c \
                            $(DILIB)/Date/StrSearch.lib   \
                            $(DILIB)/Date/Explor.lib
	$(CC)  $(DILIB_IMPORT)/Explor/ExplorZoomSiteHtmlPhp.c   -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/ExplorGenerSite: $(DILIB_IMPORT)/Explor/ExplorGenerSite.c \
                      $(DILIB)/Date/Buffer.o \
                      $(DILIB)/Date/StrSearch.o \
                      $(DILIB)/include/Explor.h \
                      $(DILIB)/Date/Explor.lib \
                      $(DILIB)/Date/SxmlNode.lib
	$(CC) $(DILIB_IMPORT)/Explor/ExplorGenerSite.c -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/ExplorGenerSiteParam: $(DILIB_IMPORT)/Explor/ExplorGenerSiteParam.c \
                      $(DILIB)/Date/Buffer.o \
                      $(DILIB)/Date/StrSearch.o \
                      $(DILIB)/include/Explor.h \
                      $(DILIB)/Date/Explor.lib \
                      $(DILIB)/Date/SxmlNode.lib
	$(CC) $(DILIB_IMPORT)/Explor/ExplorGenerSiteParam.c -Wall -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/ExplorGenerParamStep1: $(DILIB_IMPORT)/Explor/ExplorGenerParamStep1.c \
                      $(DILIB)/Date/Buffer.o \
                      $(DILIB)/Date/StrSearch.o \
                      $(DILIB)/include/Explor.h \
                      $(DILIB)/Date/Explor.lib \
                      $(DILIB)/Date/SxmlNode.lib
	$(CC) $(DILIB_IMPORT)/Explor/ExplorGenerParamStep1.c -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/ExplorGenerParamStep2: $(DILIB_IMPORT)/Explor/ExplorGenerParamStep2.c \
                      $(DILIB)/Date/Buffer.o \
                      $(DILIB)/Date/StrSearch.o \
                      $(DILIB)/include/Explor.h \
                      $(DILIB)/Date/Explor.lib \
                      $(DILIB)/Date/SxmlNode.lib
	$(CC) $(DILIB_IMPORT)/Explor/ExplorGenerParamStep2.c -Wall -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/ExplorMainExplorSiteHtmlPhp: $(DILIB_IMPORT)/Explor/ExplorMainExplorSiteHtmlPhp.c \
                            $(DILIB)/Date/StrSearch.lib   \
                            $(DILIB)/Date/Explor.lib
	$(CC)  $(DILIB_IMPORT)/Explor/ExplorMainExplorSiteHtmlPhp.c   -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/ExplorMainExplorSiteShell: $(DILIB_IMPORT)/Explor/ExplorMainExplorSiteShell.c \
                            $(DILIB)/Date/StrSearch.lib   \
                            $(DILIB)/Date/Explor.lib
	$(CC)  $(DILIB_IMPORT)/Explor/ExplorMainExplorSiteShell.c   -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/ExplorParamDictFromWiki: $(DILIB_IMPORT)/Explor/ExplorParamDictFromWiki \
                                      $(DILIB)/bin/MediaWikiTable2SxmlRowCol   \
                                      $(DILIB)/bin/MediaWikiCleanTable   \
                                      $(DILIB)/bin/ExplorParamFromRowCol
	$(MAKE_SHELL)  $(DILIB_IMPORT)/Explor/ExplorParamDictFromWiki $@

$(DILIB)/bin/ExplorParamReplace:$(DILIB_IMPORT)/Explor/ExplorParamReplace
	$(MAKE_SHELL)  $(DILIB_IMPORT)/Explor/ExplorParamReplace $@

$(DILIB)/bin/ExplorParamShellReplace:$(DILIB_IMPORT)/Explor/ExplorParamShellReplace.lex
	$(LEX) $(DILIB_IMPORT)/Explor/ExplorParamShellReplace.lex
	$(CC) lex.yy.c -ll -o  $@

$(DILIB)/bin/ExplorAreaUpdate: $(DILIB_IMPORT)/Explor/ExplorAreaUpdate \
                               $(DILIB)/bin/ExplorGenerShell
	$(MAKE_SHELL) $(DILIB_IMPORT)/Explor/ExplorAreaUpdate $@

$(DILIB)/bin/ExplorAreaRestart: $(DILIB_IMPORT)/Explor/ExplorAreaRestart \
                               $(DILIB)/bin/ExplorGenerShell
	$(MAKE_SHELL) $(DILIB_IMPORT)/Explor/ExplorAreaRestart $@

$(DILIB)/bin/ExplorAreaDataCreate: $(DILIB_IMPORT)/Explor/ExplorAreaDataCreate \
                               $(DILIB)/bin/ExplorGenerShell    \
                              $(DILIB)/bin/ExplorParamDictFromWiki
	$(MAKE_SHELL) $(DILIB_IMPORT)/Explor/ExplorAreaDataCreate $@

$(DILIB)/bin/ExplorAreaDataUpdate: $(DILIB_IMPORT)/Explor/ExplorAreaDataUpdate \
                               $(DILIB)/bin/ExplorGenerShell    \
                              $(DILIB)/bin/ExplorParamFromRowCol
	$(MAKE_SHELL) $(DILIB_IMPORT)/Explor/ExplorAreaDataUpdate $@


$(DILIB)/bin/ExplorAreaDataTrainingCreate: $(DILIB_IMPORT)/Explor/ExplorAreaDataTrainingCreate \
                               $(DILIB)/bin/ExplorGenerShell    \
                              $(DILIB)/bin/ExplorParamFromRowCol
	$(MAKE_SHELL) $(DILIB_IMPORT)/Explor/ExplorAreaDataTrainingCreate $@

$(DILIB)/bin/ExplorParamFromWikiTable: $(DILIB_IMPORT)/Explor/ExplorParamFromWikiTable \
                              $(DILIB)/bin/ExplorParamFromRowCol                      
	$(MAKE_SHELL) $(DILIB_IMPORT)/Explor/ExplorParamFromWikiTable  $@


#-------------------------------------------- End Explor.mk ----------------------------
