<?php

function ExplorGetParamTable($paramFilePath)
{
  if (file_exists($paramFilePath))
    {
      $paramFile=file($paramFilePath);
      $i=0;
      while ($i < count($paramFile))
        {
          $posTab=strpos($paramFile[$i], "\t");
          $key= substr($paramFile[$i], 0, $posTab);
          $val=rtrim(substr($paramFile[$i],$posTab+1),"\n");
          $paramTable[$key]=$val;
          $i++;
        }
      return $paramTable;
    }
  else
    {
      echo "**** file ". $paramFilePath." not founded";
      return NULL;
    }
}

function ExplorGetDomAreaTree(&$paramTable)
{
  $strTree=$paramTable["Area/areaTree"];
  $domTree= new DomDocument();
  $domTree->loadXml("<?xml version=\"1.0\" encoding=\"UTF-8\" ?>".$strTree);
  return $domTree;
}

function  ExplorAreaTreeGetNodeFromIndex(&$domTree, $stream, $step, $index)
{
  $indexPath=new DOMXPath($domTree);
  $query='site/lang[@code="fr"]/stream[@code="'.$stream.'"]/step[@code="'.$step.'"]/index[@code="'.$index.'"]';
  /* echo $domTree->saveXML(); */
  $listNode=$indexPath->query($query, $domTree->documentElement);
  return $listNode->item(0);
}

function ExplorTreeNodeGetName($treeNode)
{
  if (!$treeNode) return NULL;
  if ($n=$treeNode->getAttribute("name"))return $n;
  if ($n=$treeNode->getAttribute("shortName"))return $n;
  return $treeNode->getAttribute("code");
}

function ExplorTreeNodeGetShortName($treeNode)
{
  if (!$treeNode) return NULL;
  if ($n=$treeNode->getAttribute("shortName"))return $n;
  if ($n=$treeNode->getAttribute("name"))return $n;
  return $treeNode->getAttribute("code");
}

   function ExplorGetIndexName(&$paramTable,$indexCode)
   {
     $key="Index/".$indexCode."/name";
     if ($val=$paramTable[$key]) return $val;
     else return $indexCode;
     return $indexCode;
   }

function ExplorGetParam(&$paramTable, $key)
{
  if (isset($paramTable[$key]))return ($paramTable[$key]);
  else return NULL;
}

function ExplorPrintParamTable(&$paramTable)
{reset($paramTable);
  for ($i = 0; $i < count($paramTable); $i++)
    {
      $index = key($paramTable);
      echo $index."   [". $paramTable[$index]."]<br/>\n";
      next($paramTable);
    }
}


function ExplorGetParamK2(&$paramTable, $k1, $k2)
{
  return ExplorGetParam($paramTable, $k1."/".$k2);
}

function ExplorGetParamK3(&$paramTable, $k1, $k2, $k3)
{
  $key=$k1."/".$k2."/".$k3;
  if (isset($paramTable[$key])) return $paramTable[$key];
  return ExplorGetParamK2($paramTable, $k1, $k3);
}

function ExplorGetParamK4(&$paramTable, $k1, $k2, $k3, $k4)
{
  $key=$k1."/".$k2."/".$k3."/".$k4;
  if ( isset($paramTable[$key]))return ($paramTable[$key]);
  return ExplorGetParamK3($paramTable, $k1, $k2,$k4);
}

function ExplorGetParamK5(&$paramTable, $k1, $k2, $k3, $k4,$k5)
{
  $key=$k1."/".$k2."/".$k3."/".$k4."/".$k5;
  if ( isset($paramTable[$key]))return ($paramTable[$key]);
  return ExplorGetParamK4($paramTable, $k1, $k2,$k3, $k5);
}

function ExplorGetBiblioFromHfdKey(&$paramTable, $stream, $step,  $hfdKey)
{
  $hfdRoot="Data/".$stream."/".$step."/biblio";
  $domDocument=HfdGetXmlDomFromNumKey($paramTable,  $hfdRoot, $hfdKey);
  return ($domDocument);
}
function ExplorGetRepositoryBiblioFromHfdKey(&$paramTable, $stream, $step,  $hfdKey)
{
  $hfdRoot="Data/".$stream."/".$step."/repository";
  $domDocument=HfdRepositoryGetXmlDomFromNumKey($paramTable,  $hfdRoot, $hfdKey);
  return ($domDocument);
}

function ExplorTestHasNoCountry(&$paramTable,&$domRecord, $TEI, $stream, $step)
{
  $noCountryPath= new DOMXPath($domRecord);
  $query="teiHeader/fileDesc/sourceDesc/biblStruct/analytic/author/affiliation/wicri:noCountry";
  $noCountryList=$noCountryPath->query($query,$TEI);
  if ( $noCountryList->length > 0) return  $noCountryList;
  else return NULL;
}

function   ExplorPrintIndexAccess($index)
{
  if (strcmp($index, "AutAff.i")==0)
    {
      echo "<form action=\"AutAff.php\" method=\"get\"><p>\n";
    }
  else
    {
      echo "<form action=\"indexItem.php\" method=\"get\"><p>\n";
    }
  echo "Pour accéder à une entrée : ";
  echo "<input type=\"hidden\" name=\"index\" value=\"".$index."\">";
  echo "<input type=\"text\" name=\"key\" size=\"50\"/>";
  echo "<input type=\"submit\" value=\"Envoyer\" /></p>";
  echo "</form>\n";
}

function  ExplorPrintNoCountryList($list)
{
  foreach ($list as $item)
    {
      $affiliation=$item->parentNode;
      $author=$affiliation->parentNode;
      echo $author->firstChild->nodeValue;
      echo "\n";
      SxmlNodePrintIndent($affiliation);
    }
}

function ExplorPrintAuthorsCountry(&$paramTable,&$domRecord, $TEI, $stream, $step, $page)
{
  $authorsPath= new DOMXPath($domRecord);
  /* $query="teiHeader/fileDesc/titleStmt/author"; */
  $query="teiHeader/fileDesc/sourceDesc/biblStruct/analytic/author";
  $authorPhpProc=ExplorGetParamK5($paramTable, "Area", $stream, $step, $page, "pageIndexPerson");
  $countryPhpProc=ExplorGetParamK5($paramTable, "Area", $stream, $step, $page, "pageIndexCountry");
  if ($listAuthors=$authorsPath->query($query,$TEI))
    {
      $i=0;
      foreach ($listAuthors as $author)
        {
          if ($i++ > 0)echo " ; ";
          $name=SxmlNodeGetFirstChildByTagName($author, "name");

	  echo '<a href="'.$authorPhpProc.'&key=' . $name->nodeValue.' ">';
	  echo $name->nodeValue;
	  echo "</a>";
	    
          $countryPath=new DOMXPath($domRecord);
          $query="affiliation/country";
          if($lcountry=$countryPath->query($query,$author))
            {
	      $luniq=array();
	      foreach ($lcountry as $country) $luniq[$country->nodeValue]=$country->nodeValue;
	      $j=0;
              foreach ($luniq as $country)
                {
		  if ($j==0) echo " [";
                  if ($j++ > 0)echo ", ";
		  echo '<a href="'.$countryPhpProc.'&key=' . $country.' ">';
		  echo $country;
		  echo "</a>";
                }
       		  if ($j>0)        echo "]";
	      /*
              $j=0;
              foreach ($lcountry as $country)
                {
		  if ($j==0) echo " (";
                  if ($j++ > 0)echo ", ";
		  echo '<a href="'.$countryPhpProc.'&key=' . $country->nodeValue.' ">';
		  echo $country->nodeValue;
		  echo "</a>";
                }
       		  if ($j>0)        echo ")";
	      */
            }
        }
    }
}

function ExplorPrintCurationLinks(&$paramTable,  $stream, $step, $page, &$domRecord)
        {
          $idnoPath = new DOMXPath($domRecord);
           echo "<ul>\n";
          $query="TEI/teiHeader/fileDesc/publicationStmt/idno";
          foreach ($idnoPath->query($query, $domRecord->documentElement) as $idno)
            {
              $type= $idno->getAttribute("type");
              if (substr($type,0,11)=="wicri:Area/")
		{
		  echo "<!-- type :".$type." -->";
		  echo "<!-- built type :"."wicri:Area/".$stream."/".$step." -->";
		  if ($type=="wicri:Area/".$stream."/".$step)continue;
		  $beginLinkedStream=substr($type,11);
		  $linkedStep=substr(strstr($beginLinkedStream,"/"),1);
		  $linkedStream=substr($beginLinkedStream,0 ,strlen($beginLinkedStream)-strlen($linkedStep)-1);
		  echo "<!-- beginLinkedStream :".$beginLinkedStream." -->";
		  echo "<li>";
		  echo "to stream ". $linkedStream.", ";
		  echo "to step ". $linkedStep.": ";
                  echo ExplorGetParamK5($paramTable, "Area", $stream, $step, $page, "messLinkTo".$step);
		  /* echo "<li> Dans l'espace corpus :*/ 
                  echo "<a href=".'"../../'.substr($type,11).'/bibRecord.php?hk='.$idno->nodeValue.'">'.$idno->nodeValue."</a></li>\n";
		}
            }

          echo "</ul>";
	}

function ExplorPrintAutAff(&$paramTable, &$domRecord, $stream, $step, $page)
{
  $g1=$domRecord->documentElement;
  $k1=SxmlNodeGetFirstChildByTagName($g1,"k");
  $f1=SxmlNodeGetFirstChildByTagName($g1,"f");
  $t1=SxmlNodeGetFirstChildByTagName($g1,"t");
  echo "<p><ul><li><b>Author's uniq id: </b>".$k1->nodeValue."</li>";
  echo "<li>Total number of names: ".$f1->nodeValue."</li>";
  echo "<li>Total number of records with affiliations: ".$t1->nodeValue."</li>";
  echo "</ul></p>";
  $l1=SxmlNodeGetFirstChildByTagName($g1,"l");
  echo "<table style=\"border: thin solid #6495ed;\">";
  foreach ($l1->childNodes as $g2)
    {
      echo "<tr style=\"border: thin solid #6495ed;\">";
      $k2=SxmlNodeGetFirstChildByTagName($g2,"k");
      echo "<th  style=\"border: thin solid #6495ed;\">".$k2->nodeValue."</th>";
      $l2=SxmlNodeGetFirstChildByTagName($g2,"l");
      echo "<td  style=\"border: thin solid #6495ed;\">";
      echo "<table style=\"border: thin solid #6495ed;\">";
      foreach ($l2->childNodes as $g3)
	{
	  $k3=SxmlNodeGetFirstChildByTagName($g3,"k");
	  echo "<tr style=\"border: thin solid #6495ed;\">";
	  echo "<td  style=\"border: thin solid #6495ed;\">";
	  foreach ($k3->childNodes as $ff)
	    {

	       foreach ($ff->childNodes as $ff1) 
		 {
		   if($ff1->nodeName!="sZ") 
		     {echo $ff1->nodeValue;
		       echo "<br/>";
		     }
		 }
	    }
	  echo "</td>";
	  $l3=SxmlNodeGetFirstChildByTagName($g3,"l");
	  echo "<td  style=\"border: thin solid #6495ed;\">";
	  foreach ($l3->childNodes as $e3)
	    {
	      echo '<a href="'."bibRecord.php?hk=".$e3->nodeValue.'">';
	      echo $e3->nodeValue;
	      echo "</a>";
	      echo "<br/>";
	    }
	  echo "</td>";
	  echo "</tr>";
	}
      echo "</table>";
      echo "</td>";
      echo "</tr>";
    }
  echo "</table>";
  echo "<hr/>\n";
}


?>
