/*   -*- coding: utf-8 -*-  */

/**********************************************************************
*
*  module   : Explor
*  fichier  : ExplorGenerPages.h
*
***********************************************************************/

#ifndef _DILIB_EXPLOR_GENER_PAGES_H
#define _DILIB_EXPLOR_GENER_PAGES_H

#include <stdio.h>     /* for printf */
#include <stdlib.h>    /* for exit */

#include "DilibKernel.h"
#include "Except.h"
#include "SxmlNode.h"
#include "StrDict.h"

extern char    *ExplorGenerAreaTitle;
extern char    *ExplorGenerAreaPath;
extern char    *ExplorGenerPagesAreaCode;
extern char    *ExplorGenerPagesIstexQuery;
extern char    *ExplorGenerPagesGenericCode;
extern char    *ExplorGenerPagesWikiCode;
extern char    *ExplorGenerPagesWikiLink;
extern int      ExplorGenerPagesNumberOfStreams;
extern char    *ExplorGenerPagesWebSite;

extern int      ExplorGenerPagesNumberOfDownloads;
extern int      ExplorGenerPagesDownloadSize;

extern StrDict  *ExplorGenerPagesParamFile;
extern StrDict  *ExplorGenerPagesUrlLogos;
extern int       ExplorGenerPagesMapOption;
extern Buffer   *ExplorGenerPagesBufTime;
extern SxmlNode *ExplorGenerPagesListStreams;
extern SxmlNode *ExplorGenerPagesStreamPmc;
extern SxmlNode *ExplorGenerPagesStreamNcbi;
extern SxmlNode *ExplorGenerPagesStreamPubMed;
extern SxmlNode *ExplorGenerPagesStreamStanalyst;
extern char     *ExplorGenerPagesStreamStanalystName;
extern SxmlNode *ExplorGenerPagesStreamHal;
extern SxmlNode *ExplorGenerPagesStreamHalInra;
extern int       ExplorGenerNumberOfZooms;
extern SxmlNode *ExplorGenerPagesListZooms;
extern int       ExplorGenerPagesHasZoomFrance;
extern int       ExplorGenerPagesExecCode;

void ExplorGenerPagesInit();

void ExplorGenerPagesWikiMain();
void ExplorGenerPagesWikiMainEnd();

void ExplorGenerPagesWikiTechCompilArea();
void ExplorGenerPagesGenerFtp(int import);
void ExplorGenerPagesTargetInit();
void  ExplorGenerPagesTargetInstall();

void ExplorGenerPagesWikiTechBegin();
void ExplorGenerPagesPrintDefExplorArea();
void ExplorGenerPagesInitDirTree(int code); /* 0 : dev 1 : LorExplor/Istex */
void ExplorGenerPagesWikiDiscussionBegin();
void ExplorGenerPagesWikiDiscussionIndexCuration();
void ExplorGenerPagesWikiDataBegin();
void ExplorGenerPagesWikiDataEnd();
void ExplorGenerPagesPrintGetParGener();
void ExplorGenerPagesPrintGetParNavi();
void ExplorGenerPagesWikiNaviBegin();
void ExplorGenerPagesWikiNaviEnd();
void ExplorGenerPagesMap();
void ExplorGenerCorpus();
void ExplorGenerPagesBeginNavi();
void ExplorGenerPagesWikiTemplateSize();
void ExplorGenerGener(int isIstex);
void ExplorGenerPagesWikiTemplateInclude();

SxmlNode *ExplorGenerPagesParamStream(char *param);
SxmlNode *ExplorGenerPagesParamZoom(char *param);
char     *ExplorGenerGetBandeauCode(SxmlNode *stream, char*type, char *monoMulti);

void ExplorGenerNaviZooms();
void ExplorGenerStreamBrowsing(int rank, SxmlNode *streamNode);

void ExplorGenerPagesGenerListTypesZoom();
void ExplorGenerPagesGenerListZooms();

#endif /* _DILIB_EXPLOR_GENER_PAGES_H */

