/*   -*- coding: utf-8 -*-  */

/*
           ExplorMergeFromCheckpoint.c

 */

#include <stdio.h>     /* for printf */
#include <stdlib.h>    /* for exit */
#include <getopt.h>
#include "SxPath.h"
#include "Buffer.h"
#include "TeiHandler.h"

SxmlNode *docInput;
SxmlNode *teiRoot;


void cleanRecord()
{
  SxmlNode *oldRec;
  oldRec=SxmlNextSibling(teiRoot);
  if (oldRec)
    {
      SxmlRemoveChild(oldRec);
      SxmlFree(oldRec);
    }
}

int main()
{

  while ((docInput=SxmlInputNextDocumentElement()))
    {
      if(SxmlNodeHasName(docInput,"record"))
	{
	  SxmlNode *publicationStmt;

	  teiRoot=SxmlGetFirstChildByTagName(docInput,"TEI");
	  cleanRecord();

	  publicationStmt=TeiFindPublicationStmt(teiRoot);
	  
	}
      SxmlPrint(docInput);putchar('\n');
    }
  exit (EXIT_SUCCESS);
}
