

#   Module  : Getty
#   Fichier : Getty.mk
#

include  $(DILIB)/MakeDef.mk

$(DILIB)/Date/Getty.mod:  $(DILIB)/Date/Getty.data \
                                 $(DILIB)/Date/Getty.bin
	$(TOUCH)

#----------------------------------------------------------------
# bin
#
$(DILIB)/Date/Getty.bin::$(DILIB)/bin/GettyBhaExplorDataShells \
                                $(DILIB)/bin/GettyBhaExplorSiteShells \
                                $(DILIB)/bin/GettyExplorSiteShells
	$(TOUCH)

$(DILIB)/bin/GettyBhaExplorDataShells: $(DILIB_IMPORT)/Getty/GettyBhaExplorDataShells.c \
                            $(DILIB)/Date/StrSearch.lib   \
                            $(DILIB)/Date/Explor.lib
	$(CC)  $(DILIB_IMPORT)/Getty/GettyBhaExplorDataShells.c  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/GettyBhaExplorSiteShells: $(DILIB_IMPORT)/Getty/GettyBhaExplorSiteShells.c \
                            $(DILIB)/Date/StrSearch.lib   \
                            $(DILIB)/Date/Explor.lib
	$(CC)  $(DILIB_IMPORT)/Getty/GettyBhaExplorSiteShells.c  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/GettyExplorSiteShells: $(DILIB_IMPORT)/Getty/GettyExplorSiteShells.c \
                            $(DILIB)/Date/StrSearch.lib   \
                            $(DILIB)/Date/Explor.lib
	$(CC)  $(DILIB_IMPORT)/Getty/GettyExplorSiteShells.c  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

#----------------------------------------------------------------
# data
#
$(DILIB)/Date/Getty.data:$(DILIB)/data/Getty/ExplorParam.data.tab   \
                                $(DILIB)/data/Getty/ExplorParam.en.tab   \
                                $(DILIB)/data/icons/LogoBhaGetty.png
	$(TOUCH)

$(DILIB)/data/Getty/ExplorParam.data.tab: $(DILIB_IMPORT)/Getty/Data/GettyExplorParam.data.wiki \
                                      $(DILIB)/bin/ExplorParamFromWiki
	ExplorParamFromWiki < $(DILIB_IMPORT)/Getty/Data/GettyExplorParam.data.wiki > $@

$(DILIB)/data/Getty/ExplorParam.en.tab: $(DILIB_IMPORT)/Getty/Data/GettyExplorParam.en.wiki \
                                      $(DILIB)/bin/ExplorParamFromWiki
	ExplorParamFromWiki < $(DILIB_IMPORT)/Getty/Data/GettyExplorParam.en.wiki > $@

$(DILIB)/data/icons/LogoBhaGetty.png:$(DILIB_IMPORT)/Getty/Data/LogoBhaGetty.png
	cp $(DILIB_IMPORT)/Getty/Data/LogoBhaGetty.png $@

#--------------------------- End Getty.mk ---------------------------
