#
#   Module  : Hfd
#   Fichier : DamHfd.mk
#

include $(DILIB)/MakeDef.mk

$(DILIB)/Date/Hfd.mod: $(DILIB)/Date/DamHfd.bin \
                           $(DILIB)/Date/DamHfd.include \
                           $(DILIB)/Date/DamHfd.man \
                           $(DILIB)/Date/Hfd.php       \
                           $(DILIB)/Date/Hfd.include    \
                           $(DILIB)/Date/Hfd.lib        \
                           $(DILIB)/Date/Hfd.bin        \
                           $(DILIB)/Date/Hfd.man        \
                           $(DILIB)/Date/DamHfd.lib
	$(TOUCH)

#----------------------------------------------------------------
# Les Fichiers include
#
$(DILIB)/Date/Hfd.include: $(DILIB)/include/Hcs.h                \
                                  $(DILIB)/include/HfdHcb.h      \
                                  $(DILIB)/include/HfdRecord.h   \
                                  $(DILIB)/include/HfdIndex.h    \
                                  $(DILIB)/include/HfdBase.h     \
                                  $(DILIB)/include/HfdIterator.h \
                                  $(DILIB)/include/Hfd.h
	$(TOUCH)

$(DILIB)/include/Hcs.h: $(DILIB_IMPORT)/Hfd/Hcs.h \
                        $(DILIB)/include/SxmlNode.h
	cp $(DILIB_IMPORT)/Hfd/Hcs.h  $@

$(DILIB)/include/HfdRecord.h: $(DILIB_IMPORT)/Hfd/HfdRecord.h \
                        $(DILIB)/include/SxmlNode.h
	cp $(DILIB_IMPORT)/Hfd/HfdRecord.h  $@

$(DILIB)/include/Hfd.h: $(DILIB_IMPORT)/Hfd/Hfd.h      \
                        $(DILIB)/include/HfdHcb.h      \
                        $(DILIB)/include/HfdIterator.h
	cp $(DILIB_IMPORT)/Hfd/Hfd.h  $@

$(DILIB)/include/HfdIndex.h: $(DILIB_IMPORT)/Hfd/HfdIndex.h \
                             $(DILIB)/include/Hfd.h        \
                             $(DILIB)/include/SxmlNode.h
	cp $(DILIB_IMPORT)/Hfd/HfdIndex.h  $@

$(DILIB)/include/HfdBase.h: $(DILIB_IMPORT)/Hfd/HfdBase.h \
                             $(DILIB)/include/HfdIndex.h    
	cp $(DILIB_IMPORT)/Hfd/HfdBase.h  $@

$(DILIB)/include/HfdHcb.h: $(DILIB_IMPORT)/Hfd/HfdHcb.h \
                        $(DILIB)/include/StrDict.h      \
                        $(DILIB)/include/HfdRecord.h      \
                        $(DILIB)/include/SxmlNode.h
	cp $(DILIB_IMPORT)/Hfd/HfdHcb.h  $@

$(DILIB)/include/HfdIterator.h: $(DILIB_IMPORT)/Hfd/HfdIterator.h \
                                $(DILIB)/include/HfdHcb.h
	cp $(DILIB_IMPORT)/Hfd/HfdIterator.h  $@

$(DILIB)/Date/DamHfd.include: $(DILIB)/include/DamHfd.h \
                                      $(DILIB)/include/Dam.h \
                                      $(DILIB)/include/DamTool.h \
                                     $(DILIB)/include/DamHCB.h
	$(TOUCH)

$(DILIB)/include/DamHfd.h: $(DILIB_IMPORT)/Hfd/DamHfd.h  \
                           $(DILIB)/include/DamHCB.h
	cp $(DILIB_IMPORT)/Hfd/DamHfd.h $@

$(DILIB)/include/Dam.h: $(DILIB_IMPORT)/Hfd/Dam.h  \
                           $(DILIB)/include/DamHCB.h
	cp $(DILIB_IMPORT)/Hfd/Dam.h $@

$(DILIB)/include/DamHCB.h: $(DILIB_IMPORT)/Hfd/DamHCB.h \
                       $(DILIB)/Date/SgmlNode.include
	cp $(DILIB_IMPORT)/Hfd/DamHCB.h $@

$(DILIB)/include/DamTool.h: $(DILIB_IMPORT)/Hfd/DamTool.h
	cp $(DILIB_IMPORT)/Hfd/DamTool.h $@


#------------------------------------------------------------------
# Les binaires
#

$(DILIB)/Date/Hfd.bin: $(DILIB)/bin/HcsSxmlRecordPutKey \
                              $(DILIB)/bin/HfdSxmlRecordPutKey \
                              $(DILIB)/bin/HfdCat              \
                              $(DILIB)/bin/HfdBuild            \
                              $(DILIB)/bin/HfdSelect           \
                              $(DILIB)/bin/HfdIndexSelect      \
                              $(DILIB)/bin/HfdIndexBuildRec    \
                              $(DILIB)/bin/HfdIndexBuildHid    \
                              $(DILIB)/bin/HfdBaseAnd          \
                              $(DILIB)/bin/HfdBaseOr           \
                              $(DILIB)/bin/HfdBaseQuery        \
                              $(DILIB)/bin/HfdGetPath
	$(TOUCH)



$(DILIB)/bin/HcsSxmlRecordPutKey: $(DILIB_IMPORT)/Hfd/HcsSxmlRecordPutKey.c \
                                  $(DILIB)/Date/Hfd.lib              \
                                  $(DILIB)/Date/SxmlNode.lib
	$(CC) $(DILIB_IMPORT)/Hfd/HcsSxmlRecordPutKey.c      -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/HfdSxmlRecordPutKey: $(DILIB_IMPORT)/Hfd/HfdSxmlRecordPutKey.c \
                                  $(DILIB)/Date/Hfd.lib              \
                                  $(DILIB)/Date/SxmlNode.lib
	$(CC) $(DILIB_IMPORT)/Hfd/HfdSxmlRecordPutKey.c  -Wall    -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/HfdCat:$(DILIB_IMPORT)/Hfd/HfdCat.c  \
                     $(DILIB)/Date/Hfd.lib
	$(CC) -O  $(DILIB_IMPORT)/Hfd/HfdCat.c   -I$(DILIB)/include -Wall \
	                         $(DILIB)/lib/libDilib.a -o $@ 

$(DILIB)/bin/HfdIndexBuildRec: $(DILIB_IMPORT)/Hfd/HfdIndexBuildRec.c  \
                        $(DILIB)/Date/SxmlNode.lib
	$(CC)  $(DILIB_IMPORT)/Hfd/HfdIndexBuildRec.c   -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/HfdBuild: $(DILIB_IMPORT)/Hfd/HfdBuild.c $(DILIB)/Date/Hfd.lib
	$(CC) $(DILIB_IMPORT)/Hfd/HfdBuild.c  -Wall    -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@  

$(DILIB)/bin/HfdIndexBuildHid: $(DILIB_IMPORT)/Hfd/HfdIndexBuildHid.c  \
                       $(DILIB)/Date/Hfd.lib \
                        $(DILIB)/Date/SxPath.lib
	$(CC)  $(DILIB_IMPORT)/Hfd/HfdIndexBuildHid.c -Wall   -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/HfdBaseAnd: $(DILIB_IMPORT)/Hfd/HfdBaseAnd.c  \
                        $(DILIB)/Date/Hfd.lib              \
                        $(DILIB)/Date/SxPath.lib
	$(CC)  $(DILIB_IMPORT)/Hfd/HfdBaseAnd.c -Wall  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/HfdBaseOr: $(DILIB_IMPORT)/Hfd/HfdBaseOr.c  \
                        $(DILIB)/Date/Hfd.lib              \
                        $(DILIB)/Date/SxPath.lib
	$(CC)  $(DILIB_IMPORT)/Hfd/HfdBaseOr.c -Wall  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/HfdBaseQuery: $(DILIB_IMPORT)/Hfd/HfdBaseQuery.c  \
                        $(DILIB)/Date/Hfd.lib              \
                        $(DILIB)/Date/SxPath.lib
	$(CC)  $(DILIB_IMPORT)/Hfd/HfdBaseQuery.c -Wall  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@


$(DILIB)/bin/HfdSelect:$(DILIB_IMPORT)/Hfd/HfdSelect.c  \
                     $(DILIB)/Date/Hfd.lib       \
                     $(DILIB)/Date/SxmlNode.lib
	$(CC)  $(DILIB_IMPORT)/Hfd/HfdSelect.c   -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@ 

$(DILIB)/bin/HfdIndexSelect:$(DILIB_IMPORT)/Hfd/HfdIndexSelect.c  \
                     $(DILIB)/Date/Hfd.lib       \
                     $(DILIB)/Date/SxPath.lib
	$(CC)  $(DILIB_IMPORT)/Hfd/HfdIndexSelect.c  -Wall -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@ 

$(DILIB)/Date/DamHfd.bin:  $(DILIB)/bin/DamHfdBuild    \
                           $(DILIB)/bin/DamHfdSelect   \
                           $(DILIB)/bin/HfdStoreFile
	$(TOUCH)

$(DILIB)/bin/DamHfdBuild: $(DILIB_IMPORT)/Hfd/DamHfdBuild.c $(DILIB)/Date/DamHfd.lib
	$(CC) $(DILIB_IMPORT)/Hfd/DamHfdBuild.c      -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@  

#$(DILIB)/bin/DamGetPath: $(DILIB_IMPORT)/Hfd/DamGetPath.c $(DILIB)/Date/DamHfd.lib
#	$(CC) $(DILIB_IMPORT)/Hfd/DamGetPath.c      -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@  

$(DILIB)/bin/HfdGetPath: $(DILIB_IMPORT)/Hfd/HfdGetPath.c $(DILIB)/Date/Hfd.lib
	$(CC) $(DILIB_IMPORT)/Hfd/HfdGetPath.c      -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@  

$(DILIB)/bin/DamHfdSelect: $(DILIB_IMPORT)/Hfd/DamHfdSelect.c $(DILIB)/Date/DamHfd.lib
	$(CC) $(DILIB_IMPORT)/Hfd/DamHfdSelect.c      -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@ 

$(DILIB)/bin/HfdStoreFile: $(DILIB_IMPORT)/Hfd/HfdStoreFile.c $(DILIB)/Date/Buffer.lib \
                                    $(DILIB)/Date/RegExp.lib
	$(CC) $(DILIB_IMPORT)/Hfd/HfdStoreFile.c      -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@ 

#--------------------------------------------------------------------
# la librairie Dilib
#

$(DILIB)/Date/Hfd.lib:       $(DILIB)/Date/StrDict.lib    \
                             $(DILIB)/Date/Hcs.o      \
                             $(DILIB)/Date/HfdName.o   \
                             $(DILIB)/Date/HfdRecord.o  \
                             $(DILIB)/Date/HfdFile.o       \
                             $(DILIB)/Date/HfdIndexRead.o  \
                             $(DILIB)/Date/HfdBaseBool.o  \
                             $(DILIB)/Date/HfdIterator.o   \
                             $(DILIB)/Date/HfdIndexBool.o   \
                             $(DILIB)/Date/HfdHcb.o
	$(RANLIB) $(DILIB)/lib/libDilib.a
	$(TOUCH)

$(DILIB)/Date/Hcs.o: $(DILIB_IMPORT)/Hfd/Hcs.c \
                       $(DILIB)/Date/Hfd.include
	$(CC) $(DILIB_IMPORT)/Hfd/Hcs.c  -I$(DILIB)/include      \
                     -c -o Hcs.o
	ar ruv $(DILIB)/lib/libDilib.a   Hcs.o
	$(TOUCH)

$(DILIB)/Date/HfdIndexBool.o: $(DILIB_IMPORT)/Hfd/HfdIndexBool.c \
                       $(DILIB)/Date/Hfd.include
	$(CC) $(DILIB_IMPORT)/Hfd/HfdIndexBool.c  -I$(DILIB)/include      \
                     -c -o HfdIndexBool.o
	ar ruv $(DILIB)/lib/libDilib.a   HfdIndexBool.o
	$(TOUCH)

$(DILIB)/Date/HfdHcb.o: $(DILIB_IMPORT)/Hfd/HfdHcb.c \
                       $(DILIB)/Date/Hfd.include
	$(CC) $(DILIB_IMPORT)/Hfd/HfdHcb.c  -I$(DILIB)/include      \
                     -c -o HfdHcb.o
	ar ruv $(DILIB)/lib/libDilib.a   HfdHcb.o
	$(TOUCH)

$(DILIB)/Date/HfdRecord.o: $(DILIB_IMPORT)/Hfd/HfdRecord.c \
                       $(DILIB)/Date/Hfd.include
	$(CC) $(DILIB_IMPORT)/Hfd/HfdRecord.c  -I$(DILIB)/include      \
                     -c -o HfdRecord.o
	ar ruv $(DILIB)/lib/libDilib.a   HfdRecord.o
	$(TOUCH)

$(DILIB)/Date/HfdFile.o: $(DILIB_IMPORT)/Hfd/HfdFile.c \
                       $(DILIB)/Date/Hfd.include
	$(CC) $(DILIB_IMPORT)/Hfd/HfdFile.c  -I$(DILIB)/include      \
                     -c -o HfdFile.o
	ar ruv $(DILIB)/lib/libDilib.a   HfdFile.o
	$(TOUCH)

$(DILIB)/Date/HfdIndexRead.o: $(DILIB_IMPORT)/Hfd/HfdIndexRead.c \
                       $(DILIB)/Date/Hfd.include   \
                      $(DILIB)/Date/SxPath.include
	$(CC) $(DILIB_IMPORT)/Hfd/HfdIndexRead.c  -I$(DILIB)/include      \
                     -c -o HfdIndexRead.o
	ar ruv $(DILIB)/lib/libDilib.a   HfdIndexRead.o
	$(TOUCH)


$(DILIB)/Date/HfdBaseBool.o: $(DILIB_IMPORT)/Hfd/HfdBaseBool.c \
                       $(DILIB)/Date/Hfd.include   \
                      $(DILIB)/Date/SxPath.include
	$(CC) $(DILIB_IMPORT)/Hfd/HfdBaseBool.c  -I$(DILIB)/include      \
                     -c -o HfdBaseBool.o
	ar ruv $(DILIB)/lib/libDilib.a   HfdBaseBool.o
	$(TOUCH)

$(DILIB)/Date/HfdIterator.o: $(DILIB_IMPORT)/Hfd/HfdIterator.c \
                       $(DILIB)/Date/Hfd.include
	$(CC) $(DILIB_IMPORT)/Hfd/HfdIterator.c  -I$(DILIB)/include -Wall     \
                     -c -o HfdIterator.o
	ar ruv $(DILIB)/lib/libDilib.a   HfdIterator.o
	$(TOUCH)

$(DILIB)/Date/DamHfd.lib: $(DILIB)/Date/DamStreamIter.o \
                                 $(DILIB)/Date/DamHfdIter.o \
                                 $(DILIB)/Date/DamHfd.o \
                                 $(DILIB)/Date/DamHfdName.o \
                                 $(DILIB)/Date/DamHCB.o \
                                 $(DILIB)/Date/DamName.o 
	$(RANLIB) $(DILIB)/lib/libDilib.a
	$(TOUCH)

$(DILIB)/Date/DamStreamIter.o: $(DILIB_IMPORT)/Hfd/DamStreamIter.c \
                       $(DILIB)/Date/DamHfd.include
	$(CC) $(DILIB_IMPORT)/Hfd/DamStreamIter.c  -I$(DILIB)/include      \
                     -c -o DamStreamIter.o
	ar ruv $(DILIB)/lib/libDilib.a   DamStreamIter.o
	$(TOUCH)

$(DILIB)/Date/DamHfdIter.o: $(DILIB_IMPORT)/Hfd/DamHfdIter.c \
                       $(DILIB)/Date/DamHfd.include
	$(CC) $(DILIB_IMPORT)/Hfd/DamHfdIter.c  -I$(DILIB)/include      \
                     -c -o DamHfdIter.o
	ar ruv $(DILIB)/lib/libDilib.a   DamHfdIter.o
	$(TOUCH)

$(DILIB)/Date/DamHfd.o: $(DILIB_IMPORT)/Hfd/DamHfd.c \
                       $(DILIB)/Date/DamHfd.include
	$(CC) $(DILIB_IMPORT)/Hfd/DamHfd.c  -I$(DILIB)/include      \
                     -c -o DamHfd.o
	ar ruv $(DILIB)/lib/libDilib.a   DamHfd.o
	$(TOUCH)

$(DILIB)/Date/DamHfdName.o: $(DILIB_IMPORT)/Hfd/DamHfdName.c \
                       $(DILIB)/Date/DamHfd.include
	$(CC) $(DILIB_IMPORT)/Hfd/DamHfdName.c  -I$(DILIB)/include      \
                     -c -o DamHfdName.o
	ar ruv $(DILIB)/lib/libDilib.a   DamHfdName.o
	$(TOUCH)

$(DILIB)/Date/HfdName.o: $(DILIB_IMPORT)/Hfd/HfdName.c \
                       $(DILIB)/Date/Hfd.include
	$(CC) $(DILIB_IMPORT)/Hfd/HfdName.c  -I$(DILIB)/include      \
                     -c -o HfdName.o
	ar ruv $(DILIB)/lib/libDilib.a   HfdName.o
	$(TOUCH)

$(DILIB)/Date/DamName.o: $(DILIB_IMPORT)/Hfd/DamName.c \
                       $(DILIB)/Date/DamHfd.include
	$(CC) $(DILIB_IMPORT)/Hfd/DamName.c  -I$(DILIB)/include      \
                     -c -o DamName.o
	ar ruv $(DILIB)/lib/libDilib.a   DamName.o
	$(TOUCH)

$(DILIB)/Date/DamHCB.o: $(DILIB_IMPORT)/Hfd/DamHCB.c \
                       $(DILIB)/Date/DamHfd.include
	$(CC) $(DILIB_IMPORT)/Hfd/DamHCB.c  -I$(DILIB)/include      \
                     -c -o DamHCB.o
	ar ruv $(DILIB)/lib/libDilib.a   DamHCB.o
	$(TOUCH)

#--------------------------------------------------------------------
#    La Documentation par man d'Unix

 $(DILIB)/Date/Hfd.man:$(DILIB)/man/man1/HfdCat.1 \
                        $(DILIB)/man/man1/HfdBuild.1 \
                         $(DILIB)/man/man1/HfdSelect.1
	$(TOUCH)

$(DILIB)/man/man1/HfdCat.1:$(DILIB_IMPORT)/Hfd//HfdCat.1.man
	$(MAKE_MAN)  $(DILIB_IMPORT)/Hfd//HfdCat.1.man Hfd   $@

$(DILIB)/man/man1/HfdSelect.1:$(DILIB_IMPORT)/Hfd/HfdSelect.1.man
	$(MAKE_MAN)  $(DILIB_IMPORT)/Hfd/HfdSelect.1.man Hfd   $@

$(DILIB)/man/man1/HfdBuild.1:$(DILIB_IMPORT)/Hfd/HfdBuild.1.man
	$(MAKE_MAN)  $(DILIB_IMPORT)/Hfd/HfdBuild.1.man Hfd   $@

$(DILIB)/Date/DamHfd.man:$(DILIB)/man/man5/DamHfd.5 \
                         $(DILIB)/man/man1/DamHfdSelect.1
	$(TOUCH)

$(DILIB)/man/man5/DamHfd.5: $(DILIB_IMPORT)/Hfd/DamHfd.5.man
	$(MAKE_MAN) $(DILIB_IMPORT)/Hfd/DamHfd.5.man DamHfd   $@

$(DILIB)/man/man1/DamHfdSelect.1:$(DILIB_IMPORT)/Hfd//DamHfdSelect.1.man
	$(MAKE_MAN)  $(DILIB_IMPORT)/Hfd/DamHfdSelect.1.man DamHfd   $@

#----------------------------------------------------------------
# php files
#
$(DILIB)/Date/Hfd.php: $(DILIB)/php/Hfd/Hfd.php
	$(TOUCH)

$(DILIB)/php/Hfd/Hfd.php: $(DILIB_IMPORT)/Hfd/Hfd.php
	cp $(DILIB_IMPORT)/Hfd/Hfd.php $@



#--------------------------- end DamHfd.mk ---------------



