/**********************************************************************
*
*  projet   : Infometrics
*  module   : Histo
*  commande : Histo.h
*  fichier  : Histo.h
*  Auteur   : Jacques DUCLOY
*  Date     : Juillet 97
*  $Id: Histo.h,v 1.2 2005/06/22 15:47:17 parmentf Exp $
*
***********************************************************************
*
* Copyleft Universit de  Lorraine
*
***********************************************************************/
#ifndef _HISTO_H_
#define _HISTO_H_

#include "SgmlNode.h"

struct Histo_Struct
{
  int maxElem;
  int nElem;
  int *tabInt;
  float *tabFloat;
  float cutFloat;
  int cut;
  SgmlNode **tabNode;
  int freeMode;
  int mode; /* i:int f:float */
};

typedef struct Histo_Struct Histo;

Histo    *HistoCreate();
Histo    *HistoSetCut();
Histo    *HistoFloatSetCut(Histo *, float);
Histo    *HistoSetFreeMode ();
SgmlNode *HistoToSgmlAndReset();
Histo    *HistoAdd();
Histo    *HistoFloatAdd(Histo*, SgmlNode*, float);

Histo *HistoFloatInsertAndShift(Histo *, SgmlNode*, float);
Histo *HistoInsertAndShift();
#endif  /* _HISTO_H_  */

