/**********************************************************************
*
*  projet   : DilibPro
*  module   : Index
*  commande : IndexBuildHid
*  fichier  : IndexBuildHid
*  Auteur   : Jacques DUCLOY
*  Date     : Fevrier 94
*  $Id: IndexBuildHid.c,v 1.2 2005/06/22 12:59:38 parmentf Exp $
*
***********************************************************************/
 
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "StrSearch.h"

#include "SgmlPath.h"
#include "Index.h"

void perror();

static  DamHfd   *hfdIndex;
static  char     *tagEntryName;
static  char     *tagList;
static  char     *tagItem;
static  char     *tagWeight;
static  char     *formatWeight;

    int getopt();
    extern char *optarg;
    extern int optind;

void usage()
{
  perror ("usage: IndexBuildHid -h hfdName [ -e entryName -n ]\n");
  exit(1);
}

int main(int argc, char **argv)
{
  int             cod_arg;
  int             flagHfd;
  int             flagWrite;
  char           *hfdName;
  DamHfdIterator *iterator;
  FILE           *currentFile;
  FILE           *outputFile;
  char           *fileName;
  Buffer         *inputBuffer;
  char           *bufferString;
  char           *hidName;
  SgmlNode       *pathList;  
  char           *nextOptArg;

  flagHfd=0;
  flagWrite=1;

  tagEntryName="key";
  tagList="l";
  tagItem="i";
  tagWeight="w";
  formatWeight="%.2f";
  pathList=NULL;

  while ((cod_arg = getopt(argc,argv,"nh:e:l:i:w:W:p:"))!=EOF)
    {switch(cod_arg)
     {
     case 'h' :
       hfdName=optarg;
       if((hfdIndex=DamHfdOpenReadKey(hfdName)))
	 {
	   flagHfd=1;
	   break;
	 }
      else
	{
	  perror("HFD not founded\n");
	  usage();
	}
       break;
     case 'e':
       tagEntryName=optarg;
       break;
     case 'p':
       if(!pathList)pathList=SgmlCreateMark("pathlist");
       SgmlAddSon(pathList, SgmlCreateLeaf("path", optarg));
       while(optind-1<argc)
	 {
	   nextOptArg=argv[optind];
	   if(!nextOptArg)break;
	   if(nextOptArg[0]=='-')break;
	   SgmlAddSon(pathList, SgmlCreateLeaf("path", nextOptArg));
	   optind++;
	 }
       break;
     case 'i':
       tagItem=optarg;
       break;
     case 'l':
       tagList=optarg;
       break;
     case 'n':
       flagWrite=0;
       break;
     case 'w':
       tagWeight=optarg;
       break;
     case 'W':
       formatWeight=optarg;
       break;
     default: usage();
       break;
     }
   }
  if(!flagHfd) usage();

  hidName=malloc(strlen(hfdIndex->name)+5);
  strcpy(hidName, hfdIndex->name);
  strcat(hidName, ".hid");

  if (flagWrite) outputFile=fopen(hidName,"w");
  else outputFile=stdout;

  iterator=DamHfdIteratorCreate();
  DamHfdIteratorInit(iterator,hfdIndex->rootPath );
  inputBuffer=BufferCreate(1000,1000);

  while((fileName=DamHfdNextFilePath(iterator)))
    {
      char c;
      currentFile=fopen(fileName,"r");
      if((bufferString=BufferFgets(inputBuffer,currentFile)))
	{
	  fprintf(outputFile,"%s\t",SgmlStrGetLeaf(bufferString,tagEntryName));
	  while((c=*bufferString++)!='\t')
	    {
	      putc(c,outputFile);
	    }
	  putc('\n',outputFile);
	}
      fclose(currentFile);
    }

  if(flagWrite)
    {
      SgmlNode  *descIndex;
      SgmlNode  *descList;

      descIndex =SgmlCreateMark("index");
      descList  =SgmlCreateMark("list");
      SgmlAddSon(descIndex, SgmlCreateLeaf("tag" ,tagEntryName));
      SgmlAddSon(descList , SgmlCreateLeaf("tagl",tagList));
      SgmlAddSon(descList , SgmlCreateLeaf("tagi",tagItem));
      SgmlAddSon(descList , SgmlCreateLeaf("tagw",tagWeight));
      SgmlAddSon(descList , SgmlCreateLeaf("forw",formatWeight));
      SgmlAddSon(hfdIndex->desc, descIndex);
      if(pathList)SgmlAddSon(descIndex, pathList);
      SgmlAddSon(descIndex, descList);
      DamHCB_Print(hfdIndex);
    }
  return 0;
}


