/*   -*- coding: utf-8 -*-  */
/***********************************************************************
*
* Module   : Index
* Fichier  : IndexHistoBuilder.c
* Auteur   : Ducloy
* Date     : 11/96
*
*************************************************************************/

#include <stdio.h>     /* for printf */
#include <stdlib.h>    /* for exit */
#include <getopt.h>
#include "SxmlNode.h"

void proceedIndex(char *code)
{
  SxmlNode *indexNode;
  while ((indexNode=SxmlInputNextDocumentElement()))
    {
      char *kw;
      SxmlNode *l;
      SxmlNode *e;
      char *id;
      kw=SxmlLeafText(SxmlGetFirstChildByTagName(indexNode,"kw"));
      if ((l=SxmlGetFirstChildByTagName(indexNode,"l")))
	{
	  SxmlReset(l);
	  while ((e=SxmlNextNode(l)))
	    {
	      printf ("%s\t%s\t%s\n", SxmlLeafText(e), code, kw);
	    }
	}
     }
}

  Buffer *bKey;
  int activeKey;
SxmlNode *listA;
SxmlNode *inputRecord;

void proceedNewA()
{
  listA=SxmlElementCreate("l");
  SxmlAppendChild(listA, SxmlLeafCreate("e", SxmlLeafText(SxmlLastChild(inputRecord))));
  BufferStrcpy(bKey, SxmlInputRecordKey);
  activeKey=1;
  /*
  SxmlPrint(listA);
  putchar ('\n');
  */
}

void purgePairs()
{
  SxmlFree(listA);
}

void proceedPairs()
{

  bKey=NewBuffer();
  activeKey=0;
  while ((inputRecord=SxmlInputNextRecord()))
    {
      char *aOrB;
      /*  SxmlPrint(inputRecord); */
      aOrB=SxmlLeafText(SxmlNextSibling(SxmlFirstChild(inputRecord)));
      if ((*aOrB=='b')&&(activeKey==0)) continue;
      if ((*aOrB=='a')&&(activeKey==0)) 
	{
	  proceedNewA();
	  continue;
	}
                                              /* activeKey=1 */
      if (strcmp(SxmlInputRecordKey, BufferString(bKey))==0)
	{
	  if (*aOrB=='b')
	    {
	      SxmlNode *elemA;
	      SxmlReset(listA);
	      while ((elemA=SxmlNextNode(listA))) printf ("%s\t%s\n", SxmlLeafText(elemA),SxmlLeafText(SxmlLastChild(inputRecord) ));
	      continue;
	    }

	  /* aOrB='a' */
	  SxmlAppendChild(listA, SxmlLeafCreate("e", SxmlLeafText(SxmlLastChild(inputRecord))));
	}
      else
	{
	  purgePairs();
	  if (*aOrB=='b') 
	    {
	      activeKey=0;
	      continue;
	    }
	  proceedNewA();
	  continue;
	}
    }
}

int main (int argc, char **argv) {
  int cOption;
  while((cOption=getopt(argc,argv,"abc"))!=EOF)
    {
      {switch (cOption)
	  {
	  case 'a':
	    proceedIndex("a");
	    break;
	  case 'b':
	    proceedIndex("b");
	    break;
	  case 'c':
	    proceedPairs();
	    break;
	  }
      }
    }
}
