/*   -*- coding: utf-8 -*-  */
/***********************************************************************
*
*        Module   : Stat
*        Fichier  : DateCurationClass.c
*        Auteur   : Ali Tebbakh
*        Date     : Janvier 2014
*
************************************************************************/

#include <stdio.h>
#include <unistd.h>
#include <string.h> 
#include <stdlib.h>
#include "Buffer.h"

extern char *optarg;
extern int   optind;
int getopt();

int main (int argc, char** argv)
{
  int dateFrom;
  int dateTo;
  int step;
  int dateCourante;
  int dateClass;
  int modeTrace;
  int numclass;
  

  char * strAfter;
  char * strBefore;
  char * line;
  char tabChar;        /* tabulation pos. */
  
  Buffer *bufLine;  /* input line */
  Buffer *bufDateKey;   /* input hfd key */
 
  
  int cod_arg;
  
  bufLine=NewBuffer();
  bufDateKey=NewBuffer();
  
  dateFrom=0;
  dateTo=9999;
  step=1;
  strAfter=NULL;
  strBefore=NULL;
  modeTrace=0;
  
  tabChar='\t';
  
  while ((cod_arg = getopt(argc,argv,"f:K:t:s:b:a:T"))!=EOF)
    {switch(cod_arg)
	{
	case 'f':
	  dateFrom=atoi(optarg);  		
	  break;
	  
	case 'K':
	  tabChar=*optarg;
	  break;
	  
	case 't':
	  dateTo=atoi(optarg);
	  break;
	  
	case 's':
	  step=atoi(optarg);	  
	  break;

	case 'a':
	  strAfter=optarg;
	  break;

	case 'b':
	  strBefore=optarg; 		
	  break;

	case 'T':
	  modeTrace=1;
	  break;
	
  	}
    }

  if ((dateFrom>=dateTo))   
    {
      fprintf(stderr, "***bad option: -t (%d) must be greater than -f \n", dateTo);
      exit (EXIT_FAILURE);
      }
 
  while ((line=BufferGets(bufLine))) 
    {
      char *posTabulation;
      posTabulation=strchr(line, tabChar); /* find tab. */
      /* if (!posTabulation) continue;*/		
      if (modeTrace) printf("%s\n", line);
      BufferStrncpy(bufDateKey,line, 4);
      dateCourante=atoi(BufferString(bufDateKey));
      
      
      if ((dateCourante < dateFrom))
	{
	  if (strBefore) 
	    {
	      printf("%s\t%s\n",strBefore, posTabulation+1);
	      continue; 
	    }
	  continue;
	  }  
      if((dateCourante > dateTo))
	{ 
	   if (strAfter) 	   
	     {
	       printf("%s\t%s\n",strAfter, posTabulation+1);
	       continue; 
	     }
	   continue;
	}
        
      numclass=(dateCourante-dateFrom)/step;
      dateClass=dateFrom+(step*numclass);
      printf("%d\t%s\n",dateClass, posTabulation+1);
			 
    }  
  exit (EXIT_SUCCESS);
}
