
#   Module  : Inist
#   Fichier : Inist.mk
#

include  $(DILIB)/MakeDef.mk

$(DILIB)/Date/Inist.mod: $(DILIB)/Date/Inist.bin \
                                $(DILIB)/Date/Inist.php \
                                $(DILIB)/Date/Inist.data
	$(TOUCH)

#----------------------------------------------------------------
# php files
#
$(DILIB)/Date/Inist.php: $(DILIB)/php/Inist/Inist.php
	$(TOUCH)

$(DILIB)/php/Inist/Inist.php: $(DILIB_IMPORT)/Inist/Inist.php
	cp $(DILIB_IMPORT)/Inist/Inist.php $@

#------------------------------------------------------------------
# Les binaires
#

$(DILIB)/Date/Inist.bin: $(DILIB)/bin/PascalFromIlib \
                            $(DILIB)/bin/PascalServer2xml    \
                            $(DILIB)/bin/PascalSgml2utf8    \
                            $(DILIB)/bin/InistSgml2utf8    \
                            $(DILIB)/bin/InistServer2Sxml    \
                            $(DILIB)/bin/InistIlib2Sxml    \
                            $(DILIB)/bin/InistPair2Tei      \
                            $(DILIB)/bin/InistToWiki         \
                            $(DILIB)/bin/InistExplorDataShells    \
                            $(DILIB)/bin/InistExplorSiteHtmlPhp    \
                            $(DILIB)/bin/InistExplorSiteShell    \
                            $(DILIB)/bin/InistBhaExplorDataShells    \
                            $(DILIB)/bin/InistBhaExplorSiteHtmlPhp    \
                            $(DILIB)/bin/InistBhaExplorSiteShell    \
                            $(DILIB)/bin/InistExodic2Tei            \
                            $(DILIB)/bin/InistExplorComputeParam    \
                            $(DILIB)/bin/PascalToMiniBibStruct  \
                            $(DILIB)/bin/InistExplorInit   \
                            $(DILIB)/bin/InistAffiliationSetCountry \
                            $(DILIB)/bin/InistCurationCountry \
                            $(DILIB)/bin/InistMergeBiblioFromIdx \
                            $(DILIB)/bin/InistBhaCurPar          \
                            $(DILIB)/bin/InistBhaKwd2Wicri          \
                            $(DILIB)/bin/InistExplorParam
	$(TOUCH)

$(DILIB)/bin/PascalFromIlib: $(DILIB_IMPORT)/Inist/PascalFromIlib.c \
                            $(DILIB)/Date/SgmlPath.lib
	$(CC)  $(DILIB_IMPORT)/Inist/PascalFromIlib.c   -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/PascalToMiniBibStruct: $(DILIB_IMPORT)/Inist/PascalToMiniBibStruct.c \
                            $(DILIB)/include/SgmlNode.h            \
                            $(DILIB)/Date/SgmlPath.lib
	$(CC)  $(DILIB_IMPORT)/Inist/PascalToMiniBibStruct.c   -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/PascalServer2xml: $(DILIB_IMPORT)/Inist/PascalServer2xml.lex
	$(LEX) $(DILIB_IMPORT)/Inist/PascalServer2xml.lex
	$(CC) lex.yy.c -ll -o  $@

$(DILIB)/bin/PascalSgml2utf8:  $(DILIB_IMPORT)/Inist/PascalSgml2utf8.lex
	$(LEX) $(DILIB_IMPORT)/Inist/PascalSgml2utf8.lex
	$(CC) lex.yy.c -ll -o  $@

$(DILIB)/bin/InistBhaCurPar:  $(DILIB_IMPORT)/Inist/InistBhaCurPar.lex
	$(LEX) $(DILIB_IMPORT)/Inist/InistBhaCurPar.lex
	$(CC) lex.yy.c -ll -o  $@

$(DILIB)/bin/InistSgml2utf8:  $(DILIB_IMPORT)/Inist/InistSgml2utf8.lex
	$(LEX) $(DILIB_IMPORT)/Inist/InistSgml2utf8.lex
	$(CC) lex.yy.c -ll -o  $@

$(DILIB)/bin/InistServer2Sxml: $(DILIB_IMPORT)/Inist/InistServer2Sxml.lex
	$(LEX) $(DILIB_IMPORT)/Inist/InistServer2Sxml.lex
	$(CC) lex.yy.c -ll -o  $@

$(DILIB)/bin/InistIlib2Sxml: $(DILIB_IMPORT)/Inist/InistIlib2Sxml.c \
                            $(DILIB)/Date/SxmlNode.lib
	$(CC)  $(DILIB_IMPORT)/Inist/InistIlib2Sxml.c   -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/InistToWiki: $(DILIB_IMPORT)/Inist/InistToWiki.c \
                            $(DILIB)/Date/SxmlNode.lib  \
                            $(DILIB)/Date/MediaWiki.lib
	$(CC)  $(DILIB_IMPORT)/Inist/InistToWiki.c   -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@


$(DILIB)/bin/InistExplorDataShells: $(DILIB_IMPORT)/Inist/InistExplorDataShells.c \
                            $(DILIB)/Date/StrSearch.lib   \
                            $(DILIB)/Date/Explor.lib
	$(CC)  $(DILIB_IMPORT)/Inist/InistExplorDataShells.c   -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/InistBhaExplorDataShells: $(DILIB_IMPORT)/Inist/InistBhaExplorDataShells.c \
                            $(DILIB)/Date/StrSearch.lib   \
                            $(DILIB)/Date/Explor.lib
	$(CC)  $(DILIB_IMPORT)/Inist/InistBhaExplorDataShells.c   -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/InistMergeBiblioFromIdx: $(DILIB_IMPORT)/Inist/InistMergeBiblioFromIdx.c \
                            $(DILIB)/Date/StrSearch.lib   \
                            $(DILIB)/Date/Explor.lib
	$(CC)  $(DILIB_IMPORT)/Inist/InistMergeBiblioFromIdx.c   -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@


$(DILIB)/bin/InistExplorSiteHtmlPhp: $(DILIB_IMPORT)/Inist/InistExplorSiteHtmlPhp.c \
                            $(DILIB)/Date/StrSearch.lib   \
                            $(DILIB)/Date/Explor.lib
	$(CC)  $(DILIB_IMPORT)/Inist/InistExplorSiteHtmlPhp.c   -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/InistBhaExplorSiteHtmlPhp: $(DILIB_IMPORT)/Inist/InistBhaExplorSiteHtmlPhp.c \
                            $(DILIB)/Date/StrSearch.lib   \
                            $(DILIB)/Date/Explor.lib
	$(CC)  $(DILIB_IMPORT)/Inist/InistBhaExplorSiteHtmlPhp.c   -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/InistExplorSiteShell: $(DILIB_IMPORT)/Inist/InistExplorSiteShell.c \
                            $(DILIB)/Date/StrSearch.lib   \
                            $(DILIB)/Date/Explor.lib
	$(CC)  $(DILIB_IMPORT)/Inist/InistExplorSiteShell.c   -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/InistBhaExplorSiteShell: $(DILIB_IMPORT)/Inist/InistBhaExplorSiteShell.c \
                            $(DILIB)/Date/StrSearch.lib   \
                            $(DILIB)/Date/Explor.lib
	$(CC)  $(DILIB_IMPORT)/Inist/InistBhaExplorSiteShell.c   -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@


$(DILIB)/bin/InistExplorComputeParam: $(DILIB_IMPORT)/Inist/InistExplorComputeParam.c \
                            $(DILIB)/Date/StrSearch.lib   \
                            $(DILIB)/Date/Explor.lib
	$(CC)  $(DILIB_IMPORT)/Inist/InistExplorComputeParam.c   -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@


$(DILIB)/bin/InistAffiliationSetCountry: $(DILIB_IMPORT)/Inist/InistAffiliationSetCountry.c \
                            $(DILIB)/Date/StrSearch.lib   \
                            $(DILIB)/Date/Wicri.lib   \
                            $(DILIB)/Date/Explor.lib
	$(CC)  $(DILIB_IMPORT)/Inist/InistAffiliationSetCountry.c -Wall  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/InistCurationCountry: $(DILIB_IMPORT)/Inist/InistCurationCountry.c \
                            $(DILIB)/Date/StrSearch.lib   \
                            $(DILIB)/Date/SxPath.lib   \
                            $(DILIB)/Date/Wicri.lib   \
                            $(DILIB)/Date/Explor.lib
	$(CC)  $(DILIB_IMPORT)/Inist/InistCurationCountry.c -Wall  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/InistPair2Tei: $(DILIB_IMPORT)/Inist/InistPair2Tei.c \
                            $(DILIB)/Date/Utf8.lib      \
                            $(DILIB)/Date/Tei.lib      \
                            $(DILIB)/Date/Explor.lib      \
                            $(DILIB)/Date/SxPath.lib \
                            $(DILIB)/Date/SxmlProc.lib
	$(CC)  $(DILIB_IMPORT)/Inist/InistPair2Tei.c -Wall  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/InistBhaKwd2Wicri: $(DILIB_IMPORT)/Inist/InistBhaKwd2Wicri.c \
                            $(DILIB)/Date/Utf8.lib      \
                            $(DILIB)/Date/Tei.lib      \
                            $(DILIB)/Date/Explor.lib      \
                            $(DILIB)/Date/SxPath.lib \
                            $(DILIB)/Date/SxmlProc.lib
	$(CC)  $(DILIB_IMPORT)/Inist/InistBhaKwd2Wicri.c   -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/InistExodic2Tei: $(DILIB_IMPORT)/Inist/InistExodic2Tei.c \
                            $(DILIB)/Date/Utf8.lib      \
                            $(DILIB)/Date/Tei.lib      \
                            $(DILIB)/Date/Explor.lib      \
                            $(DILIB)/Date/SxPath.lib \
                            $(DILIB)/Date/SxmlProc.lib
	$(CC)  $(DILIB_IMPORT)/Inist/InistExodic2Tei.c   -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/InistExplorInit: $(DILIB_IMPORT)/Inist/InistExplorInit
	$(MAKE_SHELL) $(DILIB_IMPORT)/Inist/InistExplorInit $@

$(DILIB)/bin/InistExplorParam: $(DILIB_IMPORT)/Inist/InistExplorParam
	$(MAKE_SHELL) $(DILIB_IMPORT)/Inist/InistExplorParam $@

#----------------------------------------------------------------
# data
#
$(DILIB)/Date/Inist.data:$(DILIB)/data/Inist/ExplorParam.en.tab   \
                                $(DILIB)/data/Inist/ExplorParam.fr.tab   \
                                $(DILIB)/data/icons/LogoInistPascal.png  \
                                $(DILIB)/data/icons/LogoInistPascalFrancis.png  \
                                $(DILIB)/data/icons/LogoInistFrancis.png  \
                                $(DILIB)/data/Inist/FrancisPers.tab       \
                                $(DILIB)/data/Inist/BhaPers.tab          \
                                $(DILIB)/data/Inist/PascalGeo.tab        \
                                $(DILIB)/data/Inist/PascalConceptFr.tab     \
                                $(DILIB)/data/Inist/ExplorParam.data.tab   \
                                $(DILIB)/data/Inist/BhaExplorParam.data.tab   \
                                $(DILIB)/data/Inist/BhaExplorParam.en.tab   \
                                $(DILIB)/data/Inist/BhaExplorParam.fr.tab   \
                                $(DILIB)/data/Inist/BhaIndexationLorraine.tab 
	$(TOUCH)

$(DILIB)/data/Inist/ExplorParam.en.tab: $(DILIB_IMPORT)/Inist/Data/InistExplorParam.en.wiki \
                                      $(DILIB)/bin/ExplorParamFromWiki
	ExplorParamFromWiki < $(DILIB_IMPORT)/Inist/Data/InistExplorParam.en.wiki > $@

$(DILIB)/data/Inist/BhaIndexationLorraine.tab:$(DILIB_IMPORT)/Inist/Data/BhaIndexationLorraine.wiki  \
                              $(DILIB)/bin/TeiTableTermsFromWiki     \
                              $(DILIB)/bin/SxmlGrouping
	cat $(DILIB_IMPORT)/Inist/Data/BhaIndexationLorraine.wiki | $(DILIB)/bin/TeiTableTermsFromWiki > $@

$(DILIB)/data/Inist/PascalConceptFr.tab: $(DILIB)/bin/EurovocCreateConceptTable  \
                             $(DILIB_IMPORT)/Inist/Data/PascalInformatiqueGeneral.wiki \
                             $(DILIB_IMPORT)/Inist/InistCreatePascalConceptFr.tab.sh
	sh  $(DILIB_IMPORT)/Inist/InistCreatePascalConceptFr.tab.sh

$(DILIB)/data/Inist/ExplorParam.fr.tab: $(DILIB_IMPORT)/Inist/Data/InistExplorParam.fr.wiki \
                                      $(DILIB)/bin/ExplorParamFromWiki
	ExplorParamFromWiki < $(DILIB_IMPORT)/Inist/Data/InistExplorParam.fr.wiki > $@

$(DILIB)/data/Inist/ExplorParam.data.tab: $(DILIB_IMPORT)/Inist/Data/InistExplorParam.data.wiki \
                                      $(DILIB)/bin/ExplorParamFromWiki
	ExplorParamFromWiki < $(DILIB_IMPORT)/Inist/Data/InistExplorParam.data.wiki > $@

$(DILIB)/data/Inist/BhaExplorParam.data.tab: $(DILIB_IMPORT)/Inist/Data/InistBhaExplorParam.data.wiki \
                                      $(DILIB)/bin/ExplorParamFromWiki
	ExplorParamFromWiki < $(DILIB_IMPORT)/Inist/Data/InistBhaExplorParam.data.wiki > $@

$(DILIB)/data/Inist/BhaExplorParam.en.tab: $(DILIB_IMPORT)/Inist/Data/InistBhaExplorParam.en.wiki \
                                      $(DILIB)/bin/ExplorParamFromWiki
	ExplorParamFromWiki < $(DILIB_IMPORT)/Inist/Data/InistBhaExplorParam.en.wiki > $@

$(DILIB)/data/Inist/BhaExplorParam.fr.tab: $(DILIB_IMPORT)/Inist/Data/InistBhaExplorParam.fr.wiki \
                                      $(DILIB)/bin/ExplorParamFromWiki
	ExplorParamFromWiki < $(DILIB_IMPORT)/Inist/Data/InistBhaExplorParam.fr.wiki > $@

$(DILIB)/data/icons/LogoInistPascal.png: $(DILIB_IMPORT)/Inist/Data/LogoInistPascal.png
	cp $(DILIB_IMPORT)/Inist/Data/LogoInistPascal.png $@

$(DILIB)/data/icons/LogoInistPascalFrancis.png: $(DILIB_IMPORT)/Inist/Data/LogoInistPascalFrancis.png
	cp $(DILIB_IMPORT)/Inist/Data/LogoInistPascalFrancis.png $@

$(DILIB)/data/icons/LogoInistFrancis.png: $(DILIB_IMPORT)/Inist/Data/LogoInistFrancis.png
	cp $(DILIB_IMPORT)/Inist/Data/LogoInistFrancis.png $@

$(DILIB)/data/Inist/FrancisPers.tab:  $(DILIB_IMPORT)/Inist/Data/FrancisPersLorraine.wiki \
                                      $(DILIB_IMPORT)/Inist/Data/FrancisPersLorraineCpl.wiki \
                                      $(DILIB_IMPORT)/Inist/Data/FrancisPersEurope.wiki   \
                                      $(DILIB_IMPORT)/Inist/Data/FrancisPersFrance.wiki   \
                            $(DILIB)/bin/MediaWikiEasyTable2Sxml
	cat  $(DILIB_IMPORT)/Inist/Data/FrancisPersLorraine.wiki \
             $(DILIB_IMPORT)/Inist/Data/FrancisPersLorraineCpl.wiki \
             $(DILIB_IMPORT)/Inist/Data/FrancisPersEurope.wiki   \
             $(DILIB_IMPORT)/Inist/Data/FrancisPersFrance.wiki   \
              |MediaWikiEasyTable2Sxml > $@

$(DILIB)/data/Inist/BhaPers.tab:  $(DILIB_IMPORT)/Inist/Data/BhaPersLorraine.wiki \
                                  $(DILIB_IMPORT)/Inist/Data/BhaPersFrance.wiki   \
                            $(DILIB)/bin/MediaWikiEasyTable2Sxml
	cat  $(DILIB_IMPORT)/Inist/Data/BhaPersLorraine.wiki \
             $(DILIB_IMPORT)/Inist/Data/BhaPersFrance.wiki   \
              |MediaWikiEasyTable2Sxml > $@

$(DILIB)/data/Inist/PascalGeo.tab:  $(DILIB_IMPORT)/Wicri/Data/depPrefFrance.wiki \
                            $(DILIB)/bin/MediaWikiCleanTable   \
                            $(DILIB)/bin/MediaWikiTable2SxmlRowCol   \
                            $(DILIB)/bin/MediaWikiTableTransformCol  \
                            $(DILIB_IMPORT)/Wicri/Data/Iso3166.wiki  \
                            $(DILIB_IMPORT)/Inist/InistCreatePascalGeo.sh
	sh $(DILIB_IMPORT)/Inist/InistCreatePascalGeo.sh >  $@

#------------------------------- end Inist.mk ----------------
