/*   -*- coding: utf-8 -*-  */

/**********************************************************************
*
*  module   : Istex
*  fichier  : Istex.h
*  Auteur   : Jacques DUCLOY
*  Date     : 2013
*
***********************************************************************/

#ifndef _ISTEX_H_
#define _ISTEX_H_

#include "SxmlNode.h"
#include "JsonTools.h"
#include "Except.h"

/*                                     in IstexCurl.c   */

extern char *IstexRootUrl;
extern Buffer *IstexBufUrlQuery;
extern int   IstexTraceLevel;
extern int   IstexCleanFlag;      /* 0 : no clean ; 1: clean */

void      IstexInit();
void      IstexEnd();
void      IstexGetAndPrintFullTextItem(SxmlNode *hitsItem, char *typeFullText);
void      IstexGetAndPrintMetadataItem(SxmlNode *hitsItem, int outputMode, char *typeMeta);
SxmlNode *IstexGetQueryResultSxml(char *query, char *corpus, int fromInt, int sizeInt, char *output, char *sort);
char     *IstexGetQueryResult(char *query, char *corpus, int fromInt, int sizeInt, char *output, char *sort);
char     *IstexGetQueryUrl(char *query, char *corpus, int fromInt, int sizeInt, char *output, char *sort);
char     *IstexGetDocumentByUri(char *uri);
char     *IstexGetIdQueryUrl(char *id, char *output);
char     *IstexGetDoiQueryUrl(char *id, char *output);
char     *IstexJsonFindUrl(SxmlNode *jsonDoc, char* metaOrFull, char *typeToFind);
char     *IstexSetIdPass(char *id, char *pass);
char     *IstexOutputParam (char *param);
char     *IstexSetAuthToken(char *token);



/*                                     in IstexTools.c   */

SxmlNode *IstexGetDocumentModsByUri(char *uri, char *id);
SxmlNode *IstexGetDocumentTeiByUri(char *uri, char *tag);
SxmlNode *IstexGetDocumentXmlByUri(char *uri);
SxmlNode *IstexGetFullDocFromJson (SxmlNode *jsonDoc, int fulltextTag);

/*                                     in IstexCleanTools  */

SxmlNode *IstexCleanMetadataMods(SxmlNode *metaMods, char* corpusName);
void IstexCleanMetadataXmlInit();
SxmlNode *IstexCleanMetadataXml(SxmlNode *metaXml, char *corpusName);
extern char *IstexCleanHfdKey;
extern int   IstexCleanTrace;

#endif /* _ISTEX_H_ */
