
#   Module  : Istex
#   Fichier : Istex.mk
#
 
include  $(DILIB)/MakeDef.mk

$(DILIB)/Date/Istex.mod: $(DILIB)/Date/Istex.bin     \
                                $(DILIB)/Date/Istex.include \
                                $(DILIB)/Date/Istex.lib     \
                                $(DILIB)/Date/Istex.data
	$(TOUCH)


#----------------------------------------------------------------
# include files
#

$(DILIB)/Date/Istex.include: $(DILIB)/include/JsonTools.h   \
                             $(DILIB)/include/IstexRecord.h \
                             $(DILIB)/include/Istex.h
	$(TOUCH)

$(DILIB)/include/JsonTools.h:  $(DILIB_IMPORT)/Istex/JsonTools.h \
                               $(DILIB)/include/SxmlNode.h
	cp $(DILIB_IMPORT)/Istex/JsonTools.h $@


$(DILIB)/include/Istex.h:  $(DILIB_IMPORT)/Istex/Istex.h \
                           $(DILIB)/include/JsonTools.h  \
                           $(DILIB)/include/SxmlNode.h
	cp $(DILIB_IMPORT)/Istex/Istex.h $@


$(DILIB)/include/IstexRecord.h:  $(DILIB_IMPORT)/Istex/IstexRecord.h \
                           $(DILIB)/include/SxmlNode.h
	cp $(DILIB_IMPORT)/Istex/IstexRecord.h $@

#--------------------------------------------------------------------
# Dilib library
#

$(DILIB)/Date/Istex.lib: $(DILIB)/Date/JsonTools.o        \
                         $(DILIB)/Date/IstexTools.o       \
                         $(DILIB)/Date/IstexCleanTools.o  \
                         $(DILIB)/Date/IstexRecordTools.o \
                         $(DILIB)/Date/IstexCurl.o
	$(RANLIB) $(DILIB)/lib/libDilib.a
	$(TOUCH)

$(DILIB)/Date/JsonTools.o:$(DILIB_IMPORT)/Istex/JsonTools.c \
                                 $(DILIB)/include/JsonTools.h     \
                                $(DILIB)/include/Buffer.h
	$(CC) $(DILIB_IMPORT)/Istex/JsonTools.c   -I$(DILIB)/include      \
	      -c -o JsonTools.o
	ar ruv  $(DILIB)/lib/libDilib.a   JsonTools.o
	$(TOUCH)

$(DILIB)/Date/IstexTools.o:$(DILIB_IMPORT)/Istex/IstexTools.c \
                                 $(DILIB)/include/Istex.h     \
                                $(DILIB)/include/Buffer.h
	$(CC) $(DILIB_IMPORT)/Istex/IstexTools.c   -I$(DILIB)/include      \
	      -c -o IstexTools.o
	ar ruv  $(DILIB)/lib/libDilib.a   IstexTools.o
	$(TOUCH)

$(DILIB)/Date/IstexCleanTools.o:$(DILIB_IMPORT)/Istex/IstexCleanTools.c \
                                 $(DILIB)/include/Istex.h     \
                                $(DILIB)/include/Buffer.h
	$(CC) $(DILIB_IMPORT)/Istex/IstexCleanTools.c   -I$(DILIB)/include      \
	      -c -o IstexCleanTools.o
	ar ruv  $(DILIB)/lib/libDilib.a   IstexCleanTools.o
	$(TOUCH)

$(DILIB)/Date/IstexRecordTools.o:$(DILIB_IMPORT)/Istex/IstexRecordTools.c \
                                 $(DILIB)/include/Istex.h     \
                                 $(DILIB)/include/IstexRecord.h     \
                                $(DILIB)/include/Buffer.h
	$(CC) $(DILIB_IMPORT)/Istex/IstexRecordTools.c   -I$(DILIB)/include      \
	      -c -o IstexRecordTools.o
	ar ruv  $(DILIB)/lib/libDilib.a   IstexRecordTools.o
	$(TOUCH)


$(DILIB)/Date/IstexCurl.o:$(DILIB_IMPORT)/Istex/IstexCurl.c \
                                 $(DILIB)/include/Istex.h     \
                                $(DILIB)/include/Buffer.h
	$(CC) $(DILIB_IMPORT)/Istex/IstexCurl.c   -I$(DILIB)/include      \
	      -c -o IstexCurl.o
	ar ruv  $(DILIB)/lib/libDilib.a   IstexCurl.o
	$(TOUCH)

#------------------------------------------------------------------
# Les binaires
#

$(DILIB)/Date/Istex.bin:$(DILIB)/bin/IstexModsToSxml                    \
                               $(DILIB)/bin/IstexToSxml                 \
                               $(DILIB)/bin/IstexTeiToSxml              \
                               $(DILIB)/bin/IstexExplorDataShells       \
                               $(DILIB)/bin/IstexExplorSiteShell        \
                               $(DILIB)/bin/IstexExplorSiteHtmlPhp      \
                               $(DILIB)/bin/IstexAffiliationSetPays     \
                               $(DILIB)/bin/IstexCurationCountry        \
                               $(DILIB)/bin/IstexGetCorpus              \
                               $(DILIB)/bin/IstexGetCorpusById          \
                               $(DILIB)/bin/IstexGetCorpusSize          \
                               $(DILIB)/bin/IstexFlashCorpus            \
                               $(DILIB)/bin/IstexExplorCorpus           \
                               $(DILIB)/bin/JsonToSxml                  \
                               $(DILIB)/bin/IstexResultSelect           \
                               $(DILIB)/bin/IstexModsToTei              \
                               $(DILIB)/bin/IstexToTei                  \
                               $(DILIB)/bin/IstexCleanFullText          \
                               $(DILIB)/bin/IstexCatXml                 \
                               $(DILIB)/bin/IstexGenerAreaPages
	$(TOUCH)

$(DILIB)/bin/IstexModsToSxml: $(DILIB_IMPORT)/Istex/IstexModsToSxml.lex
	$(LEX) $(DILIB_IMPORT)/Istex/IstexModsToSxml.lex
	$(CC) lex.yy.c -ll -o  $@ -Wall

$(DILIB)/bin/IstexTeiToSxml: $(DILIB_IMPORT)/Istex/IstexTeiToSxml.lex
	$(LEX) $(DILIB_IMPORT)/Istex/IstexTeiToSxml.lex
	$(CC) lex.yy.c -ll -o  $@ -Wall

$(DILIB)/bin/IstexToSxml: $(DILIB_IMPORT)/Istex/IstexToSxml.lex
	$(LEX) $(DILIB_IMPORT)/Istex/IstexToSxml.lex
	$(CC) lex.yy.c -ll -o  $@ -Wall

$(DILIB)/bin/IstexResultSelect:  $(DILIB_IMPORT)/Istex/IstexResultSelect.lex 
	$(LEX) $(DILIB_IMPORT)/Istex/IstexResultSelect.lex
	$(CC) lex.yy.c -ll -o  $@ -Wall

$(DILIB)/bin/IstexFlashCorpus: $(DILIB_IMPORT)/Istex/IstexFlashCorpus  \
                               $(DILIB)/Date/Explor.lib       
	$(MAKE_SHELL) $(DILIB_IMPORT)/Istex/IstexFlashCorpus $@

$(DILIB)/bin/IstexGetCorpusSize: $(DILIB_IMPORT)/Istex/IstexGetCorpusSize  \
                                 $(DILIB)/bin/JsonToSxml                   \
                                 $(DILIB)/bin/SxmlSelect                   \
                                 $(DILIB)/bin/IstexGetCorpus
	$(MAKE_SHELL) $(DILIB_IMPORT)/Istex/IstexGetCorpusSize $@

$(DILIB)/bin/IstexExplorCorpus: $(DILIB_IMPORT)/Istex/IstexExplorCorpus  \
                               $(DILIB)/Date/Explor.lib       
	$(MAKE_SHELL) $(DILIB_IMPORT)/Istex/IstexExplorCorpus $@

$(DILIB)/bin/IstexGenerAreaPages: $(DILIB_IMPORT)/Istex/IstexGenerAreaPages.c  \
                          $(DILIB)/Date/MediaWiki.lib                   \
                               $(DILIB)/Date/Explor.lib       
	$(CC) $(DILIB_IMPORT)/Istex/IstexGenerAreaPages.c  -Wall  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/IstexGetCorpus: $(DILIB_IMPORT)/Istex/IstexGetCorpus.c  \
                        $(DILIB)/Date/Istex.lib                      \
                        $(DILIB)/Date/SxmlNode.lib                   \
                        $(DILIB)/include/Istex.h                     \
                        $(DILIB)/Date/CharSetBuffer.lib       
	$(CC) $(DILIB_IMPORT)/Istex/IstexGetCorpus.c  -Wall  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a  -lcurl -o $@

$(DILIB)/bin/IstexGetCorpusById: $(DILIB_IMPORT)/Istex/IstexGetCorpusById.c  \
                        $(DILIB)/Date/Istex.lib                      \
                        $(DILIB)/Date/SxmlNode.lib                   \
                        $(DILIB)/include/Istex.h                     \
                        $(DILIB)/Date/CharSetBuffer.lib       
	$(CC) $(DILIB_IMPORT)/Istex/IstexGetCorpusById.c  -Wall  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a  -lcurl -o $@

$(DILIB)/bin/JsonToSxml: $(DILIB_IMPORT)/Istex/JsonToSxml.c          \
                        $(DILIB)/Date/Istex.lib               \
                        $(DILIB)/Date/SxmlNode.lib   
	$(CC) $(DILIB_IMPORT)/Istex/JsonToSxml.c  -Wall  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a  -o $@

$(DILIB)/bin/IstexExplorDataShells: $(DILIB_IMPORT)/Istex/IstexExplorDataShells.c \
                            $(DILIB)/Date/StrSearch.lib   \
                            $(DILIB)/Date/Explor.lib
	$(CC)  $(DILIB_IMPORT)/Istex/IstexExplorDataShells.c   -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -Wall -o $@

$(DILIB)/bin/IstexExplorSiteShell: $(DILIB_IMPORT)/Istex/IstexExplorSiteShell.c \
                            $(DILIB)/Date/StrSearch.lib   \
                            $(DILIB)/Date/Explor.lib
	$(CC)  $(DILIB_IMPORT)/Istex/IstexExplorSiteShell.c   -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/IstexExplorSiteHtmlPhp: $(DILIB_IMPORT)/Istex/IstexExplorSiteHtmlPhp.c \
                            $(DILIB)/Date/StrSearch.lib   \
                            $(DILIB)/Date/Explor.lib
	$(CC)  $(DILIB_IMPORT)/Istex/IstexExplorSiteHtmlPhp.c   -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/IstexModsToTei: $(DILIB_IMPORT)/Istex/IstexModsToTei.c   \
                            $(DILIB)/Date/SxPath.lib            \
                            $(DILIB)/Date/Utf8.lib      \
                            $(DILIB)/Date/Tei.lib      
	$(CC)  $(DILIB_IMPORT)/Istex/IstexModsToTei.c -Wall  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/IstexToTei: $(DILIB_IMPORT)/Istex/IstexToTei.c   \
                            $(DILIB)/Date/SxPath.lib            \
                            $(DILIB)/Date/Utf8.lib      \
                            $(DILIB)/Date/Istex.lib      \
                            $(DILIB)/Date/Tei.lib      
	$(CC)  $(DILIB_IMPORT)/Istex/IstexToTei.c -Wall  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@


$(DILIB)/bin/IstexCleanFullText: $(DILIB_IMPORT)/Istex/IstexCleanFullText.c   \
                            $(DILIB)/Date/SxPath.lib            \
                            $(DILIB)/Date/Utf8.lib      \
                            $(DILIB)/Date/Istex.lib      \
                            $(DILIB)/Date/Tei.lib      
	$(CC)  $(DILIB_IMPORT)/Istex/IstexCleanFullText.c -Wall  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/IstexAffiliationSetPays: $(DILIB_IMPORT)/Istex/IstexAffiliationSetPays.c \
                           $(DILIB)/Date/Wicri.lib   \
                           $(DILIB)/Date/Utf8.lib   \
                                  $(DILIB)/Date/SxPath.lib
	$(CC)  $(DILIB_IMPORT)/Istex/IstexAffiliationSetPays.c -Wall  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/IstexCurationCountry: $(DILIB_IMPORT)/Istex/IstexCurationCountry.c \
                            $(DILIB)/Date/StrSearch.lib   \
                            $(DILIB)/Date/SxPath.lib   \
                            $(DILIB)/Date/Wicri.lib   \
                            $(DILIB)/Date/Explor.lib
	$(CC)  $(DILIB_IMPORT)/Istex/IstexCurationCountry.c -Wall  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/IstexCatXml: $(DILIB_IMPORT)/Istex/IstexCatXml.c  \
                          $(DILIB)/Date/SxPath.lib             \
                          $(DILIB)/Date/Hfd.lib
	$(CC)  $(DILIB_IMPORT)/Istex/IstexCatXml.c -Wall  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

#----------------------------------------------------------------
# data
#
$(DILIB)/Date/Istex.data:$(DILIB)/data/Istex/ExplorParam.data.tab \
                               $(DILIB)/data/Istex/IstexExplorCorpus.param.data.wiki \
                               $(DILIB)/data/Istex/IstexExplorCorpus.param.fr.wiki \
                               $(DILIB)/data/Istex/ExplorParam.en.tab  \
                               $(DILIB)/data/Istex/ExplorParam.fr.tab  \
                               $(DILIB)/data/Istex/IstexMetadataXmlCleanRules.tab  \
                               $(DILIB)/data/icons/LogoIstex.png
	$(TOUCH)

$(DILIB)/data/Istex/ExplorParam.data.tab: $(DILIB_IMPORT)/Istex/Data/IstexExplorParam.data.wiki \
                                      $(DILIB)/bin/ExplorParamFromWiki
	ExplorParamFromWiki < $(DILIB_IMPORT)/Istex/Data/IstexExplorParam.data.wiki > $@

$(DILIB)/data/Istex/IstexExplorCorpus.param.data.wiki: $(DILIB_IMPORT)/Istex/Data/IstexExplorCorpus.param.data.wiki 
	cp $(DILIB_IMPORT)/Istex/Data/IstexExplorCorpus.param.data.wiki $@

$(DILIB)/data/Istex/IstexExplorCorpus.param.fr.wiki: $(DILIB_IMPORT)/Istex/Data/IstexExplorCorpus.param.fr.wiki 
	cp $(DILIB_IMPORT)/Istex/Data/IstexExplorCorpus.param.fr.wiki $@

$(DILIB)/data/Istex/IstexMetadataXmlCleanRules.tab:  $(DILIB_IMPORT)/Istex/Data/IstexMetadataXmlCleanRules.txt  \
                                       $(DILIB)/bin/StrDictFromStream
	StrDictFromStream <  $(DILIB_IMPORT)/Istex/Data/IstexMetadataXmlCleanRules.txt > $@

$(DILIB)/data/Istex/ExplorParam.en.tab: $(DILIB_IMPORT)/Istex/Data/IstexExplorParam.en.wiki \
                                      $(DILIB)/bin/ExplorParamFromWiki
	ExplorParamFromWiki < $(DILIB_IMPORT)/Istex/Data/IstexExplorParam.en.wiki > $@

$(DILIB)/data/Istex/ExplorParam.fr.tab: $(DILIB_IMPORT)/Istex/Data/IstexExplorParam.fr.wiki \
                                      $(DILIB)/bin/ExplorParamDictFromWiki
	ExplorParamDictFromWiki < $(DILIB_IMPORT)/Istex/Data/IstexExplorParam.fr.wiki > $@

$(DILIB)/data/icons/LogoIstex.png:$(DILIB_IMPORT)/Istex/Data/LogoIstexSiteon0.png
	cp $(DILIB_IMPORT)/Istex/Data/LogoIstexSiteon0.png  $@


# ------------------ end Istex.mk ------------------------
