/*   -*- coding: utf-8 -*-  */

/**********************************************************************
*
*  module   : Istex
*  fichier  : IstexCurationCountry.c 
*  Auteur   : Jacques DUCLOY
*  Date     : fin 2013
*
***********************************************************************/

#include <stdio.h>     /* for printf */
#include <stdlib.h>    /* for exit */
#include <ctype.h>
#include <getopt.h>
#include "SxPath.h"
#include "StrSearch.h"
#include "WicriPaysFromEn.h"
#include "WicriFrance.h"
#include "WicriAllemagne.h"
#include "WicriAmerique.h"
#include "WicriRegionFromEn.h"

SxmlNode * affiliation;
SxmlNode *docInput;
SxmlNode *listAffiliations;

SxPathResult *teiPathAffiliationOld;
SxPathResult *teiPathAffiliation;

void proceedAffiliation()
{
  SxmlNode *countryNode;
  SxmlNode *regionArea;
  char *strRegionArea;
  if((countryNode=SxmlGetFirstChildByTagName(affiliation,"country"))
     &&(regionArea=SxmlGetFirstChildByTagName(affiliation,"wicri:regionArea"))
     &&(strRegionArea=SxmlLeafText(regionArea)))
    {
      char *posC1;
      char *beginRegion;
      SxmlNode *resReg;
      SxmlNode *resUniv;

      if (!WicriRegExpZip5)
	{
	  WicriRegExpZip5=RegExpCreate("[0-9][0-9][0-9][0-9][0-9]");
	}  
      posC1=strrchr(strRegionArea,',');
      if (!posC1)return;
      beginRegion=posC1+1;
      while (*beginRegion==' ')beginRegion++;
      resReg=WicriGetRegionFromSubField(affiliation, beginRegion, strRegionArea, SxmlLeafText(countryNode));
      resUniv=WicriAffiliationSetUnivFromField(affiliation, strRegionArea);
      if (resReg||resUniv)
	{
	  SxmlNode *noReg;
	  if ((noReg=SxmlGetFirstChildByTagName(affiliation, "wicri:noRegion"))) SxmlFree(noReg);
	  return;
	}
      SxmlAppendChild(affiliation, SxmlLeafCreate("wicri:noRegion", beginRegion));
    }
}

int main()
{
   teiPathAffiliationOld=SxPathSetCompile("TEI/teiHeader/fileDesc/titleStmt/author/affiliation");
   teiPathAffiliation=SxPathSetCompile("TEI/teiHeader/fileDesc/sourceDesc/biblStruct/analytic/author/affiliation");
   while ((docInput=SxmlInputNextDocumentElement()))
     { 
       if((listAffiliations=SxPathSetResultListCreate(teiPathAffiliation, docInput)))
	 {
	   while((affiliation=SxmlNodeListNextNode(listAffiliations)))
	     {
	       SxmlNode *modsAff;
	       proceedAffiliation();       
	       if ((modsAff=SxmlGetFirstChildByTagName(affiliation, "mods:affiliation"))) SxmlFree(modsAff);
	     } 
	 }
       SxmlFree(listAffiliations);
       if((listAffiliations=SxPathSetResultListCreate(teiPathAffiliationOld, docInput)))
	 {
	   while((affiliation=SxmlNodeListNextNode(listAffiliations)))
	     {
	       SxmlFree(affiliation);
	     } 
	 }
       SxmlFree(listAffiliations);
       SxmlPrint (SxmlInputRecord);
     }
   exit(EXIT_SUCCESS);
}
