/*   -*- coding: utf-8 -*-  */
/***********************************************************************
 
   Module   : Istex
   Commande : IstexExplorDataShell
   Fichier  : IstexExplorDataShell.c
   Auteur   : DUCLOY
   Date     : 2012
 
************************************************************************/

#include <stdio.h>     /* for printf */
#include <stdlib.h>    /* for exit */
#include "Explor.h"

extern char *optarg;
extern int   optind;
int getopt();

SxmlNode *ExplorStepNode;
SxmlNode *streamListSteps;
 
void generIstexShellCorpusBiblio()
{
  char *istexImportDir;
  char *istexImportFile;
  SxmlNode *listIsxtexSxmlImportFile;
  char *strListIsxtexSxmlImportFile;

  SxmlNode *listImportFile;
  char     *strImportFile;
  char     *strImportFilter;
  SxmlNode *fileNode;

  char     *strIstexImportFile;
  SxmlNode *listIstexImportFile;

  char     *strIstexModsImportFile;
  SxmlNode *listIstexModsImportFile;

  char     *strIstexImportHfd;
  SxmlNode *listIstexImportHfd;

  char     *strIstexLinkCorpus;

  printf("<?dilib file=\"%s/bin/%sCorpusBiblio.sh\" ?>\n", ExplorAreaDir, ExplorStreamCode );
  printf ("#!/bin/sh\n");
  printf ("# This shell is generated by IstexExplorDataShell \n");
  printf ("echo \"---- Executing sh %s/bin/%sCorpusBiblio.sh\" \n", ExplorAreaDir, ExplorStreamCode );

  istexImportDir=ExplorGetFromDictK3("Area", ExplorStreamCode, "Corpus/Istex:IstexImportDir"); /* deprecated */
  istexImportFile=ExplorGetFromDictK3("Area", ExplorStreamCode, "Corpus/Istex:IstexImportFile"); /* deprecated */
  strListIsxtexSxmlImportFile=ExplorGetFromDictK3("Area", ExplorStreamCode, "Corpus/Istex:IstexSxmlImportFile");  /* deprecated */
  strImportFile=ExplorGetFromDictK3("Area", ExplorStreamCode, "Corpus/importFile");  /* deprecated */

  strIstexModsImportFile=ExplorGetFromDictK3("Area", ExplorStreamCode, "Corpus/Istex:modsImportFile"); 
  strIstexImportFile=ExplorGetFromDictK3("Area", ExplorStreamCode, "Corpus/Istex:importFile"); 
  strIstexImportHfd=ExplorGetFromDictK3("Area", ExplorStreamCode, "Corpus/Istex:importHfd"); 
  strIstexLinkCorpus=ExplorGetFromDictK3("Area", ExplorStreamCode, "Corpus/Istex:linkCorpus"); 

  if (strIstexLinkCorpus)
    {
      static Buffer *bufLink=NULL;
      if (!bufLink) bufLink=NewBuffer();
      printf("ln -s %s %s/Data/%s/Corpus/biblio.hfd\n", strIstexLinkCorpus, ExplorAreaDir, ExplorStreamCode );
      BufferStrcpy (bufLink, strIstexLinkCorpus);
      BufferTailCut(bufLink,2);
      BufferStrcat(bufLink, "cs");
      printf("ln -s %s %s/Data/%s/Corpus/biblio.hcs\n", BufferString(bufLink), ExplorAreaDir, ExplorStreamCode );
      printf("ln -s $EXPLOR_AREA/Import/IstexRepository.hfd $EXPLOR_AREA/Data/%s/Corpus/repository.hfd\n", ExplorStreamCode );
      printf("ln -s $EXPLOR_AREA/Import/IstexRepository.hcs $EXPLOR_AREA/Data/%s/Corpus/repository.hcs\n", ExplorStreamCode );

      printf("<?dilib appendFile=\"%s/bin/area.mk\" ?>\n", ExplorAreaDir );
      printf("# This part is generated by IstexExplorDataShells /  generIstexShellCorpusBiblio() \n");
      printf("$(EXPLOR_AREA)/Make/%s/Corpus/biblio: \n", ExplorStreamCode);
      printf("\n\tsh $(EXPLOR_AREA)/bin/%sCorpusBiblio.sh \n", ExplorStreamCode );
      printf("\ttouch $(EXPLOR_AREA)/Make/%s/Corpus/biblio\n\n", ExplorStreamCode);
      return;
    }

  strImportFilter=ExplorGetFromDictK3("Area", ExplorStreamCode, "Corpus/importFilter");
  
  if (strListIsxtexSxmlImportFile)
    {
      listIsxtexSxmlImportFile=SxmlFromString(strListIsxtexSxmlImportFile);
    }
  else listIsxtexSxmlImportFile=NULL;
  
  
  
  printf ("( \n");
  if ( istexImportDir) printf ("cat %s/Import/%s/*.xml  | IstexModsToSxml  \n", ExplorAreaDir, istexImportDir);
  if ( istexImportFile) printf ("cat %s/Import/%s  | IstexModsToSxml  \n", ExplorAreaDir, istexImportFile);
  if ( listIsxtexSxmlImportFile )
    {
      SxmlNode *nodeFile;
      SxmlReset(listIsxtexSxmlImportFile);
      while ((nodeFile=SxmlNextNode(listIsxtexSxmlImportFile)))
	{
	  char *istexImportUnit;
	  istexImportUnit=SxmlLeafText(nodeFile);
	  printf (" cat %s/Import/%s   | IstexModsToSxml \n", ExplorAreaDir, istexImportUnit);
	}
    }
  if(strImportFile)
    {
      listImportFile=SxmlFromString(strImportFile);
      SxmlReset (listImportFile);
      while ((fileNode=SxmlNextNode(listImportFile)))
	{
	  printf ("cat %s/Import/%s  | IstexModsToSxml  \n", ExplorAreaDir, SxmlLeafText(fileNode));
	}
    }
  if(strIstexModsImportFile)
    {
      listIstexModsImportFile=SxmlFromString(strIstexModsImportFile);
      SxmlReset (listIstexModsImportFile);
      while ((fileNode=SxmlNextNode(listIstexModsImportFile)))
	{
	  printf ("cat %s/Import/%s  | IstexModsToSxml  \n", ExplorAreaDir, SxmlLeafText(fileNode));
	}
    }
  if(strIstexImportFile)
    {
      listIstexImportFile=SxmlFromString(strIstexImportFile);
      SxmlReset (listIstexImportFile);
      while ((fileNode=SxmlNextNode(listIstexImportFile)))
	{
	  printf ("cat %s/Import/%s  | IstexToSxml  \n", ExplorAreaDir, SxmlLeafText(fileNode));
	}
    }
  if(strIstexImportHfd)
    {
      listIstexImportHfd=SxmlFromString(strIstexImportHfd);
      SxmlReset (listIstexImportHfd);
      while ((fileNode=SxmlNextNode(listIstexImportHfd)))
	{
	  printf ("HfdCat %s/Import/%s.hfd  \n", ExplorAreaDir, SxmlLeafText(fileNode));
	}
    }
  printf (" )  | sort -u  \\\n");
       
  printf ("   | IstexModsToTei   \\\n");
  printf ("   | TeiPutRefToIdno -t wicri:Area/%s/Corpus  \\\n", ExplorStreamCode );
  printf ("   | HfdBuild -h %s/Data/%s/Corpus/biblio\n\n",ExplorAreaDir, ExplorStreamCode);

  printf (" echo \"==== \" %s, step Corpus, biblio done\n", ExplorStreamCode);
  printf (" HfdCat %s/Data/%s/Corpus/biblio.hfd | wc \n", ExplorAreaDir, ExplorStreamCode);

  printf("<?dilib appendFile=\"%s/bin/area.mk\" ?>\n", ExplorAreaDir );
  printf("# This part is generated by IstexExplorDataShells /  generIstexShellCorpusBiblio() \n");
  printf("$(EXPLOR_AREA)/Make/%s/Corpus/biblio: ", ExplorStreamCode); 
  if (istexImportDir) 
    {
      printf (" \\\n");
      printf("               $(EXPLOR_AREA)/Import/%s \n",  istexImportDir); 
    }
  if (istexImportFile) 
    {
      printf (" \\\n");
      printf("                %s/Import/%s \n", ExplorAreaDir, istexImportFile);
    }
  if (strImportFile)
    {
      SxmlReset (listImportFile);
      while ((fileNode=SxmlNextNode(listImportFile)))
	{
	  char *strFile;
	  printf (" \\\n");
	  strFile=SxmlLeafText(fileNode);
	  printf ("           %s/Import/%s", ExplorAreaDir, strFile);
	}
    }
  if (strIstexModsImportFile)
    {
      SxmlReset (listIstexModsImportFile);
      while ((fileNode=SxmlNextNode(listIstexModsImportFile)))
	{
	  char *strFile;
	  printf (" \\\n");
	  strFile=SxmlLeafText(fileNode);
	  printf ("           %s/Import/%s", ExplorAreaDir, strFile);
	}
    }
  if (strIstexImportFile)
    {
      SxmlReset (listIstexImportFile);
      while ((fileNode=SxmlNextNode(listIstexImportFile)))
	{
	  char *strFile;
	  printf (" \\\n");
	  strFile=SxmlLeafText(fileNode);
	  printf ("           %s/Import/%s", ExplorAreaDir, strFile);
	}
    }
  if (strIstexImportHfd)
    {
      SxmlReset (listIstexImportHfd);
      while ((fileNode=SxmlNextNode(listIstexImportHfd)))
	{
	  char *strFile;
	  printf (" \\\n");
	  strFile=SxmlLeafText(fileNode);
	  printf ("           %s/Import/%s.hcs", ExplorAreaDir, strFile);
	}
    }


  printf("\n\tsh %s/bin/%sCorpusBiblio.sh \n", ExplorAreaDir, ExplorStreamCode );
  printf("\ttouch %s/Make/%s/Corpus/biblio\n\n", ExplorAreaDir, ExplorStreamCode);

}

void generIstexShellCurationBiblio()
{
  SxmlNode *previousStep;
  char *codePrevious;

  printf("<?dilib file=\"%s/bin/%sCurationBiblio.sh\" ?>\n", ExplorAreaDir, ExplorStreamCode );
  printf ("#!/bin/sh\n");
  printf ("# This file is generated by Dilib / Istex / IstexExplorDataShell / generIstexShellCurationBiblio  \n");
  printf ("echo \"---- Executing sh %s/bin/%sCurationBiblio.sh\" \n", ExplorAreaDir, ExplorStreamCode );
  ExplorGenerDeleteHfd(ExplorStreamCode, "Curation", "biblio");
  previousStep=SxmlPreviousSibling(ExplorStepNode);
  codePrevious=SxmlLeafText(previousStep);
  printf (" HfdCat %s/Data/%s/%s/biblio.hfd \\\n", ExplorAreaDir, ExplorStreamCode, codePrevious);
  printf ("   | ExplorCleanToTei  \\\n");
  ExplorCurationRecordOperations(ExplorStreamCode, "Curation");
  printf ("   | TeiPutRefToIdno -t wicri:Area/%s/Curation  \\\n", ExplorStreamCode );
  printf ("   | IstexAffiliationSetPays    \\\n");
  printf ("   | TeiKeywordsFromTable -s KwdEn -m $DILIB/data/Wicri/Metadata/IndexGeoEn2Fr.tab -S Wicri -T geographic -L fr \\\n");
  printf ("   | TeiKeywordsFromTable -s KwdEn -m $DILIB/data/Wicri/Metadata/IndexTopicEn2Fr.tab  -S Wicri -T topic -L fr \\\n");
  printf ("   | HfdBuild -h %s/Data/%s/Curation/biblio\n\n",ExplorAreaDir, ExplorStreamCode);

  printf (" echo \"==== \" %s, step Curation, biblio done\n", ExplorStreamCode);
  printf (" HfdCat %s/Data/%s/Curation/biblio.hfd | wc \n", ExplorAreaDir, ExplorStreamCode);

  printf("<?dilib appendFile=\"%s/bin/area.mk\" ?>\n", ExplorAreaDir );
  printf("# This part is generated by IstexExplorDataShells /  generIstexShellCurationBiblio() \n");
  printf("$(EXPLOR_AREA)/Make/%s/Curation/biblio: \\\n", ExplorStreamCode); 
  printf("                $(DILIB)/data/Wicri/Metadata/BigUnivToPays.tab \\\n");
  printf("                $(EXPLOR_AREA)/Make/%s/%s.step \n", ExplorStreamCode, codePrevious);
  printf("\tsh $(EXPLOR_AREA)/bin/%sCurationBiblio.sh \n", ExplorStreamCode );
  printf("\ttouch $(EXPLOR_AREA)/Make/%s/Curation/biblio\n\n", ExplorStreamCode);

}

void generIstexShellCheckExplBiblio(char *step)
{
  printf("<?dilib file=\"%s/bin/%s%sBiblio.sh\" ?>\n", ExplorAreaDir, ExplorStreamCode, step );
  printf ("#!/bin/sh\n");
  printf ("# This file is generated by Dilib / Istex / IstexExplorDataShells / generIstexShellCheckExplBiblio  \n");
  printf ("echo \"---- Executing sh %s/bin/%s%sBiblio.sh\" \n", ExplorAreaDir, ExplorStreamCode, step );
  ExplorGenerDeleteHfd(ExplorStreamCode, step, "biblio");
  printf (" HfdCat %s/Data/%s/Curation/biblio.hfd \\\n", ExplorAreaDir, ExplorStreamCode);
  ExplorGenerBiblioFilter(ExplorStreamCode, step );
  printf ("   | IstexCurationCountry  \\\n");
  ExplorExplorationCommonOperations(ExplorStreamCode, step, 1);
  printf ("   | TeiBuildAffiliationTree    \\\n");
  ExplorGenerBuildBiblio(ExplorStreamCode, step, NULL);
  printf("<?dilib appendFile=\"%s/bin/area.mk\" ?>\n", ExplorAreaDir );
  printf("# This part is generated by IstexExplorDataShells /  generIstexShellCheckExplBiblio  \n");
  printf("$(EXPLOR_AREA)/Make/%s/%s/biblio: \\\n ", ExplorStreamCode, step);
  printf("                $(EXPLOR_AREA)/Make/%s/Curation.step \n", ExplorStreamCode);
  printf("\tsh $(EXPLOR_AREA)/bin/%s%sBiblio.sh\n", ExplorStreamCode, step );
  printf("\ttouch $(EXPLOR_AREA)/Make/%s/%s/biblio\n\n", ExplorStreamCode, step);
}

void generIstexIndexAutAff(char *step)
{
  printf("<?dilib file=\"%s/bin/%s%sIndexAutAff.i.sh\" ?>\n", ExplorAreaDir, ExplorStreamCode, step );
  printf ("#!/bin/sh\n");
  printf ("#  This shell is generated by NlmIstexExplorDataShells / generIndexAutAff\n");
  ExplorGenerDeleteHfd(ExplorStreamCode, step, "AutAff.i");
  printf ("(");
  printf (" HfdCat %s/Data/%s/%s/biblio.hfd\\\n", ExplorAreaDir, ExplorStreamCode, step);
  printf ("  | SxmlSelect -s record/TEI/teiHeader/fileDesc/titleStmt/author -p @s1 -p @1  \\\n");
  printf ("  | SgmlSelect -s author/name@uniqKey@# -p @s1 -g author/name# -p @g1   \\\n");
  printf (" -s author/affiliation/mods:affiliation author/affiliation/wicri:noCountry -p @s2  -p @2       \n\n");

  printf (" HfdCat %s/Data/%s/%s/biblio.hfd\\\n", ExplorAreaDir, ExplorStreamCode, step);
  printf ("  | SxmlSelect -s record/TEI/teiHeader/fileDesc/titleStmt/author -p @s1 -p @1  \\\n");
  printf ("  | grep -v \"</nlm:affiliation>\"     \\\n");   
  printf ("  | SgmlSelect -s author/name@uniqKey@# -p @s1 -g author/name# -p @g1   \\\n");
  printf ("          -p \"<mods:affiliation>NONE</mods:affiliation>\"   -p @2       \n\n");

  printf (" ) | sort      \\\n");
  printf ("  | SxmlGrouping | HfdBuild -h %s/Data/%s/%s/AutAff.i   \n",  ExplorAreaDir,  ExplorStreamCode, step );

  printf (" IndexBuildHid -h %s/Data/%s/%s/AutAff.i -e k   \n", ExplorAreaDir, ExplorStreamCode, step);

  printf (" HfdCat %s/Data/%s/%s/AutAff.i.hfd     \\\n", ExplorAreaDir, ExplorStreamCode, step);
  printf ("      |  SgmlSelect -g g/t# -g g/k# -p @g1 -p \"<idx><kw>@g2</kw><f>@g1</f></idx>\"     \\\n");
  printf ("      | sort -rn    \\\n");
  printf ("      | SgmlFast -c 1     \\\n");
  printf ("      | head -500 > %s/Data/%s/%s/AutAff.i.sort    \n", ExplorAreaDir, ExplorStreamCode, step);

  printf (" echo \"==== \" %s, step %s, index aut-aff done\n", ExplorStreamCode, step);
  printf (" HfdCat %s/Data/%s/%s/AutAff.i.hfd | wc \n", ExplorAreaDir, ExplorStreamCode, step);

  printf("<?dilib appendFile=\"%s/bin/area.mk\" ?>\n", ExplorAreaDir );
  printf("# This part is generated by IstexExplorDataShells / generIndexAutAff \n");
  printf("$(EXPLOR_AREA)/Make/%s/%s/AutAff.i.index:  \\\n ", ExplorStreamCode, step);
  printf("                $(EXPLOR_AREA)/Make/%s/%s/biblio \n", ExplorStreamCode, step);
  printf("\tsh $(EXPLOR_AREA)/bin/%s%sIndexAutAff.i.sh \n", ExplorStreamCode, step );
  printf("\ttouch $(EXPLOR_AREA)/Make/%s/%s/AutAff.i.index \n\n", ExplorStreamCode, step);
}

void generIstexAllShellsIndex()
{
  char *step;
  SxmlNode *stepNode;
  SxmlNode *stepListIndexes;
  SxmlNode *indexNode;

  ExplorGenerAllShellsIndex(ExplorStreamCode);
  SxmlReset (streamListSteps);
  while ((stepNode=SxmlNextNode(streamListSteps)))
    {
      step=SxmlLeafText(stepNode);
      if((stepListIndexes=SxmlFromString(ExplorGetFromDictK4("Area",ExplorStreamCode, step, "listIndexes"))))
	{
	  SxmlReset (stepListIndexes);
	  while ((indexNode=SxmlNextNode(stepListIndexes)))
	    {
	      char *indexTypeStr;
	      char *indexCode;
	      SxmlNode *indexTypeNode;
	      SxmlNode *nodeType;

	      indexCode=SxmlLeafText(indexNode);
	      indexTypeStr=ExplorGetFromDictK5 ("Area", ExplorStreamCode, step, indexCode, "indexType");
	      indexTypeNode=SxmlFromString(indexTypeStr);
	      if (strcmp(SxmlLeafText(nodeType=SxmlFirstChild(indexTypeNode)), "builtin")==0)
		{
		  if (strcmp(indexCode,"AutAff.i")==0)generIstexIndexAutAff(step);
		}
	    }
	}
    }
}


int main (int argc, char **argv) {
  int cOption;

  char *pathParamFile;

  pathParamFile=NULL;
  
   while((cOption=getopt(argc,argv,"s:t:"))!=EOF)
     {switch (cOption)
	 {
	 case 's':
	   ExplorStreamCode=optarg;
	   break;
	 case 't':
	   pathParamFile=optarg;
	   break;
	 }
     }
   
   ExplorParamInit(pathParamFile);
   streamListSteps=SxmlFromString(ExplorGetFromDictK3("Area", ExplorStreamCode, "listSteps"));
   ExplorGenerShellCreateData( ExplorStreamCode, streamListSteps);

   SxmlReset(streamListSteps);
   while ((ExplorStepNode=SxmlNextNode(streamListSteps))) 
    {
      char *stepCode;
      stepCode=SxmlLeafText(ExplorStepNode);
      if(strcmp(stepCode, "Corpus")==0)
	{
	  ExplorGenerShellCreateStep(ExplorStreamCode , stepCode);
	  generIstexShellCorpusBiblio();
	  continue;
	}
      if(strcmp(stepCode, "Curation")==0)
	{
	  ExplorGenerShellCreateStep(ExplorStreamCode , stepCode);
	  generIstexShellCurationBiblio();
	  continue;
	}
      if(strcmp(stepCode, "Checkpoint")==0)
	{
	  ExplorGenerShellCreateStep(ExplorStreamCode , stepCode);
	  generIstexShellCheckExplBiblio( "Checkpoint");
	  continue;
	}
      if(strcmp(stepCode, "Exploration")==0)
	{
	  ExplorGenerShellCreateStep(ExplorStreamCode , stepCode);
	  generIstexShellCheckExplBiblio("Exploration");
	  continue;
	}
    }
   
   /* ExplorGenerAllShellsIndex(ExplorStreamCode); */
   generIstexAllShellsIndex();
   exit(EXIT_SUCCESS);
}
