/*   -*- coding: utf-8 -*-  */

/**********************************************************************
*
*  module   : Istex
*  fichier  : IstexGenerAreaPages.c
*
***********************************************************************/

#include "ExplorGenerPages.h"

int   IstexGenerPagesCorpusSize;

char* IstexCorpusSize;
extern char *optarg;
extern int   optind;
int getopt();

int main (int argc, char **argv) 
{
  int cOption;
  SxmlNode *streamNode;

  ExplorGenerPagesInit();
  ExplorGenerPagesIstexQuery="query";
  IstexGenerPagesCorpusSize=2000;
  ExplorGenerPagesNumberOfStreams=0;
  ExplorGenerPagesParamStream("Istex");
  ExplorGenerPagesDownloadSize=2500;
  ExplorGenerPagesNumberOfDownloads=0;
  IstexCorpusSize=getenv("EXPLOR_AREA_ISTEX_SIZE");

  while((cOption=getopt(argc,argv,"a:d:D:g:h:i:mq:t:p:x:w:W:s:S:z:"))!=EOF)
    {switch (cOption)
	{
	case 'a':
	  ExplorGenerPagesAreaCode=optarg;
	  break;
	case 'd':
	  ExplorGenerPagesNumberOfDownloads=atoi(optarg);
	  break;
	case 'D':
	  ExplorGenerPagesDownloadSize=atoi(optarg);
	  break;
	case 'g':
	  ExplorGenerPagesGenericCode=optarg;
	  break;
	case 'm':
	  ExplorGenerPagesMapOption=1;
	  break;
	case 'p':
	  ExplorGenerAreaPath=optarg;
	  break;
	case 'q':
	  ExplorGenerPagesIstexQuery=optarg;
	  break;
	case 's':
	  ExplorGenerPagesParamStream(optarg);
	  break;
	case 't':
	  ExplorGenerAreaTitle=optarg;
	  break;
	case 'x':
	  ExplorGenerPagesExecCode=optarg[0];
	  break;
	case 'w':
	  ExplorGenerPagesWikiLink=optarg;
	  break;
	case 'h':
	  ExplorGenerPagesWebSite=optarg;
	  break;
	case 'S':
	  IstexGenerPagesCorpusSize=atoi(optarg);
	  break;
	case 'W':
	  ExplorGenerPagesWikiCode=optarg;
	  break;
	case 'z':
	  ExplorGenerPagesParamZoom(optarg);
	  break;
	}
    }

  if (!ExplorGenerAreaPath) ExplorGenerAreaPath=ExplorGenerPagesWikiCode;

  ExplorGenerPagesWikiMain();
  printf("Il contient [[A pour volumétrie (serveur d'exploration)::");
  printf("{{%s, Explor size|stream=Area|step=Corpus|index=biblio}}",  ExplorGenerPagesAreaCode);  
  printf("]] documents.\n");

  ExplorGenerPagesBeginNavi();
  if (ExplorGenerPagesNumberOfStreams ==1)
    {
      printf("|\n{{Explor bandeau flux|type=IstexSolo|code=Main|path=%s}}\n", ExplorGenerPagesAreaCode);
      if (IstexCorpusSize) printf("|Le corpus contient [[A pour taille ISTEX::%s]]", IstexCorpusSize);
      else  printf("|Le corpus donne accès à [[A pour taille ISTEX::]]");
      printf("  [[A pour base utilisée::ISTEX (corpus)|documents ISTEX]] ");
      printf("(et {{%s, Explor size|stream=Main|step=Exploration|index=biblio}} après curation).\n",  ExplorGenerPagesAreaCode);
    }
  else
    {
      int i;
      printf("|-\n!{{Explor icon number|n=1}}");
      printf("\n|colspan=2|\n");
      printf("\n{{Explor bandeau flux|type=IstexMulti|code=Istex|path=%s}}\n", ExplorGenerPagesAreaCode);
      printf("|Ce flux donne accès [[A pour taille ISTEX::");
      printf("{{%s, Explor size|stream=Istex|step=Corpus|index=biblio}}]]",  ExplorGenerPagesAreaCode); 
      printf (" [[A pour base utilisée::ISTEX (corpus)|documents ISTEX]] "); 
      printf("(et {{%s, Explor size|stream=Istex|step=Checkpoint|index=biblio}} après curation).\n",  ExplorGenerPagesAreaCode);
      SxmlReset(ExplorGenerPagesListStreams);
      i=1;
      while ((streamNode=SxmlNextNode(ExplorGenerPagesListStreams)))
	{
	  if (i==1){i=2;continue;}
	  ExplorGenerStreamBrowsing(i++, streamNode);
	}
      printf("|-\n!{{Explor icon number|n=%d}}Flux principal\n!", i);
      SxmlReset(ExplorGenerPagesListStreams);
      i=1;
      while ((streamNode=SxmlNextNode(ExplorGenerPagesListStreams)))
	{
	  char *streamName;
	  streamName=SxmlGetAttribute(streamNode,"name");
	  if ((strcmp(streamName,"Pmc")==0) && ExplorGenerPagesStreamNcbi) {i++;continue;}
	  if ((strcmp(streamName,"PubMed")==0) && ExplorGenerPagesStreamNcbi) {i++;continue;}
	  printf("{{Explor icon number|n=%d}}", i++);
	}
      printf("\n|{{Explor bandeau flux|type=MainMerge|code=Main|path=%s}}\n", ExplorGenerPagesAreaCode);
      printf("\n|Ce flux fusionne {{formatnum:{{%s, Explor size|stream=Area|step=Checkpoint|index=biblio}}}} références issues des étapes précédentes.\n", ExplorGenerPagesAreaCode);
      printf("Ce volume est ramené à {{formatnum:{{%s, Explor size|stream=Main|step=Merge|index=biblio}}}} après dédoublonnage par [[DOI]].\n", ExplorGenerPagesAreaCode);
      printf("Enfin, il est réduit à {{formatnum:{{%s, Explor size|stream=Main|step=Exploration|index=biblio}}}} par [[clé de dédoublonnage IDAT]].\n", ExplorGenerPagesAreaCode);
    }
  ExplorGenerNaviZooms();
  printf("|-\n|}\n");

  ExplorGenerPagesWikiMainEnd();

  ExplorGenerPagesWikiTechBegin();

  printf(";Génération des pages wikis:\n<source lang=\"sh\">\n");
  printf("source IstexGetCorpusSize -q \"%s\"\n", ExplorGenerPagesIstexQuery);

  printf(" IstexGenerAreaPages \\\n");
  printf ("       -a %s   \\\n", ExplorGenerPagesAreaCode);
  if (ExplorGenerPagesMapOption) printf ("       -m   \\\n");
  if (ExplorGenerPagesGenericCode) printf ("       -g %s   \\\n", ExplorGenerPagesGenericCode);
  /*
  if (ExplorGenerAreaPath) printf ("       -p %s   \\\n", ExplorGenerAreaPath);
  printf ("       -w %s  \\\n", ExplorGenerPagesWikiLink);
  printf ("       -W %s   \\\n", ExplorGenerPagesWikiCode);
  */
  ExplorGenerGener(1);

  ExplorGenerPagesInitDirTree(0);

  if(ExplorGenerPagesExecCode > 1)
    {
      printf ("===Sur la machine LorExplor===\n");
      printf ("<source lang=\"sh\">\n");
      printf ("newgrp wicri\n");
      printf ("source /applis/lorexplor/Dilib/init.sh\n");
      printf ("</source>\n");

      ExplorGenerPagesInitDirTree(1);
      
    }

  if (ExplorGenerPagesNumberOfDownloads!=0)
    {
      int nStepToDo;
      int totalDone;
      printf("====Récupération des corpus ISTEX====\n");
      printf (";En cas de reprise complète au niveau du téléchargement:\n");
      printf ("<source lang=\"sh\">\n");
      printf ("rm -rf $EXPLOR_AREA/Import/IstexDownload.*.h*\n");
      printf ("</source>\n");
      printf ("<source lang=\"sh\">\n");
      printf ("time IstexGetCorpus -q \"%s\" -s %d  -i $ISTEX_ID -p $ISTEX_PASS  -A \\\n", ExplorGenerPagesIstexQuery, ExplorGenerPagesDownloadSize);
      printf ("     | SxmlUnIndent     \\\n");
      printf ("     | HfdBuild -bh    $EXPLOR_AREA/Import/IstexDownload.000000\n");
      printf ("</source>\n");
      printf (":\'\'Vérification\'\'\n");
      printf ("<source lang=\"sh\">\n");
      printf ("SxmlSelect -g hfd/nrec/1 -p @g1 < $EXPLOR_AREA/Import/IstexDownload.000000.hcs\n");
      printf ("</source>\n");
      nStepToDo=ExplorGenerPagesNumberOfDownloads-1;
      totalDone=ExplorGenerPagesDownloadSize;
      while(nStepToDo--)
	{
	  printf ("<source lang=\"sh\">\n");
	  printf ("time IstexGetCorpus -q \"%s\" -f %d -s %d -A  -i $ISTEX_ID -p $ISTEX_PASS  \\\n", ExplorGenerPagesIstexQuery, totalDone, ExplorGenerPagesDownloadSize);
	  printf ("     | IstexToSxml     \\\n");
	  printf ("     | HfdBuild -bh    $EXPLOR_AREA/Import/IstexDownload.%06d\n", totalDone);
	  printf ("</source>\n");
	  printf ("<source lang=\"sh\">\n");
	  printf ("SxmlSelect -g hfd/nrec/1 -p @g1 < $EXPLOR_AREA/Import/IstexDownload.%06d.hcs\n", totalDone);
	  printf ("</source>\n");
	  totalDone+=ExplorGenerPagesDownloadSize;
	}
    }
  printf("====Construction du Repository ISTEX====\n");
  printf("<source>\ncd %s.corpus/Import\n</source>\n\n", ExplorGenerPagesAreaCode );

  printf ("''En cas de reprise au niveau du téléchargement''\n");
  printf("<source lang=\"sh\">\n");
  printf ("rm -rf Import/IstexRepository.h*\n");
  printf("\n</source>\n");
  if (ExplorGenerPagesNumberOfDownloads!=0)
    {
      int nStepToDo;
      int totalDone;
      totalDone=0;
      nStepToDo=ExplorGenerPagesNumberOfDownloads;
      printf("<source lang=\"sh\">\n");
      printf("(\n");
      while(nStepToDo--)
	{
	  printf("  HfdCat $EXPLOR_AREA/Import/IstexDownload.%06d.hfd\n", totalDone);
	  totalDone+=ExplorGenerPagesDownloadSize;
	}
      printf(" )    | SgmlFast -c 1 \\\n        | HfdBuild -bh    $EXPLOR_AREA/Import/IstexRepository\n"); 
      printf("\n</source>\n");
    }
  else
    {
      printf("<source lang=\"sh\">\n");
      /*
      printf("IstexGetCorpus -q \"%s\" -s %d -A  -i $ISTEX_ID -p $ISTEX_PASS   \\\n", ExplorGenerPagesIstexQuery,  IstexGenerPagesCorpusSize);
      */
      printf("IstexGetCorpus -q \"%s\" -s %d    -l          \\\n", ExplorGenerPagesIstexQuery,  IstexGenerPagesCorpusSize);
      printf("     | IstexGetCorpusById -A -t $ISTEX_TOKEN  \\\n");
      printf("     | SxmlUnIndent                           \\\n");
      printf("     | HfdBuild -bh   Import/IstexRepository\n"); 
      printf("\n</source>\n");
    }

  printf ("Vérification\n");
  printf("<source lang=\"sh\">\n");
  printf("HfdCat  Import/IstexRepository.hfd | wc\n");
  printf("\n</source>\n");

  if (ExplorGenerPagesExecCode =='1')
    {
      printf("====Préparation au transfert====\n<source lang=\"sh\">\n");
      printf ("tar -cvf Import.tar Import\n");
      printf ("gzip Import.tar\n");
      printf("</source>\n");
      printf("===Retour vers la machine de développement===\n====Transfert par scp====\n<source lang=\"sh\">\n");
      printf ("scp $ISTEX_SCP:$WICRI_TARGET_ROOT/%s/explor/%s.storage/%s.corpus/Import.tar.gz .\n", ExplorGenerAreaPath, ExplorGenerPagesGenericCode, ExplorGenerPagesAreaCode  );
      printf ("gunzip Import.tar.gz\n");
     printf ("tar -xvf Import.tar \n");
      printf("</source>\n");
    }

  printf("====Construction des métadonnées ISTEX====\n");
  printf (";ISTEX, création du HFD Corpus Biblio:En cas de reprise:\n");
  printf("<source lang=\"sh\">\n");
  printf ("rm -rf $EXPLOR_AREA/Import/IstexMetadata.h*\n");
  printf("\n</source>\n");


  printf (";Construction corpus biblio:\n");
  printf("<source lang=\"sh\">\n");
  printf("HfdCat $EXPLOR_AREA/Import/IstexRepository.hfd   \\\n");
  printf("  | SgmlFast -c1                                 \\\n");
  printf("  | IstexToTei                                   \\\n");
  printf("  | IstexCleanFullText                           \\\n");
  if (ExplorGenerPagesNumberOfStreams==1) printf("  | TeiPutRefToIdno -t wicri:Area/Main/Corpus  -c ISTEX -s Corpus -S Main \\\n");
  else  printf("  | TeiPutRefToIdno -t wicri:Area/Istex/Corpus  -c ISTEX -s Corpus -S Istex \\\n");
  printf("  | HfdBuild -h $EXPLOR_AREA/Import/IstexMetadata\n");
  printf("\n</source>\n");

  if (ExplorGenerPagesNumberOfStreams > 1)
    {
      printf ("====Téléchargement des autres corpus====\n");
      if (ExplorGenerPagesStreamPubMed)
	{
	  printf(";PubMed:\n");
          printf("Site : http://www.ncbi.nlm.nih.gov/pubmed\n\n");
	  printf("Requête :\n\n");
	  printf("Ranger le résultat dans $EXPLOR_AREA/Import/pubmed_result.xml\n");
	}
      if (ExplorGenerPagesStreamPmc)
	{
	  printf(";PubMed Central:\n");
          printf("Site : http://www.ncbi.nlm.nih.gov/pmc\n\n");
	  printf("Requête :\n\n");
	  printf("Ranger le résultat dans $EXPLOR_AREA/Import/pmc_result.xml\n");
	}
      if (ExplorGenerPagesStreamStanalyst)
	{
	  printf(";%s:\n", ExplorGenerPagesStreamStanalystName);
          printf("Site :http://stan2.demo.inist.fr/fr/\n\n");
	  printf("Requête :\n\n");
	  printf("Télécharger avec les onglets : Serveur / SGML / SGML / LF\n*résultat dans $EXPLOR_AREA/Import\n");
	  printf("  mv $EXPLOR_AREA/Import/corpus.txt $EXPLOR_AREA/Import/inistServer.txt \n");
	  printf("Télécharger avec les onglets : SGML / SGML / SGML / LF\n*résultat dans $EXPLOR_AREA/Import\n");
	  printf("  mv $EXPLOR_AREA/Import/corpus.txt $EXPLOR_AREA/Import/inistStandard.txt \n");
	}
      if (ExplorGenerPagesStreamHal)
	{
	  printf(";Hal:\n");
	  printf("Sur : https://hal.archives-ouvertes.fr/\n");
	}
      if (ExplorGenerPagesStreamHalInra)
	{
	  printf(";HalInra:\n");
	  printf("Sur : http://prodinra.inra.fr/\n");
	}
    }

  ExplorGenerPagesWikiTechCompilArea();
  ExplorGenerPagesGenerFtp(0);

  if (ExplorGenerPagesExecCode <'2')
    {
      printf("====Transfert vers la machine LorExplor====\n<source lang=\"sh\">\n");
      printf("scp Site.tar.gz $ISTEX_SCP:$WICRI_TARGET_ROOT/%s/explor/%s.storage/%s.new\n", ExplorGenerAreaPath, ExplorGenerPagesGenericCode, ExplorGenerPagesAreaCode );
      printf("scp Data.tar.gz $ISTEX_SCP:$WICRI_TARGET_ROOT/%s/explor/%s.storage/%s.new\n", ExplorGenerAreaPath, ExplorGenerPagesGenericCode, ExplorGenerPagesAreaCode );
      printf("scp ImportMetadata.tar.gz $ISTEX_SCP:$WICRI_TARGET_ROOT/%s/explor/%s.storage/%s.new\n", ExplorGenerAreaPath, ExplorGenerPagesGenericCode, ExplorGenerPagesAreaCode );
      printf("</source>\n");
    }

  ExplorGenerPagesTargetInit();

  printf(";Transfert par FileZilla:\n");
  printf("Transférer les fichiers Site.tar.gz, Data.tar.gz de %s (émetteur) vers %s (cible).\n", ExplorGenerPagesAreaCode, ExplorGenerPagesAreaCode);

  ExplorGenerPagesTargetInstall();
  printf("<source lang=\"sh\">\n");
  printf("\ngunzip ImportMetadata.tar.gz \n");
  printf("tar -xvf ImportMetadata.tar \n");
  printf("gzip ImportMetadata.tar \n");
  
  if (ExplorGenerPagesNumberOfStreams ==1)printf("\ncd Data/Main/Corpus \n");
  else printf("\ncd Data/Istex/Corpus \n");
  printf("rm biblio.hcs \n");
  printf("rm biblio.hfd \n");
  printf("ln -s ../../../Import/istexMetadata.hcs biblio.hcs \n");
  printf("ln -s ../../../Import/istexMetadata.hfd biblio.hfd \n");
  printf("</source>\n");

  ExplorGenerPagesWikiDiscussionBegin();
  ExplorGenerPagesWikiDiscussionIndexCuration();

  ExplorGenerPagesWikiDataBegin();
  if (ExplorGenerPagesNumberOfStreams==1)
    {
      printf("|-\n|listStreams\n|Area\n|Main");
      ExplorGenerPagesGenerListZooms();
      /*
      SxmlReset(ExplorGenerPagesListZooms);
      while ((streamNode=SxmlNextNode(ExplorGenerPagesListZooms)))
	{
	  char *streamName;
	  streamName=SxmlGetAttribute(streamNode,"name");
	  printf("; %s ",streamName); 
	}
      */
      putchar('\n');
      printf("|-\n|typeStream\n|Area/Main\n|Istex:IstexSolo \n");
    }
  else
    {
      printf("|-\n|listStreams\n|Area\n|");
      SxmlReset(ExplorGenerPagesListStreams);
      while ((streamNode=SxmlNextNode(ExplorGenerPagesListStreams)))
	{
	  char *streamName;
	  streamName=SxmlGetAttribute(streamNode,"name");
	  printf("%s ;",streamName); 
	}
      printf("Main");
      SxmlReset(ExplorGenerPagesListZooms);
      while ((streamNode=SxmlNextNode(ExplorGenerPagesListZooms)))
	{
	  char *streamName;
	  streamName=SxmlGetAttribute(streamNode,"name");
	  printf("; %s ",streamName); 
	}
      printf("\n|-\n|typeStream\n|Area/Main\n|Explor:MainMerge\n");
      printf("|-\n|typeStream\n|Area/Istex\n|Istex:IstexMulti \n");
      if (ExplorGenerPagesStreamPubMed)printf("|-\n|typeStream\n|Area/PubMed\n|Nlm:Medline \n");
      if (ExplorGenerPagesStreamPmc)printf("|-\n|typeStream\n|Area/Pmc\n|Nlm:Pmc \n");
      if (ExplorGenerPagesStreamHal)printf("|-\n|typeStream\n|Area/Hal\n|Ccsd:HalV3 \n");
      if (ExplorGenerPagesStreamHalInra)printf("|-\n|typeStream\n|Area/HalInra\n|Inra:HalInra \n");
      if (ExplorGenerPagesStreamNcbi)printf("|-\n|typeStream\n|Area/Ncbi\n|Nlm:Ncbi \n");
      if (ExplorGenerPagesStreamStanalyst) 
	{
	  if (strcmp(ExplorGenerPagesStreamStanalystName, "Pascal")==0)
	    printf("|-\n|typeStream\n|Area/%s\n|Inist:StanPascal \n", ExplorGenerPagesStreamStanalystName);
	  else printf("|-\n|typeStream\n|Area/%s\n|Inist:Stanalyst \n", ExplorGenerPagesStreamStanalystName);
	}
      printf("|-\n|mergingList\n|Area/Main\n|");

      SxmlReset(ExplorGenerPagesListStreams);
      while ((streamNode=SxmlNextNode(ExplorGenerPagesListStreams)))
	{
	  char *streamName;
	  streamName=SxmlGetAttribute(streamNode,"name");
	  if ((strcmp(streamName,"Pmc")==0) && ExplorGenerPagesStreamNcbi) continue;
	  if ((strcmp(streamName,"PubMed")==0) && ExplorGenerPagesStreamNcbi) continue;
	  if (SxmlNextSibling(streamNode))printf("%s ; ",streamName); 
	  else printf("%s\n",streamName); 
	}
    }
  if (ExplorGenerPagesStreamNcbi)printf("|-\n|mergingList\n|Area/Ncbi\n|PubMed ; Pmc \n");
  ExplorGenerPagesGenerListTypesZoom();
  printf("|-\n|}\n");
            /* to put in tools */
  printf("==Corpus==\n{| class=\"wikitable sortable\"\n|-\n!type\n!rubrique\n!valeur\n");
  if (ExplorGenerPagesNumberOfStreams==1)
    printf("|-\n|Istex:linkCorpus\n|Area/Main/Corpus\n|$EXPLOR_AREA/Import/IstexMetadata.hfd \n");
  else
    {
      printf("|-\n|Istex:linkCorpus\n|Area/Istex/Corpus\n|$EXPLOR_AREA/Import/IstexMetadata.hfd \n");
      if (ExplorGenerPagesStreamPubMed) printf("|-\n|importFile\n|Area/PubMed/Corpus\n|pubmed_result.xml\n");
      if (ExplorGenerPagesStreamPmc) printf("|-\n|importFile\n|Area/Pmc/Corpus\n|pmc_result.xml\n");
      if (ExplorGenerPagesStreamHal) printf("|-\n|Ccsd:teiImportFile\n|Area/Hal/Corpus\n|api.archives-ouvertes.fr.xml\n");
      if (ExplorGenerPagesStreamStanalyst) 
	{
	  printf("|-\n|Inist:standardImportFile\n|Area/%s/Corpus\n|inistStandard.txt\n", ExplorGenerPagesStreamStanalystName);
	  printf("|-\n|Inist:serveurImportFile\n|Area/%s/Corpus\n|inistServer.txt\n", ExplorGenerPagesStreamStanalystName);
	}
    }
  printf("|-\n|}\n");

  ExplorGenerPagesWikiDataEnd();
  ExplorGenerPagesWikiNaviBegin();
  printf("|-\n|areaRootIntroduction\n|Area\n|");
  printf("<h2>Plateforme %s</h2>\n", ExplorGenerAreaTitle);
  printf("<p>Cette page introduit une application générée par des moyens automatiques à partir d'un corpus ISTEX. Dans un contexte monobase, cette page n\'est pas significative</p>");
  printf("\n");
  printf("|-\n|streamIntroduction\n|Area/Main\n|");
  printf("<h2>Flux principal %s</h2>\n", ExplorGenerAreaTitle);
  printf( "<p>Cette page introduit une chaine d'étapes générée par des moyens automatiques pour faciliter l\'analyse de contenus extraits de corpus ISTEX</p>");
  printf("\n");
  printf("|-\n|stepIntroduction\n|Area/Main/Exploration\n|");
  printf("<h2>%s</h2>\n", ExplorGenerAreaTitle);
  printf("<p>Cette page introduit un portail d'exploration généré par des moyens automatiques pour faciliter l\'analyse des contenus issus de corpus ISTEX </p>");
  printf("\n");

  ExplorGenerPagesWikiNaviEnd();

  ExplorGenerPagesMap();

  ExplorGenerPagesWikiTemplateSize();

  ExplorGenerPagesWikiTemplateInclude();

  exit(EXIT_SUCCESS);
}
