
#   Module : Loria
#   Fichier : Loria.mk
#

include  $(DILIB)/MakeDef.mk

$(DILIB)/Date/Loria.mod: $(DILIB)/Date/Loria.data \
                         $(DILIB)/Date/Loria.bin
	$(TOUCH)

#----------------------------------------------------------------
# bin
#

$(DILIB)/Date/Loria.bin: $(DILIB)/bin/LoriaCrinExplorDataShells    \
                         $(DILIB)/bin/LoriaCrinExplorSiteHtmlPhp   \
                         $(DILIB)/bin/LoriaCrinExplorSiteShell    \
                         $(DILIB)/bin/LoriaCrinClean
	$(TOUCH)

$(DILIB)/bin/LoriaCrinExplorDataShells: $(DILIB_IMPORT)/Loria/LoriaCrinExplorDataShells.c \
                            $(DILIB)/Date/StrSearch.lib   \
                            $(DILIB)/Date/Explor.lib
	$(CC)  $(DILIB_IMPORT)/Loria/LoriaCrinExplorDataShells.c -Wall  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/LoriaCrinExplorSiteShell: $(DILIB_IMPORT)/Loria/LoriaCrinExplorSiteShell.c \
                            $(DILIB)/Date/StrSearch.lib   \
                            $(DILIB)/Date/Explor.lib
	$(CC)  $(DILIB_IMPORT)/Loria/LoriaCrinExplorSiteShell.c -Wall  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/LoriaCrinExplorSiteHtmlPhp: $(DILIB_IMPORT)/Loria/LoriaCrinExplorSiteHtmlPhp.c \
                            $(DILIB)/Date/StrSearch.lib   \
                            $(DILIB)/Date/Explor.lib
	$(CC)  $(DILIB_IMPORT)/Loria/LoriaCrinExplorSiteHtmlPhp.c -Wall  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

 $(DILIB)/bin/LoriaCrinClean:  $(DILIB_IMPORT)/Loria/LoriaCrinClean.lex
	$(LEX) $(DILIB_IMPORT)/Loria/LoriaCrinClean.lex
	$(CC) lex.yy.c -ll -o  $@

#----------------------------------------------------------------
# data
#
$(DILIB)/Date/Loria.data : $(DILIB)/data/Loria/LoriaCrinExplorParam.data.tab \
                           $(DILIB)/data/Loria/LoriaCrinExplorParam.fr.tab   \
                           $(DILIB)/data/Loria/LoriaCrinExplorParam.en.tab   \
                           $(DILIB)/data/icons/Logo_LORIA.jpeg
	$(TOUCH)

$(DILIB)/data/Loria/LoriaCrinExplorParam.data.tab: $(DILIB_IMPORT)/Loria/Data/LoriaCrinExplorParam.data.wiki \
                                      $(DILIB)/bin/ExplorParamDictFromWiki
	ExplorParamDictFromWiki <  $(DILIB_IMPORT)/Loria/Data/LoriaCrinExplorParam.data.wiki  > $@

$(DILIB)/data/Loria/LoriaCrinExplorParam.en.tab: $(DILIB_IMPORT)/Loria/Data/LoriaCrinExplorParam.en.wiki \
                                      $(DILIB)/bin/ExplorParamDictFromWiki
	ExplorParamDictFromWiki <  $(DILIB_IMPORT)/Loria/Data/LoriaCrinExplorParam.en.wiki  > $@

$(DILIB)/data/Loria/LoriaCrinExplorParam.fr.tab: $(DILIB_IMPORT)/Loria/Data/LoriaCrinExplorParam.fr.wiki \
                                      $(DILIB)/bin/ExplorParamDictFromWiki
	ExplorParamDictFromWiki <  $(DILIB_IMPORT)/Loria/Data/LoriaCrinExplorParam.fr.wiki  > $@

$(DILIB)/data/icons/Logo_LORIA.jpeg: $(DILIB_IMPORT)/Loria/Data/Logo_LORIA.jpeg
	cp $(DILIB_IMPORT)/Loria/Data/Logo_LORIA.jpeg $@

#--------------------------- End Loria.mk ---------------------------
