/*   -*- coding: utf-8 -*-  */
/***********************************************************************
 
   Module   : Loria
   Commande : LoriaCrinExplorDataShells
   Fichier  : LoriaCrinExplorDataShells.c
   Auteur   : Ducloy
   Date     : 2016
 
************************************************************************/

#include <stdio.h>     /* for printf */
#include <stdlib.h>    /* for exit */
#include "Explor.h"

extern char *optarg;
extern int   optind;
int getopt();

SxmlNode *ExplorStepNode;
SxmlNode *ExplorStreamListSteps;

void generLoriaCrinShellCorpusBiblio()
{
  SxmlNode *listSxmlImportFile;
  char     *strListSxmlImportFile;
  SxmlNode *fileNode;
  int inputMode; /* 'b' BibTex ; 't' : Tei */

  printf("<?dilib file=\"%s/bin/%sCorpusBiblio.sh\" ?>\n", ExplorAreaDir, ExplorStreamCode );
  printf ("#!/bin/sh\n");
  printf ("# This file is generated by Dilib / LoriaCrin / LoriaCrinExplorDataShells \n");
  printf ("echo \"---- Executing sh %s/bin/%sCorpusBiblio.sh\" \n", ExplorAreaDir, ExplorStreamCode );
  ExplorGenerDeleteHfd (ExplorStreamCode, "Corpus", "biblio");               /* if update */
  inputMode='b';
  strListSxmlImportFile=ExplorGetFromDictK3("Area", ExplorStreamCode, "Corpus/importFile");
  if (!strListSxmlImportFile)
     {
       strListSxmlImportFile=ExplorGetFromDictK3("Area", ExplorStreamCode, "Corpus/Loria:teiImportFile");
       inputMode='t';
       if (!strListSxmlImportFile)
	 {
	   fprintf(stderr, "parameter * Area/%s/Corpus/importFile * is missing\n", ExplorStreamCode);
	   exit(EXIT_FAILURE);
	 }
     }
  listSxmlImportFile=SxmlFromString(strListSxmlImportFile);
  printf (" (\n");
  SxmlReset (listSxmlImportFile);
  while ((fileNode=SxmlNextNode(listSxmlImportFile)))
     {
        printf ("cat %s/Import/%s   \n", ExplorAreaDir, SxmlLeafText(fileNode));
     }
  if (inputMode=='b')
    {
      printf (" ) | BibtexToSxml  \\\n"); 
      printf ("   | LoriaCrinClean  \\\n"); 
      printf ("   | BibtexToSxmlTei  \\\n"); 
      printf ("   | TeiPutRefToIdno -t wicri:Area/%s/Corpus  \\\n", ExplorStreamCode );
    }
  else
    {
      printf (" )  | TeiPutRefToIdno -u wicri:Area/%s/Corpus  \\\n", ExplorStreamCode );
    }
  printf ("   | HfdBuild -h %s/Data/%s/Corpus/biblio\n\n",ExplorAreaDir, ExplorStreamCode);

  printf (" echo \"==== \" %s, step Corpus, biblio done\n", ExplorStreamCode);
  printf (" HfdCat %s/Data/%s/Corpus/biblio.hfd | wc \n", ExplorAreaDir, ExplorStreamCode);

  printf("<?dilib appendFile=\"%s/bin/area.mk\" ?>\n", ExplorAreaDir );
  printf("# This part is generated by Dilib / LoriaCrin / LoriaCrinExplorDataShells \n");
  printf("%s/Make/%s/Corpus/biblio: ", ExplorAreaDir, ExplorStreamCode);
  SxmlReset (listSxmlImportFile);
  while ((fileNode=SxmlNextNode(listSxmlImportFile)))
     {
	printf (" \\\n");
        printf ("         %s/Import/%s   ", ExplorAreaDir, SxmlLeafText(fileNode));
     }
  printf("\n\tsh %s/bin/%sCorpusBiblio.sh \n", ExplorAreaDir, ExplorStreamCode );
  printf("\ttouch %s/Make/%s/Corpus/biblio\n\n", ExplorAreaDir, ExplorStreamCode);
}

void generLoriaCrinShellCurationBiblio()
{
  SxmlNode *previousStep;
  char     *codePrevious;

  printf("<?dilib file=\"%s/bin/%sCurationBiblio.sh\" ?>\n", ExplorAreaDir, ExplorStreamCode );
  printf ("#!/bin/sh\n");
  printf ("# This shell has been generated by LoriaCrinExplorDataShells \n");
  printf ("echo \"---- Executing sh %s/bin/%sCurationBiblio.sh\" \n", ExplorAreaDir, ExplorStreamCode );
  ExplorGenerDeleteHfd(ExplorStreamCode, "Curation", "biblio");
  previousStep=SxmlPreviousSibling(ExplorStepNode);
  codePrevious=SxmlLeafText(previousStep);
  printf (" HfdCat %s/Data/%s/%s/biblio.hfd \\\n", ExplorAreaDir, ExplorStreamCode, codePrevious);
  printf ("   | SgmlFast -c 1  \\\n");
  ExplorGenerBuildBiblio(ExplorStreamCode, "Curation", NULL);

  printf("<?dilib appendFile=\"%s/bin/area.mk\" ?>\n", ExplorAreaDir );
  printf("# This part is generated by LoriaCrinExplorDataShells /  generNlmMedlineShellCurationBiblio() \n");
  printf("%s/Make/%s/Curation/biblio: \\\n", ExplorAreaDir, ExplorStreamCode);
  printf("                %s/Make/%s/%s.step \n", ExplorAreaDir, ExplorStreamCode, codePrevious);
  printf("\tsh %s/bin/%sCurationBiblio.sh \n", ExplorAreaDir, ExplorStreamCode );
  printf("\ttouch %s/Make/%s/Curation/biblio\n\n", ExplorAreaDir, ExplorStreamCode);
}

void generLoriaCrinShellCheckExplBiblio(char *step)
{
  printf("<?dilib file=\"%s/bin/%s%sBiblio.sh\" ?>\n", ExplorAreaDir, ExplorStreamCode, step );
  printf ("#!/bin/sh\n");
  printf ("# This file is generated by Dilib / LoriaCrin / LoriaCrinExplorDataShells / generLoriaCrinShellCheckExplBiblio  \n");
  printf ("echo \"---- Executing sh %s/bin/%s%sBiblio.sh\" \n", ExplorAreaDir, ExplorStreamCode, step );
  ExplorGenerDeleteHfd(ExplorStreamCode, step, "biblio");
  printf (" HfdCat %s/Data/%s/Curation/biblio.hfd \\\n", ExplorAreaDir, ExplorStreamCode);
  /* printf ("   | SgmlFast -c 1  \\\n"); */
  ExplorExplorationCommonOperations(ExplorStreamCode, step, 1);
  ExplorGenerBuildBiblio(ExplorStreamCode, step, NULL);

  printf("<?dilib appendFile=\"%s/bin/area.mk\" ?>\n", ExplorAreaDir );
  printf("# This part is generated by LoriaCrinExplorDataShells /  generLoriaCrinShellCheckExplBiblio  \n");
  printf("%s/Make/%s/%s/biblio: \\\n ", ExplorAreaDir, ExplorStreamCode, step);
  printf("                %s/Make/%s/Curation.step \n", ExplorAreaDir, ExplorStreamCode);
  printf("\tsh %s/bin/%s%sBiblio.sh\n", ExplorAreaDir, ExplorStreamCode, step );
  printf("\ttouch %s/Make/%s/%s/biblio\n\n", ExplorAreaDir, ExplorStreamCode, step);
}


int main (int argc, char **argv) 
{
   int cOption;
   char *pathParamFile;

   pathParamFile=NULL;
   ExplorStreamCode=NULL;

   while((cOption=getopt(argc,argv,"s:t:"))!=EOF)
     {switch (cOption)
	 {
	 case 's':
	   ExplorStreamCode=optarg;
	   break;
	 case 't':
	   pathParamFile=optarg;
	   break;
	 }
     }
   if ((!pathParamFile)|| (!ExplorStreamCode)) 
     {
         perror("**** Options -s stream and -t paramFile are mandatory\n");
         exit (EXIT_FAILURE);
     }
   ExplorParamInit(pathParamFile);
   ExplorStreamListSteps=SxmlFromString(ExplorGetFromDictK3("Area", ExplorStreamCode, "listSteps"));
   ExplorGenerShellCreateData( ExplorStreamCode, ExplorStreamListSteps);

   SxmlReset(ExplorStreamListSteps);
   while ((ExplorStepNode=SxmlNextNode(ExplorStreamListSteps)))
    {
      char *stepCode;
      stepCode=SxmlLeafText(ExplorStepNode);
      if(strcmp(stepCode, "Corpus")==0)
	{
	  ExplorGenerShellCreateStep(ExplorStreamCode , stepCode);
	  generLoriaCrinShellCorpusBiblio();
	  continue;
	}
     else if(strcmp(stepCode, "Curation")==0)
	{
	  ExplorGenerShellCreateStep(ExplorStreamCode , stepCode);
	  generLoriaCrinShellCurationBiblio();
	  continue;
	}
     else if(strcmp(stepCode, "Checkpoint")==0)
	{
	  ExplorGenerShellCreateStep(ExplorStreamCode , stepCode);
	  generLoriaCrinShellCheckExplBiblio(stepCode);
	  continue;
	}
    else if(strcmp(stepCode, "Exploration")==0)
	{
	  ExplorGenerShellCreateStep(ExplorStreamCode , stepCode);
	  generLoriaCrinShellCheckExplBiblio(stepCode);
	  continue;
	}
    }
   ExplorGenerAllShellsIndex(ExplorStreamCode);
   exit (EXIT_SUCCESS);
}
