/*   -*- coding: utf-8 -*-  */

/***********************************************************************
*
*               Module   : MediaWiki
*               Fichier  : MediaWikiExportTools.c
*               Auteur   : Jacques Ducloy
*               Date     : Février 2015
*
************************************************************************
*
* Copyleft 2015 LorExplor 
* 
************************************************************************/

#include <stdio.h>     /* for printf */
#include <stdlib.h>    /* for exit */
#include <getopt.h>
#include <time.h>
#include <math.h>
#include "StrDict.h"
#include "SxmlNode.h"
#include "MediaWiki.h"

void MediaWikiExportFileBegin()
{
                          /* sth like copy/paste from an export MediWiki */
  printf ("<mediawiki xmlns=\"http://www.mediawiki.org/xml/export-0.8/\"\n"); 
  printf ("   xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" \n"); 
  printf ("   xsi:schemaLocation=\"http://www.mediawiki.org/xml/export-0.8/ http://www.mediawiki.org/xml/export-0.8.xsd\" \n"); 
  printf ("   version=\"0.8\"\n" );
  printf ("   xml:lang=\"fr\">\n");
}

void MediaWikiExportFileEnd()
{
  printf ("</mediawiki>\n");
}

time_t  MediaWikiTimeDay;
struct tm * MediaWikiTmDay;
char  MediaWikiStrDate[200];

void MediaWikiExportPageBegin(char *title, char *user, char *date)
{
  printf("<page>\n");
  printf("<title>%s</title>\n", title);
  printf("<revision>\n");
  MediaWikiTimeDay=time(NULL);
  MediaWikiTmDay=gmtime(&MediaWikiTimeDay);
  strftime(MediaWikiStrDate, 200, "%FT%TZ", MediaWikiTmDay);
  printf("<timestamp>%s</timestamp>\n", MediaWikiStrDate);
  printf("<contributor><username>%s</username></contributor>\n", user);
  printf("<text xml:space=\"preserve\">\n");
}


void MediaWikiExportPageEnd()
{
  printf("</text>\n");
  printf("</revision>\n");
  printf("</page>\n");
  }

void MediaWicriExplorPrintElement(SxmlNode *element)
{
  SxmlNode *child;
  printf ("%clt;%s%cgt;", '&', SxmlNodeName(element), '&');
  while ((child=SxmlNextNode(element)))
    {
      if (SxmlIsText(child)) 
	{
	  printf("%s",SxmlNodeValue(child));
	  continue;
	}
      MediaWicriExplorPrintElement(child);
    }
    printf ("%clt;/%s%cgt;", '&', SxmlNodeName(element), '&'); 
}

void MediaWicriExplorPrintElementContent(SxmlNode *element)
{
  SxmlNode *child;
  
  while ((child=SxmlNextNode(element)))
    {
      if (SxmlIsText(child)) 
	{
	  printf("%s",SxmlNodeValue(child));
	  continue;
	}
      MediaWicriExplorPrintElement(child);
    }
  
}

