
#   Module  : Nlm
#   Fichier : Nlm.mk
#
 
include  $(DILIB)/MakeDef.mk

$(DILIB)/Date/Nlm.mod: $(DILIB)/Date/Nlm.data         \
                            $(DILIB)/Date/Nlm.include \
                            $(DILIB)/Date/Nlm.lib     \
                            $(DILIB)/Date/Nlm.bin 
	$(TOUCH)

#----------------------------------------------------------------
# include files
#

$(DILIB)/Date/Nlm.include: $(DILIB)/include/Nlm.h
	$(TOUCH)

$(DILIB)/include/Nlm.h: $(DILIB_IMPORT)/Nlm/Nlm.h  \
                        $(DILIB)/include/SxmlNode.h
	cp $(DILIB_IMPORT)/Nlm/Nlm.h $@

#--------------------------------------------------------------------
# Dilib library
#

$(DILIB)/Date/Nlm.lib:  $(DILIB)/Date/NlmCurl.o
	$(RANLIB) $(DILIB)/lib/libDilib.a
	$(TOUCH)

$(DILIB)/Date/NlmCurl.o:$(DILIB_IMPORT)/Nlm/NlmCurl.c       \
                                 $(DILIB)/include/Nlm.h     \
                                 $(DILIB)/include/Buffer.h
	$(CC) $(DILIB_IMPORT)/Nlm/NlmCurl.c   -I$(DILIB)/include      \
	      -c -o NlmCurl.o
	ar ruv  $(DILIB)/lib/libDilib.a   NlmCurl.o
	$(TOUCH)

#----------------------------------------------------------------
# data
#

$(DILIB)/Date/Nlm.data:$(DILIB)/data/Nlm/MedlineExplorParam.data.tab  \
                              $(DILIB)/data/Nlm/MedlineExplorParam.en.tab  \
                              $(DILIB)/data/Nlm/MedlineExplorParam.fr.tab  \
                              $(DILIB)/data/Nlm/PmcExplorParam.data.tab     \
                              $(DILIB)/data/Nlm/PmcExplorParam.en.tab     \
                              $(DILIB)/data/Nlm/PmcExplorParam.fr.tab     \
                              $(DILIB)/data/Nlm/NcbiExplorParam.data.tab \
                              $(DILIB)/data/Nlm/NcbiExplorParam.en.tab  \
                              $(DILIB)/data/Nlm/NcbiExplorParam.fr.tab \
                              $(DILIB)/data/icons/LogoPubMed.png       \
                              $(DILIB)/data/icons/LogoNcbi.png       \
                              $(DILIB)/data/Nlm/Geo2WicriFr.tab     \
                              $(DILIB)/data/icons/LogoPmc.gif
	$(TOUCH)


$(DILIB)/data/Nlm/Geo2WicriFr.tab: $(DILIB_IMPORT)/Nlm/NlmCreateGeoFR.sh  \
                                    $(DILIB_IMPORT)/Wicri/Data/Iso3166.wiki \
                                    $(DILIB_IMPORT)/Wicri/Data/Iso3166En.wiki \
                                    $(DILIB)/Date/MediaWiki.bin
	sh  $(DILIB_IMPORT)/Nlm/NlmCreateGeoFR.sh

$(DILIB)/data/Nlm/MedlineExplorParam.data.tab: $(DILIB_IMPORT)/Nlm/Data/NlmMedlineExplorParam.data.wiki \
                  $(DILIB)/bin/ExplorParamFromWiki
	ExplorParamFromWiki < $(DILIB_IMPORT)/Nlm/Data/NlmMedlineExplorParam.data.wiki > $@

$(DILIB)/data/Nlm/MedlineExplorParam.en.tab: $(DILIB_IMPORT)/Nlm/Data/NlmMedlineExplorParam.en.wiki \
                  $(DILIB)/bin/ExplorParamFromWiki
	ExplorParamFromWiki < $(DILIB_IMPORT)/Nlm/Data/NlmMedlineExplorParam.en.wiki > $@

$(DILIB)/data/Nlm/MedlineExplorParam.fr.tab: $(DILIB_IMPORT)/Nlm/Data/NlmMedlineExplorParam.fr.wiki \
                  $(DILIB)/bin/ExplorParamFromWiki
	ExplorParamFromWiki < $(DILIB_IMPORT)/Nlm/Data/NlmMedlineExplorParam.fr.wiki > $@

$(DILIB)/data/Nlm/PmcExplorParam.data.tab: $(DILIB_IMPORT)/Nlm/Data/NlmPmcExplorParam.data.wiki \
                  $(DILIB)/bin/ExplorParamFromWiki
	ExplorParamFromWiki < $(DILIB_IMPORT)/Nlm/Data/NlmPmcExplorParam.data.wiki > $@

$(DILIB)/data/Nlm/PmcExplorParam.en.tab: $(DILIB_IMPORT)/Nlm/Data/NlmPmcExplorParam.en.wiki \
                  $(DILIB)/bin/ExplorParamFromWiki
	ExplorParamFromWiki < $(DILIB_IMPORT)/Nlm/Data/NlmPmcExplorParam.en.wiki > $@

$(DILIB)/data/Nlm/PmcExplorParam.fr.tab: $(DILIB_IMPORT)/Nlm/Data/NlmPmcExplorParam.fr.wiki \
                  $(DILIB)/bin/ExplorParamFromWiki
	ExplorParamFromWiki < $(DILIB_IMPORT)/Nlm/Data/NlmPmcExplorParam.fr.wiki > $@

$(DILIB)/data/Nlm/NcbiExplorParam.data.tab: $(DILIB_IMPORT)/Nlm/Data/NlmNcbiExplorParam.data.wiki \
                  $(DILIB)/bin/ExplorParamFromWiki
	ExplorParamFromWiki < $(DILIB_IMPORT)/Nlm/Data/NlmNcbiExplorParam.data.wiki > $@

$(DILIB)/data/Nlm/NcbiExplorParam.en.tab: $(DILIB_IMPORT)/Nlm/Data/NlmNcbiExplorParam.en.wiki \
                  $(DILIB)/bin/ExplorParamFromWiki
	ExplorParamFromWiki < $(DILIB_IMPORT)/Nlm/Data/NlmNcbiExplorParam.en.wiki > $@

$(DILIB)/data/Nlm/NcbiExplorParam.fr.tab: $(DILIB_IMPORT)/Nlm/Data/NlmNcbiExplorParam.fr.wiki \
                  $(DILIB)/bin/ExplorParamFromWiki
	ExplorParamFromWiki < $(DILIB_IMPORT)/Nlm/Data/NlmNcbiExplorParam.fr.wiki > $@

$(DILIB)/data/icons/LogoPubMed.png:$(DILIB_IMPORT)/Nlm/Data/LogoPubMed.png
	cp $(DILIB_IMPORT)/Nlm/Data/LogoPubMed.png $@

$(DILIB)/data/icons/LogoPmc.gif:$(DILIB_IMPORT)/Nlm/Data/LogoPmc.gif
	cp $(DILIB_IMPORT)/Nlm/Data/LogoPmc.gif $@

$(DILIB)/data/icons/LogoNcbi.png:$(DILIB_IMPORT)/Nlm/Data/LogoNcbi.png
	cp $(DILIB_IMPORT)/Nlm/Data/LogoNcbi.png $@

#------------------------------------------------------------------
# Les binaires
#

$(DILIB)/Date/Nlm.bin:$(DILIB)/bin/NlmPubMed2SxmlStep1           \
                             $(DILIB)/bin/NlmPubMed2SxmlStep2           \
                             $(DILIB)/bin/NlmPubMed2CorpusTei           \
                             $(DILIB)/bin/NlmPmc2CorpusTei              \
                             $(DILIB)/bin/NlmPmc2Sxml                   \
                             $(DILIB)/bin/Nlm2Sxml                      \
                             $(DILIB)/bin/NlmPmcResultSelect            \
                             $(DILIB)/bin/NlmPubMedResultSelect         \
                             $(DILIB)/bin/NlmMedlineExplorDataShells    \
                             $(DILIB)/bin/NlmMedlineExplorSiteHtmlPhp   \
                             $(DILIB)/bin/NlmMedlineExplorSiteShell     \
                             $(DILIB)/bin/NlmMedlineAffiliationSetPays  \
                             $(DILIB)/bin/NlmPmcExplorDataShells        \
                             $(DILIB)/bin/NlmPmcExplorSiteShell         \
                             $(DILIB)/bin/NlmPmcExplorSiteHtmlPhp       \
                             $(DILIB)/bin/NlmPmcAffiliationSetPays      \
                             $(DILIB)/bin/NlmPmcCleanCorpus             \
                             $(DILIB)/bin/NlmNcbiExplorDataShells       \
                             $(DILIB)/bin/NlmNcbiExplorSiteShell        \
                             $(DILIB)/bin/NlmCurationCountry            \
                             $(DILIB)/bin/NlmMeshFreInsermToWicri       \
                             $(DILIB)/bin/NlmMeshFreToWiki              \
                             $(DILIB)/bin/NlmPubMedGetCorpus            \
                             $(DILIB)/bin/NlmPubMedGetCorpusSize        \
                             $(DILIB)/bin/NlmPubMedFlashCorpus          \
                             $(DILIB)/bin/NlmPubMedExplorCorpus         \
                             $(DILIB)/bin/NlmPubMedExplorCorpusWithPmc  \
                             $(DILIB)/bin/NlmNcbiExplorSiteHtmlPhp      \
                             $(DILIB)/bin/NlmPmc2Wicri                  \
                             $(DILIB)/bin/NlmPmcGetCorpusById           \
                             $(DILIB)/bin/NlmMeshGetCorpusById          \
                             $(DILIB)/bin/NlmPubMedGetCorpusById        \
                             $(DILIB)/bin/NlmPubMed2Wicri               \
                             $(DILIB)/bin/NlmPubMedMeshFre              \
                             $(DILIB)/bin/NlmNcbiMerge                  \
                             $(DILIB)/bin/NlmNcbiFindNew
	$(TOUCH)

$(DILIB)/bin/NlmPubMed2SxmlStep1: $(DILIB_IMPORT)/Nlm/NlmPubMed2SxmlStep1.lex
	$(LEX) $(DILIB_IMPORT)/Nlm/NlmPubMed2SxmlStep1.lex
	$(CC) lex.yy.c -ll -o  $@ 

$(DILIB)/bin/NlmPubMedGetCorpus: $(DILIB_IMPORT)/Nlm/NlmPubMedGetCorpus.c  \
                        $(DILIB)/Date/SxmlNode.lib            \
                        $(DILIB)/Date/Nlm.lib                 \
                        $(DILIB)/Date/CharSetBuffer.lib       
	$(CC) $(DILIB_IMPORT)/Nlm/NlmPubMedGetCorpus.c    -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a  -lcurl -o $@

$(DILIB)/bin/NlmPmcGetCorpusById: $(DILIB_IMPORT)/Nlm/NlmPmcGetCorpusById.c  \
                        $(DILIB)/Date/SxmlNode.lib            \
                        $(DILIB)/Date/Nlm.lib                 \
                        $(DILIB)/Date/CharSetBuffer.lib       
	$(CC) $(DILIB_IMPORT)/Nlm/NlmPmcGetCorpusById.c    -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a  -lcurl -o $@

$(DILIB)/bin/NlmMeshGetCorpusById: $(DILIB_IMPORT)/Nlm/NlmMeshGetCorpusById.c  \
                        $(DILIB)/Date/SxmlNode.lib            \
                        $(DILIB)/Date/Nlm.lib                 \
                        $(DILIB)/Date/CharSetBuffer.lib       
	$(CC) $(DILIB_IMPORT)/Nlm/NlmMeshGetCorpusById.c    -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a  -lcurl -o $@

$(DILIB)/bin/NlmPubMedGetCorpusById: $(DILIB_IMPORT)/Nlm/NlmPubMedGetCorpusById.c  \
                        $(DILIB)/Date/SxmlNode.lib            \
                        $(DILIB)/Date/Nlm.lib                 \
                        $(DILIB)/Date/CharSetBuffer.lib       
	$(CC) $(DILIB_IMPORT)/Nlm/NlmPubMedGetCorpusById.c    -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a  -lcurl -o $@

$(DILIB)/bin/NlmNcbiMerge: $(DILIB_IMPORT)/Nlm/NlmNcbiMerge.c  \
                        $(DILIB)/Date/SxmlNode.lib            \
                        $(DILIB)/Date/CharSetBuffer.lib       
	$(CC) $(DILIB_IMPORT)/Nlm/NlmNcbiMerge.c    -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a  -lcurl -o $@

$(DILIB)/bin/NlmNcbiFindNew: $(DILIB_IMPORT)/Nlm/NlmNcbiFindNew.c  \
                        $(DILIB)/Date/SxmlNode.lib            \
                        $(DILIB)/Date/CharSetBuffer.lib       
	$(CC) $(DILIB_IMPORT)/Nlm/NlmNcbiFindNew.c    -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a  -lcurl -o $@

$(DILIB)/bin/NlmPubMedFlashCorpus:  $(DILIB_IMPORT)/Nlm/NlmPubMedFlashCorpus \
                               $(DILIB)/Date/Explor.lib  
	$(MAKE_SHELL) $(DILIB_IMPORT)/Nlm/NlmPubMedFlashCorpus $@

$(DILIB)/bin/NlmPubMedGetCorpusSize:  $(DILIB_IMPORT)/Nlm/NlmPubMedGetCorpusSize  \
                                      $(DILIB)/bin/NlmPubMedGetCorpus             \
                                      $(DILIB)/bin/SxmlSelect
	$(MAKE_SHELL) $(DILIB_IMPORT)/Nlm/NlmPubMedGetCorpusSize $@

$(DILIB)/bin/NlmPubMedExplorCorpus:  $(DILIB_IMPORT)/Nlm/NlmPubMedExplorCorpus \
                               $(DILIB)/Date/Explor.lib  
	$(MAKE_SHELL) $(DILIB_IMPORT)/Nlm/NlmPubMedExplorCorpus $@

$(DILIB)/bin/NlmPubMedExplorCorpusWithPmc:  $(DILIB_IMPORT)/Nlm/NlmPubMedExplorCorpusWithPmc \
                               $(DILIB)/Date/Explor.lib  
	$(MAKE_SHELL) $(DILIB_IMPORT)/Nlm/NlmPubMedExplorCorpusWithPmc $@

$(DILIB)/bin/NlmPmc2Sxml: $(DILIB_IMPORT)/Nlm/NlmPmc2Sxml.lex
	$(LEX) $(DILIB_IMPORT)/Nlm/NlmPmc2Sxml.lex
	$(CC) lex.yy.c -ll -o  $@

$(DILIB)/bin/Nlm2Sxml: $(DILIB_IMPORT)/Nlm/Nlm2Sxml.lex
	$(LEX) $(DILIB_IMPORT)/Nlm/Nlm2Sxml.lex
	$(CC) lex.yy.c -ll -o  $@

$(DILIB)/bin/NlmPmcResultSelect: $(DILIB_IMPORT)/Nlm/NlmPmcResultSelect.lex
	$(LEX) $(DILIB_IMPORT)/Nlm/NlmPmcResultSelect.lex
	$(CC) lex.yy.c -ll -o  $@

$(DILIB)/bin/NlmPubMedResultSelect: $(DILIB_IMPORT)/Nlm/NlmPubMedResultSelect.lex
	$(LEX) $(DILIB_IMPORT)/Nlm/NlmPubMedResultSelect.lex
	$(CC) lex.yy.c -ll -o  $@ -Wall

$(DILIB)/bin/NlmPubMed2SxmlStep2: $(DILIB_IMPORT)/Nlm/NlmPubMed2SxmlStep2.c \
                                  $(DILIB)/Date/SxPath.lib
	$(CC)  $(DILIB_IMPORT)/Nlm/NlmPubMed2SxmlStep2.c -Wall -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/NlmPmc2Wicri: $(DILIB_IMPORT)/Nlm/NlmPmc2Wicri.c \
                                  $(DILIB)/Date/SxPath.lib
	$(CC)  $(DILIB_IMPORT)/Nlm/NlmPmc2Wicri.c -Wall -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/NlmPubMed2Wicri: $(DILIB_IMPORT)/Nlm/NlmPubMed2Wicri.c \
                                  $(DILIB)/Date/SxPath.lib       \
                                  $(DILIB)/Date/StrDict.lib
	$(CC)  $(DILIB_IMPORT)/Nlm/NlmPubMed2Wicri.c -Wall -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/NlmMedlineAffiliationSetPays: $(DILIB_IMPORT)/Nlm/NlmMedlineAffiliationSetPays.c \
                           $(DILIB)/Date/Wicri.lib   \
                           $(DILIB)/Date/Utf8.lib   \
                                  $(DILIB)/Date/SxPath.lib
	$(CC)  $(DILIB_IMPORT)/Nlm/NlmMedlineAffiliationSetPays.c -Wall -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/NlmPmcAffiliationSetPays: $(DILIB_IMPORT)/Nlm/NlmPmcAffiliationSetPays.c \
                           $(DILIB)/Date/Wicri.lib   \
                           $(DILIB)/Date/Utf8.lib   \
                                  $(DILIB)/Date/SxPath.lib
	$(CC)  $(DILIB_IMPORT)/Nlm/NlmPmcAffiliationSetPays.c -Wall -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/NlmPubMed2CorpusTei: $(DILIB_IMPORT)/Nlm/NlmPubMed2CorpusTei.c \
                                  $(DILIB)/Date/SxPath.lib         \
                                  $(DILIB)/Date/Utf8.lib                    \
                                   $(DILIB)/Date/Tei.lib      
	$(CC)  $(DILIB_IMPORT)/Nlm/NlmPubMed2CorpusTei.c -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -Wall -o $@

$(DILIB)/bin/NlmPmc2CorpusTei: $(DILIB_IMPORT)/Nlm/NlmPmc2CorpusTei.c \
                                  $(DILIB)/Date/SxPath.lib         \
                                  $(DILIB)/Date/Utf8.lib                    \
                                   $(DILIB)/Date/Tei.lib      
	$(CC)  $(DILIB_IMPORT)/Nlm/NlmPmc2CorpusTei.c -Wall -I$(DILIB)/include -Wall  \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/NlmPmcCleanCorpus: $(DILIB_IMPORT)/Nlm/NlmPmcCleanCorpus.c \
                                  $(DILIB)/Date/SxPath.lib      
	$(CC)  $(DILIB_IMPORT)/Nlm/NlmPmcCleanCorpus.c -Wall -I$(DILIB)/include -Wall  \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/NlmCurationCountry:$(DILIB_IMPORT)/Nlm/NlmCurationCountry.c \
                            $(DILIB)/Date/StrSearch.lib   \
                            $(DILIB)/Date/Wicri.lib   \
                            $(DILIB)/Date/Explor.lib
	$(CC)  $(DILIB_IMPORT)/Nlm/NlmCurationCountry.c -Wall -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/NlmMeshFreToWiki:$(DILIB_IMPORT)/Nlm/NlmMeshFreToWiki.c \
                            $(DILIB)/Date/StrSearch.lib   \
                            $(DILIB)/Date/SxPath.lib
	$(CC)  $(DILIB_IMPORT)/Nlm/NlmMeshFreToWiki.c -Wall -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/NlmMeshFreInsermToWicri:$(DILIB_IMPORT)/Nlm/NlmMeshFreInsermToWicri.c \
                            $(DILIB)/Date/StrSearch.lib   \
                            $(DILIB)/Date/SxPath.lib
	$(CC)  $(DILIB_IMPORT)/Nlm/NlmMeshFreInsermToWicri.c -Wall -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/NlmPubMedMeshFre:$(DILIB_IMPORT)/Nlm/NlmPubMedMeshFre.c \
                            $(DILIB)/Date/StrSearch.lib   \
                            $(DILIB)/Date/SxPath.lib
	$(CC)  $(DILIB_IMPORT)/Nlm/NlmPubMedMeshFre.c -Wall -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/NlmPmcExplorDataShells:$(DILIB_IMPORT)/Nlm/NlmPmcExplorDataShells.c \
                            $(DILIB)/Date/StrSearch.lib   \
                            $(DILIB)/Date/Explor.lib
	$(CC)  $(DILIB_IMPORT)/Nlm/NlmPmcExplorDataShells.c -Wall -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/NlmMedlineExplorDataShells:$(DILIB_IMPORT)/Nlm/NlmMedlineExplorDataShells.c \
                            $(DILIB)/Date/StrSearch.lib   \
                            $(DILIB)/Date/Explor.lib
	$(CC)  $(DILIB_IMPORT)/Nlm/NlmMedlineExplorDataShells.c -Wall  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/NlmMedlineExplorSiteHtmlPhp:$(DILIB_IMPORT)/Nlm/NlmMedlineExplorSiteHtmlPhp.c \
                            $(DILIB)/Date/StrSearch.lib   \
                            $(DILIB)/Date/Explor.lib
	$(CC)  $(DILIB_IMPORT)/Nlm/NlmMedlineExplorSiteHtmlPhp.c -Wall  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/NlmMedlineExplorSiteShell:$(DILIB_IMPORT)/Nlm/NlmMedlineExplorSiteShell.c \
                            $(DILIB)/Date/StrSearch.lib   \
                            $(DILIB)/Date/Explor.lib
	$(CC)  $(DILIB_IMPORT)/Nlm/NlmMedlineExplorSiteShell.c -Wall -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/NlmPmcExplorSiteHtmlPhp:$(DILIB_IMPORT)/Nlm/NlmPmcExplorSiteHtmlPhp.c \
                            $(DILIB)/Date/StrSearch.lib   \
                            $(DILIB)/Date/Explor.lib
	$(CC)  $(DILIB_IMPORT)/Nlm/NlmPmcExplorSiteHtmlPhp.c  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/NlmPmcExplorSiteShell:$(DILIB_IMPORT)/Nlm/NlmPmcExplorSiteShell.c \
                            $(DILIB)/Date/StrSearch.lib   \
                            $(DILIB)/Date/Explor.lib
	$(CC)  $(DILIB_IMPORT)/Nlm/NlmPmcExplorSiteShell.c  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/NlmNcbiExplorSiteHtmlPhp:$(DILIB_IMPORT)/Nlm/NlmNcbiExplorSiteHtmlPhp.c \
                            $(DILIB)/Date/StrSearch.lib   \
                            $(DILIB)/Date/Explor.lib
	$(CC)  $(DILIB_IMPORT)/Nlm/NlmNcbiExplorSiteHtmlPhp.c  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/NlmNcbiExplorDataShells:$(DILIB_IMPORT)/Nlm/NlmNcbiExplorDataShells.c \
                            $(DILIB)/Date/StrSearch.lib   \
                            $(DILIB)/Date/Explor.lib
	$(CC)  $(DILIB_IMPORT)/Nlm/NlmNcbiExplorDataShells.c  -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

$(DILIB)/bin/NlmNcbiExplorSiteShell: $(DILIB_IMPORT)/Nlm/NlmNcbiExplorSiteShell.c \
                            $(DILIB)/Date/StrSearch.lib   \
                            $(DILIB)/Date/Explor.lib
	$(CC)  $(DILIB_IMPORT)/Nlm/NlmNcbiExplorSiteShell.c   -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

#------------------------------- end Nlm.mk ----------------
