#
#   Module  : RegExp
#   Fichier : RegExp.mk

include $(DILIB)/MakeDef.mk

$(DILIB)/Date/RegExp.mod: $(DILIB)/Date/RegExp.include \
                                 $(DILIB)/Date/RegExp.lib  \
                                 $(DILIB)/Date/RegExp.bin  \
                                 $(DILIB)/Date/RegExp.man
	$(TOUCH)

#----------------------------------------------------------------
# Les Fichiers include
#

$(DILIB)/Date/RegExp.include: $(DILIB)/include/RegExp.h
	$(TOUCH)

$(DILIB)/include/RegExp.h:  $(DILIB_IMPORT)/RegExp/RegExp.h
	cp  $(DILIB_IMPORT)/RegExp/RegExp.h $@

#--------------------------------------------------------------------
# la librairie Dilib
#

$(DILIB)/Date/RegExp.lib: $(DILIB)/Date/RegExp.o 
	$(RANLIB) $(DILIB)/lib/libDilib.a
	$(TOUCH)

$(DILIB)/Date/RegExp.o: $(DILIB_IMPORT)/RegExp/RegExp.c \
                               $(DILIB)/include/RegExp.h     \
                               $(DILIB)/include/Buffer.h     \
                               $(DILIB)/include/Except.h
	$(CC) $(DILIB_IMPORT)/RegExp/RegExp.c   -I$(DILIB)/include            \
	      -c -o RegExp.o
	ar ruv  $(DILIB)/lib/libDilib.a   RegExp.o
	$(TOUCH)

#--------------------------------------------------------------------
#    La Documentation par man d'Unix
#

$(DILIB)/Date/RegExp.man:$(DILIB)/man/man3/RegExpDilib.3
	$(TOUCH)

$(DILIB)/man/man3/RegExpDilib.3: $(DILIB_IMPORT)/RegExp/RegExp.3.man
	$(MAKE_MAN) $(DILIB_IMPORT)/RegExp/RegExp.3.man RegExp  $@
	cp $(DILIB_IMPORT)/RegExp/RegExp.3.rman $(DILIB)/man/man3/RegExp.3

#-----------------------------------------------------------------------------
#            executables (bin)
#

$(DILIB)/Date/RegExp.bin: $(DILIB)/bin/RegExpSelect
	$(TOUCH)

$(DILIB)/bin/RegExpSelect:$(DILIB_IMPORT)/RegExp/RegExpSelect.c  \
                        $(DILIB)/Date/SxmlNode.lib
	$(CC) $(DILIB_IMPORT)/RegExp/RegExpSelect.c    -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a -o $@

#-----------------------------------------------------------------------------
