/****************************************************************************
*
*      Projet  : Www
*      Module  : Ssi
*      Fichier : SsiParser.c
*      Auteur  : J. Ducloy
*
*      Date    : Janvier 99
*      $Id: SsiParser.c,v 1.2 2003/03/17 12:53:55 parmentf Exp $
*
****************************************************************************
*
* Copyright (c) 1999 - LORIA
* 
****************************************************************************/
#include "stdio.h"
#include "SsiParser.h"
#include <string.h>

SsiParser *parser;
int getopt();
extern char *optarg;
extern int optind;

int main(argc, argv)
     int argc;
     char **argv;
{  
  int cod_arg;
  int inputHasBeenDone;
  char *optString;
  FILE *outputFile;
  Buffer *bufVar;
  char *posEq;
  char *varName;
  SgmlNode *varContent;

  outputFile=NULL;
  optString="d:k:i:m:o:t:x:";
  inputHasBeenDone=0;

  parser=SsiParserCreate();
  bufVar=BufferCreate(10,10);

  while ((cod_arg = getopt(argc,argv,optString))!=EOF)
    {switch(cod_arg)
      {
      case 'd':
	SsiParserSetDict(parser, optarg);
	break;

      case 'o':
	{
	  if((outputFile=fopen(optarg,"w")))
	    {
	      SsiParserSetOutput(parser,outputFile);
	    }
	  else
	    {
	      fprintf (stderr, "**** SsiParser * File %s not founded\n", optarg);
	      exit(2);
	    }
	}
	break;

      case 'm':
	if(!(posEq=strchr(optarg,'=')))
	  {
	    fprintf (stderr, "**** SsiParser m option <%s> not fit\n" ,optarg);
	    exit(2);
	  }
	varName=malloc(posEq-optarg+1);
	varName[0]='\0';
	strncat(varName, optarg, posEq-optarg);
	switch(posEq[1])
	  {
	  case '<':
	    varContent=SgmlFromString(posEq+1);
	    break;
	  case '\\':
	    varContent=SgmlDataCreate(posEq+2);
	    break;
	  default:	    
	    varContent=SgmlDataCreate(posEq+1);
	    break;
	  }

	StrSearchPut(parser->memory, varName, (char *)varContent); 
	break;

      default:
	break;
	
      }
    }

  optind=1;
  if(!outputFile) SsiParserSetOutput(parser, stdout);

  while ((cod_arg = getopt(argc,argv,optString))!=EOF)
    {switch(cod_arg)
      {
      case 'k':
	SsiParseKey(parser, optarg);
	SsiParserPrint(parser, "\n");
	inputHasBeenDone=1;
	break;

      case 'i':
	{
	  FILE *inputFile;
	  if((inputFile=fopen(optarg,"r")))
	    {
	      SsiParseFile(parser,inputFile);
	      inputHasBeenDone=1;
	    }
	  else
	    {
	      fprintf (stderr, "**** SsiParser * File %s not founded/n", optarg);
	      exit(2);
	    }
	}
	break;

      case 't':
	SsiParseLine(parser, optarg);
	inputHasBeenDone=1;
	break;

      default:
	break;
	
      }
    }
  if(inputHasBeenDone)exit(0);
  SsiParseFile(parser, stdin);
  exit(0);
  return 0;
}
