/****************************************************************************
*
*      Projet  : Www
*      Module  : Ssi
*      Fichier : SsiParser.h
*      Auteur  : J. Ducloy
*
*      Date    : Janvier 99
*
****************************************************************************
*
* Copyright (c) 1999 - LORIA
* 
****************************************************************************/

#ifndef _SSI_PARSER_H

#define _SSI_PARSER_H

#include "StrSearch.h"
#include "Buffer.h"
#include "SgmlNode.h"

struct SsiParser_struct
{
  FILE           *outputFile;
  StrSearchTable *dict;
  StrSearchTable *memory;
  char           *endString;
  Buffer         *intBuf;
  Buffer         *keyBuf;
  char           *context;
  char           *prog;
  int             modeBuffer;
  Buffer         *bufOutput;
};

typedef struct SsiParser_struct SsiParser;


SsiParser *SsiParserSetOutput();
SsiParser *SsiParserCreate();
SsiParser *SsiParserSetDict();

#define SsiParserDict(s) ((s)->dict)
void SsiParserPrint();
#define SsiParserEndString(s) ((s)->endString)
SsiParser *SsiParserSetContext();
SsiParser *SsiParserSetProg();
SgmlNode *SsiParserGetSsi();
char *SsiParserGetKey();
void  SsiParseFile();
void  SsiParseString();
void  SsiParseLine();
char  *SsiParseKey();

#endif /* _SSI_PARSER_H */
