/**********************************************************************
*
*  projet   : DilibPro
*  module   : SgmlPath
*  commande : SgmlFast
*  fichier  : SgmlFast.c
*  Auteur   : Jacques DUCLOY
*  Date     : Avril 97
*
***********************************************************************/
#include "Buffer.h"
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
int getopt();
extern char *optarg;
Buffer *record;
static Buffer *key;
static int caseDistinction;

static char *grepString;
char *markString;
char *markId;
int  lenMarkString;
int  lenMarkId;
char *curPos;
int numZone;
static int bufToPurge;

int printMark;

int lCompare(s1,s2,l1)
char *s1;
char *s2;
int l1;
{
  int i2;
  
  for (i2=0 ; i2<l1 ; i2++)
    {
      char c1;
      char c2;
      if (!(c1=s1[i2]))return 1;
      if (!(c2=s2[i2]))return 1;
      if (tolower(c1)!=tolower(c2))return 1;
    }
  return 0;
}

#define testMark() (                                              \
		    (c=='<')                                      \
		    &&(caseDistinction==0 ?                       \
                       (strncmp(curPos,markId,lenMarkId)==0)      \
                       : (lCompare(curPos,markId,lenMarkId)==0))  \
		    &&(c1=curPos[lenMarkId])                      \
		    &&(    (c1=='>')                              \
			   ||  (c1==' ')                          \
			   )                                      \
		    )

#define skipMark()  {                                             \
	  if (c1=='>')                                            \
	    {                                                     \
	      if(printMark)printf("<%s", markString);             \
	      curPos+=strlen(markString);                         \
	    }                                                     \
	  else                                                    \
	    {                                                     \
	      posLt=strchr(curPos,'>');                           \
	      if(printMark)                                       \
		{                                                 \
		  printf("<%s", markId);                          \
		  curPos+=lenMarkId;                              \
		  while(curPos <= posLt)                          \
		    {                                             \
		      putchar(*curPos++);                         \
		    }                                             \
		}                                                 \
	      curPos=posLt+1;                                     \
	    }                                                     \
}

void lineCut();
void zoneCut()
{
  char c;

  while ((c=*curPos++))
    {
      if((c=='<')&&(curPos[0]=='/')&&(strncmp(curPos+1,markString,lenMarkString)==0))
	{
	  curPos+=strlen(markString)+1;
	  return;
	}
    }
  if ((curPos=BufferGets(record)))zoneCut();
  else exit(0);
}

void lineCut()
{
  char c;
  char c1;
  char *posLt;

  while ((c=*curPos++))
    {
      if(testMark())
	{
	  if (c1=='>')curPos+=strlen(markString);
	  else
	    {
	      posLt=strchr(curPos,'>');
	      curPos=posLt+1;
	    }
	  zoneCut();
	  continue;
	}
      putchar(c);
    }
  putchar('\n');
}

void zoneSelect()
{
  char c;

  while ((c=*curPos++))
    {
      if((c=='<')
	 &&(curPos[0]=='/')
	 &&(caseDistinction==0 ?
	    (strncmp(curPos+1,markString,lenMarkString)==0)
	    : (lCompare(curPos+1,markId,lenMarkId)==0)))
	{
	  curPos+=strlen(markString)+1;
	  return;
	}
      putchar (c);
    }
  if ((curPos=BufferGets(record)))zoneSelect();
  else exit(0);
}



void lineSelect()
{
  char c;
  char c1;
  char *posLt;

  while ((c=*curPos++))
    {
      if(testMark())
	{
          skipMark();
	  zoneSelect();
	  if(printMark)printf("</%s", markString);
	  putchar('\n');
	  continue;
	}
    }
}



char *getKey()
{
  char *pos;

  if((pos=strchr(curPos,'\t')))
    {
      BufferStrncpy(key, curPos, pos-curPos);
      curPos=pos+1;
      return BufferString(key);
    }
  else return NULL;
}

void zoneSplit()
{
  char c;

  while ((c=*curPos++))
    {
      if((c=='<')&&(curPos[0]=='/')&&(strncmp(curPos+1,markString,lenMarkString)==0))
	{
	  curPos+=strlen(markString)+1;
	  return;
	}
      putchar (c);
    }
  if ((curPos=BufferGets(record)))zoneSplit();
  else exit(0);
}



void lineSplit()
{
  char c;
  char c1;
  char *posLt;

  while ((c=*curPos++))
    {
      if(testMark())
	{
	  skipMark();
	  zoneSplit();
	  if(printMark)printf("</%s", markString);
	  printf("\t%s\n", BufferString(key));
	  continue;
	}
    }
}

void lineKey()
{
  char c;
  char c1;
  char *posLt;

  while ((c=*curPos++))
    {
      if(testMark())
	{
	  skipMark();
	  zoneSplit();
	  if(printMark)printf("</%s", markString);
	  printf("\t%s\n", BufferString(record));
	  continue;
	}
    }
}


void lineCutNum(n)
int n;
{
  char *posTab;
  char c1;
  int n1;
  n1=n-1;
  
  switch (n)
    {
    case 0:
      if ((posTab=strrchr(curPos,'\t')))
         {
	   while(curPos<posTab)
	     {
	       putchar(*curPos++);
	     }
	   putchar('\n');
	   return;
         }
      return;

    case 1:
      if ((posTab=strchr(curPos,'\t')))
	printf("%s\n",posTab+1);
      else
	{
	  if(bufToPurge)printf("\n");
	}
      return;

    default:
      bufToPurge=1;
      while((c1=*curPos++))
	{

	  switch (c1)
	    {
	    case '\t':
	      if (--n1>0)
		putchar (c1);
	      else
		{
		  if ((posTab=strchr(curPos,'\t')))
		    printf("\t%s\n",posTab+1);
		  else
		    {
		      printf("\n");
		    }
		  return;
		}
	      break;

	    case '\n':
	      putchar (c1);
	      return;

	    default:

	      putchar (c1);
	      break;
	    }
	}
      if(bufToPurge){printf("\n");bufToPurge=0;}
      return;
    }
}

void usage()
{
  fprintf(stderr,"usage: SgmlFast -cS mark ...\n");
  exit(1);
}

void computeMark(s1)
     char *s1;
{
  lenMarkString=strlen(s1)+1;
  markString=(char *)malloc((lenMarkString+1)*sizeof(char));
  strcpy (markString, s1);
  strcat (markString,">");
  markId=(char *)malloc((lenMarkString)*sizeof(char));
  lenMarkId=strlen(s1);
  strcpy (markId, s1);
}

void lineGrep()
{
  char c;
  char c1;
  char *posLt;

  while ((c=*curPos++))
    {
      if(testMark())
	{
	  if (grepString)
	    {
	      skipMark();
	      if((strncmp(grepString, curPos, strlen(grepString))==0)
		 &&(curPos[strlen(grepString)+1]='<'))
		{
		  printf("%s\n", BufferString(record));
		  break;
		}
	      else continue;
	    }
	  else
	    {
	      printf("%s\n", BufferString(record));
	      break;
	    }
	}
    }
}

void lineGrepExtract()
{
  char c;
  char c1;
  char *posLt;
  if (getKey())
    {
      while ((c=*curPos++))
	{
	  if(testMark())
	    {
	      printf ("%s\t", BufferString(key));
	      skipMark();
	      zoneSplit();
	      printf("</%s>\n", markString);
	      return;
	    }
	}
    }
  else
    {
      while ((c=*curPos++))
	{
	  if(testMark())
	    {
	      skipMark();
	      zoneSplit();
	      printf("</%s>\n", markString);
	      return;
	    }
	}
    }
}

int main(argc,argv)
      int argc;
      char **argv;
{
  int c;
  int mode;
  caseDistinction=0;
  grepString=NULL;
  record=BufferCreate(1000,1000);
  key=BufferCreate(10,10);
  printMark=1;
  while((c=getopt(argc,argv,"c:ik:g:G:ns:S:"))!=EOF)
    {
      switch(c)
	{
	case 'c':
	  if (isdigit((int)*optarg))
	    {
	      mode = 'C';
	      numZone=atoi(optarg);
	    }
	  else
	    {
	      computeMark(optarg);
	      mode = c;
	    }
	  break;

	case 'g':
	  {
	    char *posEq;
	    printMark=0;
	    if ((posEq=strchr(optarg,'=')))
	      {
		char *m1;
		m1=malloc(posEq-optarg+1);
		m1[0]='\0';
		strncat(m1, optarg, posEq-optarg);
		computeMark(m1);
		grepString=posEq+1;
	      }
	    else computeMark(optarg);
	    mode='g';
	  }
	  break;

	case 'G':
	  computeMark(optarg);
	  mode='G';
	  break;

	case 'i':
	  caseDistinction=1;
	  break;

	case 'n':
	  printMark=0;
	  break;

	case 'S':
	  computeMark(optarg);
	  mode = 'S';
	  break;

	case 's':
	  computeMark(optarg);
	  mode = 's';
	  break;

	case 'k':
	  computeMark(optarg);
	  mode ='k';
	  break;

	default:
	  usage();
	}
    }

  while (BufferGets(record))
    {
      curPos=BufferString(record);
      switch(mode)
	{
	case 'c':
	  lineCut();
	  break;

	case 'C':
	  bufToPurge=0;
	  lineCutNum(numZone);
	  break;

	case 'S':
	  lineSelect();
	  break;

	case 's':
	  if (getKey())
	    {
	      lineSplit();
	    }
	  break;

	case 'k':
	  lineKey();
	  break;

	case 'g':
	  lineGrep();
	  break;

	case 'G':
	  lineGrepExtract();
	  break;
	}
    }
  exit(0);
  return 0;
}
