/**********************************************************************
*
*  projet   : DilibPro
*  module   : SgmlText
*  commande : SgmlText
*  fichier  : SgmlText.h
*  Auteur   : Ducloy
*  Date     : Avril 95
*  Mise a jour Sept 97 (option toUpper)
*              Dec  97 (option reIndex)
*
****************************************************************************
*
* Copyright (c) 1995 CNRS/CRIN & INRIA Lorraine
* 
***********************************************************************/

#ifndef _SGML_TEXT_H_
#define _SGML_TEXT_H_
#include "Buffer.h"
#include "StrSearch.h"

struct SgmlTextIterator_struct
{
  Buffer *buffer;
  Buffer *bufTrans;
  char   *string;
  char   *begin;
  char           transco;
                          /*  S : Sgml (upper and lower)
                              s : Sgml lower case
                              A : ASCII (input and output)
                              a : ascii lower case
                              l : Sgml to lc
                          */
  int minLenWord;
  int lastLenWord;
  StrSearchTable *stopWordList;
};

typedef struct SgmlTextIterator_struct  SgmlTextIterator;

SgmlTextIterator *SgmlTextIteratorCreate();
SgmlTextIterator *SgmlTextIteratorInit();
char             *SgmlTextNextSent();
char             *SgmlTextNextWord();
void              SgmlTextAddStopWordTable();
SgmlTextIterator *SgmlTextSetTransco();
void              SgmlTextProcOtherList();
void              SgmlTextWordSetMinLen();
#endif  /* _SGML_TEXT_H_  */
