#
#   Module  : StrSearch
#   Fichier : StrSearch.mk
#

include $(DILIB)/MakeDef.mk

$(DILIB)/Date/StrSearch.mod: $(DILIB)/Date/StrSearch.include \
                                    $(DILIB)/Date/StrDict.include   \
                                    $(DILIB)/Date/StrDict.lib       \
                                    $(DILIB)/Date/StrDict.bin       \
                                    $(DILIB)/Date/StrSearch.man     \
                                    $(DILIB)/Date/StrSearch.lib
	$(TOUCH)

$(DILIB)/Date/StrDict.mod: $(DILIB)/Date/StrDict.include   \
                           $(DILIB)/Date/StrDict.lib       \
                           $(DILIB)/Date/StrDict.bin 
	$(TOUCH)

#------------------------------------------------------------------

$(DILIB)/Date/StrSearch.include: $(DILIB)/include/StrSearch.h 
	$(TOUCH)

$(DILIB)/include/StrSearch.h:  $(DILIB_IMPORT)/StrSearch/StrSearch.h
	cp  $(DILIB_IMPORT)/StrSearch/StrSearch.h $@

#------------------------------------------------------------------

$(DILIB)/Date/StrDict.include: $(DILIB)/include/StrDict.h 
	$(TOUCH)

$(DILIB)/include/StrDict.h:  $(DILIB_IMPORT)/StrSearch/StrDict.h
	cp  $(DILIB_IMPORT)/StrDict/StrDict.h $@


#------------------------------------------------------------------
# Les binaires
#

$(DILIB)/Date/StrDict.bin:$(DILIB)/bin/StrSearchKey  \
                                 $(DILIB)/bin/StrDictKey    \
                                 $(DILIB)/bin/StrDictClean    \
                                 $(DILIB)/bin/StrDictSelect \
                                 $(DILIB)/bin/StrDictMerge  \
                                 $(DILIB)/bin/StrDictFromStream
	$(TOUCH)

$(DILIB)/bin/StrSearchKey:$(DILIB_IMPORT)/StrSearch/StrSearchKey.c \
                          $(DILIB)/Date/Buffer.lib  \
                          $(DILIB)/Date/StrSearch.lib
	$(CC)  $(DILIB_IMPORT)/StrSearch/StrSearchKey.c -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a  -o $@

$(DILIB)/bin/StrDictClean:$(DILIB_IMPORT)/StrDict/StrDictClean.lex
	$(LEX) $(DILIB_IMPORT)/StrDict/StrDictClean.lex
	$(CC) lex.yy.c -ll -o  $@

$(DILIB)/bin/StrDictKey:$(DILIB_IMPORT)/StrDict/StrDictKey.c \
                          $(DILIB)/Date/Buffer.lib  \
                          $(DILIB)/Date/StrDict.lib
	$(CC)  $(DILIB_IMPORT)/StrDict/StrDictKey.c -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a  -o $@

$(DILIB)/bin/StrDictSelect:$(DILIB_IMPORT)/StrDict/StrDictSelect.c \
                          $(DILIB)/Date/Buffer.lib  \
                          $(DILIB)/Date/StrDict.lib
	$(CC)  $(DILIB_IMPORT)/StrDict/StrDictSelect.c -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a  -o $@

$(DILIB)/bin/StrDictMerge:$(DILIB_IMPORT)/StrSearch/StrDictMerge.c \
                          $(DILIB)/Date/Buffer.lib  \
                          $(DILIB)/Date/StrSearch.lib
	$(CC)  $(DILIB_IMPORT)/StrSearch/StrDictMerge.c -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a  -o $@

$(DILIB)/bin/StrDictFromStream:$(DILIB_IMPORT)/StrSearch/StrDictFromStream.c \
                               $(DILIB)/Date/Buffer.lib
	$(CC)  $(DILIB_IMPORT)/StrSearch/StrDictFromStream.c -Wall -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a  -o $@

#--------------------------------------------------------------------
# la librairie Dilib
#

$(DILIB)/Date/StrDict.lib:$(DILIB)/Date/StrDict.o \
                  $(DILIB)/Date/StrDictFile.o
	$(RANLIB) $(DILIB)/lib/libDilib.a
	$(TOUCH)

$(DILIB)/Date/StrDict.o: $(DILIB_IMPORT)/StrDict/StrDict.c  \
                                  $(DILIB)/include/StrDict.h
	$(CC) $(DILIB_IMPORT)/StrDict/StrDict.c     -Wall                  \
	           -I$(DILIB)/include      \
	           -c -o StrDict.o
	ar ruv $(DILIB)/lib/libDilib.a StrDict.o
	$(TOUCH)

$(DILIB)/Date/StrDictFile.o: $(DILIB_IMPORT)/StrDict/StrDictFile.c  \
                                  $(DILIB)/include/StrDict.h
	$(CC) $(DILIB_IMPORT)/StrDict/StrDictFile.c                         \
	           -I$(DILIB)/include      \
	           -c -o StrDictFile.o
	ar ruv $(DILIB)/lib/libDilib.a StrDictFile.o
	$(TOUCH)

$(DILIB)/Date/StrSearch.lib:$(DILIB)/Date/StrSearch.o  \
                                   $(DILIB)/Date/StrSearchGet.o
	$(RANLIB) $(DILIB)/lib/libDilib.a
	$(TOUCH)

$(DILIB)/Date/StrSearch.o: $(DILIB_IMPORT)/StrSearch/StrSearch.c  \
                                  $(DILIB)/include/StrSearch.h
	$(CC) $(DILIB_IMPORT)/StrSearch/StrSearch.c                         \
	           -I$(DILIB)/include      \
	           -c -o StrSearch.o
	ar ruv $(DILIB)/lib/libDilib.a StrSearch.o
	$(TOUCH)

$(DILIB)/Date/StrSearchGet.o: $(DILIB_IMPORT)/StrSearch/StrSearchGet.c  \
                                  $(DILIB)/include/StrSearch.h
	$(CC) $(DILIB_IMPORT)/StrSearch/StrSearchGet.c                         \
	           -I$(DILIB)/include      \
	           -c -o StrSearchGet.o
	ar ruv $(DILIB)/lib/libDilib.a StrSearchGet.o
	$(TOUCH)

#--------------------------------------------------------------------
#    La Documentation par man d'Unix

$(DILIB)/Date/StrSearch.man:$(DILIB)/man/man3/StrSearch.3  \
                                   $(DILIB)/man/man1/StrDictMerge.1
	$(TOUCH)

$(DILIB)/man/man3/StrSearch.3:$(DILIB_IMPORT)/StrSearch/StrSearch.3.man
	$(MAKE_MAN) $(DILIB_IMPORT)/StrSearch/StrSearch.3.man StrSearch $@
	cp $(DILIB_IMPORT)/StrSearch/StrSearch.3.rman $(DILIB)/man/man3/StrSearchTableCreate.3
	cp $(DILIB_IMPORT)/StrSearch/StrSearch.3.rman $(DILIB)/man/man3/StrSearchTableFree.3
	cp $(DILIB_IMPORT)/StrSearch/StrSearch.3.rman $(DILIB)/man/man3/StrSearchTableFreeStr.3
	cp $(DILIB_IMPORT)/StrSearch/StrSearch.3.rman $(DILIB)/man/man3/StrSearchTableFreeKey.3
	cp $(DILIB_IMPORT)/StrSearch/StrSearch.3.rman $(DILIB)/man/man3/StrSearchTableFreeValue.3
	cp $(DILIB_IMPORT)/StrSearch/StrSearch.3.rman $(DILIB)/man/man3/StrSearchTable.3
	cp $(DILIB_IMPORT)/StrSearch/StrSearch.3.rman $(DILIB)/man/man3/StrSearchAdd.3
	cp $(DILIB_IMPORT)/StrSearch/StrSearch.3.rman $(DILIB)/man/man3/StrSearchPut.3
	cp $(DILIB_IMPORT)/StrSearch/StrSearch.3.rman $(DILIB)/man/man3/StrSearchGetTable.3
	cp $(DILIB_IMPORT)/StrSearch/StrSearch.3.rman $(DILIB)/man/man3/StrSearchTableToFile.3
	cp $(DILIB_IMPORT)/StrSearch/StrSearch.3.rman $(DILIB)/man/man3/StrSearchGetTableFromFile.3
	cp $(DILIB_IMPORT)/StrSearch/StrSearch.3.rman $(DILIB)/man/man3/StrSearchAddTable.3
	cp $(DILIB_IMPORT)/StrSearch/StrSearch.3.rman $(DILIB)/man/man3/StrSearchGetTableC.3
	cp $(DILIB_IMPORT)/StrSearch/StrSearch.3.rman $(DILIB)/man/man3/StrSearchTableReset.3
	cp $(DILIB_IMPORT)/StrSearch/StrSearch.3.rman $(DILIB)/man/man3/StrSearchTableIteratorReset.3
	cp $(DILIB_IMPORT)/StrSearch/StrSearch.3.rman $(DILIB)/man/man3/StrSearchTableIteratorReverseReset.3
	cp $(DILIB_IMPORT)/StrSearch/StrSearch.3.rman $(DILIB)/man/man3/StrSearchNext.3
	cp $(DILIB_IMPORT)/StrSearch/StrSearch.3.rman $(DILIB)/man/man3/StrSearchPrevious.3
	cp $(DILIB_IMPORT)/StrSearch/StrSearch.3.rman $(DILIB)/man/man3/StrSearchValue.3
	cp $(DILIB_IMPORT)/StrSearch/StrSearch.3.rman $(DILIB)/man/man3/StrSearchKeyLessEqual.3

$(DILIB)/man/man1/StrDictMerge.1:$(DILIB_IMPORT)/StrSearch/StrDictMerge.1.man
	$(MAKE_MAN) $(DILIB_IMPORT)/StrSearch/StrDictMerge.1.man StrSearch $@

