#!/bin/sh

#
#       projet DilibXml
#       module SxPath
#


echo  \|-------------------------------------- module SxPath
echo  \|

cat $DILIB_IMPORT/SxPath/Test/testSxmlSelect.1.data.input  \
 | SgmlStreamExtract -t body                                                  \
       | SgmlFast -S tr                                                       \
       | SxmlSelect -g tr/td@class=mw-interwikitable-prefix/1 -p @g1          \
                    -g tr/td@class=mw-interwikitable-url/1 -p @g2             \
 >  $DILIB/MakeDir/testSxmlSelect.1.data.output

diff $DILIB/MakeDir/testSxmlSelect.1.data.output   \
     $DILIB_IMPORT/SxPath/Test/testSxmlSelect.1.data.target \
    >  $DILIB/MakeDir/sxmlSelect.test1.diff

if test -s  $DILIB/MakeDir/sxmlSelect.test1.diff
then 
  echo XmlProc "****************************** ERROR SxPath SxmlSelect *****"
else
  echo ----- SxmlSelect Test 1 OK
  rm  $DILIB/MakeDir/testSxmlSelect.1.data.output
  rm  $DILIB/MakeDir/sxmlSelect.test1.diff
fi

#------------------------------

gcc $DILIB_IMPORT/SxPath/Test/sxPath.test2.c $DILIB_CC -o $DILIB/MakeDir/sxPath.test2
$DILIB/MakeDir/sxPath.test2 >  $DILIB/MakeDir/sxPath.test2.data.output

diff $DILIB/MakeDir/sxPath.test2.data.output \
       $DILIB_IMPORT/SxPath/Test/sxPath.test2.data.target \
    >  $DILIB/MakeDir/sxPath.test2.diff

if test -s  $DILIB/MakeDir/sxPath.test2.diff
then 
  echo "****************************** ERROR SxPath (test 2) *****"
else
  echo ----- SxPath Test 2 OK

  rm $DILIB/MakeDir/sxPath.test2.data.output
  rm $DILIB/MakeDir/sxPath.test2 
  rm   $DILIB/MakeDir/sxPath.test2.diff
fi

#------------------------------

 SxmlSelect -s doc/mcl/e/1 book/kw/li -p @s1 -p @1 <  $DILIB_IMPORT/SxPath/Test/sxPath.test3.data.input >  $DILIB/MakeDir/sxPath.test3.data.output
 SxmlSelect -s book/aut/a/1 -s book/kw/li/1 -p @s1 -p @s2 -p @1 < $DILIB_IMPORT/SxPath/Test/sxPath.test3.data.input >> $DILIB/MakeDir/sxPath.test3.data.output

SxmlSelect -g 1/2/2 -p @g1 < $DILIB_IMPORT/SxPath/Test/sxPath.test3.data.input >> $DILIB/MakeDir/sxPath.test3.data.output

SxmlSelect -g book/aut/a -p @g1@g2 -g book/tit < $DILIB_IMPORT/SxPath/Test/sxPath.test3.data.input  >> $DILIB/MakeDir/sxPath.test3.data.output
diff $DILIB/MakeDir/sxPath.test3.data.output \
       $DILIB_IMPORT/SxPath/Test/sxPath.test3.data.target \
    >  $DILIB/MakeDir/sxPath.test3.diff

if test -s  $DILIB/MakeDir/sxPath.test2.diff
then 
  echo "****************************** ERROR SxPath (test 3) *****"
else
  echo ----- SxPath Test 3 OK
  rm $DILIB/MakeDir/sxPath.test3.data.output 
  rm $DILIB/MakeDir/sxPath.test3.diff
fi
