.TH XmlNode 3 "2 June 2003"
.SH NAME
SxmlAttribute, SxmlListAttributes \- Sxml attributes management.
.SH SYNOPSIS
.PP
.nf
\#include "SxmlNode.h"
.fi
.SS Constructors
.PP
.nf
.ft B 
SxmlNode\(** SxmlAttributeCreate(name,value)
	char *name;
	char *value;
.ft
.fi

.PP
.nf
.ft B
SxmlNode *SxmlListAttributesCreate()
.ft
.fi

.SS Methods
.PP
.nf
.ft B 
char\(** SxmlGetAttribute(elem,name)
	SxmlNode *elem;
	char *name;
.ft
.fi


.PP
.nf
.ft B
SxmlNode *SxmlSetAttribute(e1,n1,v1)
     SxmlNode *e1;
     char *n1;
     char *v1;
.ft
.fi

.PP
.nf
.ft B
char *SxmlHasAttribute(x1,a1,v1)
     SxmlNode *x1;
     char *a1;
     char *v1;
.ft
.fi

.PP
.nf
.ft B
SxmlNode *SxmlListAttributes(e1)
     SxmlNode *e1;
.ft
.fi

.SS "Output Methods"
.PP
.nf
.ft B
void SxmlAttributeFilePrint(a1,f1)
     SxmlNode *a1;
     FILE *f1;
.ft
.fi

.PP
.nf
.ft B
void SxmlListAttributesFilePrint(l1,f1)
     SxmlNode *l1;
     FILE *f1;
.ft
.fi

.PP
.nf
.ft B
char *SxmlAttributeToString(b1,a1)  
     Buffer  *b1;
     SxmlNode *a1;
.ft
.fi

.PP
.nf
.ft B
char *SxmlListAttributesToString(b1,l1)  
     Buffer  *b1;
     SxmlNode *l1;
.ft
.fi

.SS "Internal Methods"
.PP
.nf
.ft B 
SxmlNode\(** SxmlGetAttributeNode(elem,name)
	SxmlNode *elem;
        char *name;
.ft
.fi

.PP
.nf
.ft B
SxmlNode *SxmlSetListAttributes(e1,l1)
     SxmlNode *l1;
     SxmlNode *e1;
.ft
.fi

.SH DESCRIPTION
.PP
.B SxmlAttribute
inherits from 
.BR SxmlNode .

.PP
.B SxmlListAttributes
inherits from 
.BR SxmlNodeList .

.SS Constructors
.TP
.B SxmlAttributeCreate
is the basic constructor of a SxmlAttribute.
Strings
.I value
and
.I name
are copied while creating 
.B SxmlAttributes.

.TP
.B SxmlListAttributesCreate
builds an empty list of attributes.

.SS Methods

.TP
.B SxmlGetAttribute
returns the value of the attribute of the 
.BR SxmlNode (3)
.I elem
which name is
.IR name .

.TP
.B SxmlSetAttribute
sets the value
.I v1
to the attribute
.I n1
of the element
.IR e1 .

.TP
.B SxmlHasAttribute
checks wether the attribute of 
.I x1
which name is
.I a1
has the value 
.IR v1 .
Returns the value when it has the same value as 
.IR v1 , 
and NULL when its value is different, or the attribute
.I a1
does not exist in the SxmlNode
.IR e1 .

.TP
.B SxmlGetListAttributes
Returns the list of attributes of the node
.IR e1 .

.SS "Output Methods"
.TP
.B SxmlAttributeFilePrint
prints to the file
.I f1
the name and the value of the attribute
.I a1
in XML format.

.TP
.B SxmlListAttributesFilePrint
prints to the file
.I f1
all the attributes of the list
.I l1
in XML format.

.TP
.B SxmlAttributeToString
translates the SxmlAttribute
.I a1
to a C string, returns it, and adds it to the 
.BR Buffer (3)
.IR b1 .
.I Warning:
when 
.I b1
changes, the returned string may change too.
You don't have to free the returned string (it will be at the call to
.BR BufferFree (3)).

.TP
.B SxmlListAttributesToString
translates the SxmlListAttributes
.I l1
to a C string, returns it, and adds it to the 
.BR Buffer (3)
.IR b1 .
.I Warning:
when 
.I b1
changes, the returned string may change too.
You don't have to free the returned string (it will be at the call to
.BR BufferFree (3)).

.SH EXAMPLE
.nf
#include "SxmlNode.h"

SxmlNode *node = SxmlLeafCreate("tagname","content");
SxmlSetAttribute(node,"version","beta");

.fi

.SH FILES
.nf
  $DILIB_ROOT/Import/DilibSxml/SxmlNode/Source/SxmlNode.h
  $DILIB_ROOT/Import/DilibSxml/SxmlNode/Source/SxmlAtt.c
.fi

.SH AUTHORS
INIST-CNRS: J. DUCLOY, F. PARMENTIER <DilibMaster@inist.fr>

.SH "SEE ALSO"
.BR SxmlNode (3),
.BR SxmlNodeList (3),
.BR Buffer (3).

