%{
/**********************************************************************
*
*  module   : SxmlNode
*  fichier  : SxmlFromEd
*  Auteur   : Jacques DUCLOY
*  Date     : Octobre 93
*
***********************************************************************/


char tag[100];

 int currentState;
int level;

#define begin(s) { BEGIN(s); currentState=s;}

void dataEndMark();



%}


%START DATA DOC MARK COMMENT COM_SGML END_MARK SGML KEY

NL  [ \t]*\n[ \t\n]*
SP  [ \t]+

%%
<DOC>^"#"                  BEGIN KEY;
<DOC>^";"                  BEGIN COMMENT;
<DOC>"<--"                 BEGIN COM_SGML;
<DOC>"<"                   {ECHO; begin(MARK);}
<DATA>"<SGML>"            {printf("</%s>", tag); BEGIN SGML;}
<MARK>"<SGML>"             BEGIN SGML;
<COM_SGML>.                ;
<COM_SGML>"-->"            BEGIN currentState;
<COM_SGML>\n               ;
<SGML>[ \t]*\n[ \t]*       printf(" ");
<SGML>.                    ECHO;
<SGML>"</SGML>"            BEGIN MARK;
<COMMENT>.                 ;
<COMMENT>\n                BEGIN currentState;
<MARK>{NL}                 ;
<MARK>{SP}                 ;
<MARK>^"</"[^>]+">"        {ECHO; printf("\n");}
<MARK>"</"[^>]+">"         {ECHO;}
<MARK>"<"                  {ECHO;}
<MARK>[^< >]+              {ECHO; strcpy(tag,yytext); begin(END_MARK);}
<END_MARK>">"[\n\t ]*/[^\n\t <] {printf(">"); begin (DATA);}
<END_MARK>">"[\n\t ]*      {printf(">"); begin (MARK);}
<END_MARK>.                ECHO;
<DATA>^"</"[^ >]+">"       {dataEndMark(); printf("\n");}
<DATA>{NL}/"<"             ;
<DATA>{SP}/"<"             ;
<DATA>"</"[^ >]+">"        dataEndMark();
<DATA>"<"                  {printf("</%s><", tag); begin (MARK);}
<DATA>{NL}                 printf(" ");
<KEY>[ ]*\n                {printf("\t"); begin (MARK);}
<KEY>.                     ECHO;
%%

void dataEndMark()
{
   if (strcmp(yytext+2,tag)==0) {ECHO;}
   else printf("</%s>%s", tag, yytext);
   begin ( MARK);
}

int main()
{
  BEGIN DOC;
  level=0;
  yylex();
  exit(0);
}
