#
#   Module  : SxmlNode
#   Fichier : SxmlNode.mk
#

include $(DILIB)/MakeDef.mk

$(DILIB)/Date/SxmlNode.mod:  $(DILIB)/Date/SxmlNode.include \
                               $(DILIB)/Date/SxmlNode.man          \
                               $(DILIB)/Date/SxmlNode.lib          \
                               $(DILIB)/Date/SxmlNode.php          \
                               $(DILIB)/Date/SxmlNode.bin
	$(TOUCH)

#----------------------------------------------------------------
# Les Fichiers include
#

$(DILIB)/Date/SxmlNode.include: $(DILIB)/include/SxmlNode.h
	$(TOUCH)

$(DILIB)/include/SxmlNode.h:  $(DILIB_IMPORT)/SxmlNode/SxmlNode.h \
                             $(DILIB)/include/Buffer.h   \
                             $(DILIB)/include/SgmlNode.h   \
                             $(DILIB)/include/DilibKernel.h   \
                             $(DILIB)/include/StrDict.h      \
                             $(DILIB)/include/StrSearch.h
	cp  $(DILIB_IMPORT)/SxmlNode/SxmlNode.h $@

#----------------------------------------------------------------
# php files
#
$(DILIB)/Date/SxmlNode.php: $(DILIB)/php/SxmlNode/SxmlNode.php
	$(TOUCH)

$(DILIB)/php/SxmlNode/SxmlNode.php: $(DILIB_IMPORT)/SxmlNode/SxmlNode.php
	cp $(DILIB_IMPORT)/SxmlNode/SxmlNode.php $@



#--------------------------------------------------------------------
# la librairie Dilib
#

$(DILIB)/Date/SxmlNode.lib:$(DILIB)/Date/SxmlElement.o \
                         $(DILIB)/Date/BufferParserXml.o \
                         $(DILIB)/Date/SxmlNodeKernel.o \
                         $(DILIB)/Date/SxmlComment.o  \
                         $(DILIB)/Date/SxmlTree.o  \
                         $(DILIB)/Date/SxmlAtt.o   \
                         $(DILIB)/Date/SxmlPrint.o \
                         $(DILIB)/Date/SxmlContainer.o \
                         $(DILIB)/Date/SxmlRecord.o   \
                         $(DILIB)/Date/SxmlDocument.o  \
                         $(DILIB)/Date/SxmlText.o   \
                         $(DILIB)/Date/SxmlParser.o \
                         $(DILIB)/Date/SxmlDtd.o \
                         $(DILIB)/Date/SxmlSearch.o \
                         $(DILIB)/Date/SxmlNodeList.o \
                         $(DILIB)/Date/SxmlClone.o   \
                         $(DILIB)/Date/SxmlNodeUnIndent.o   \
                         $(DILIB)/Date/SgmlNode.lib \
                         $(DILIB)/Date/RegExp.lib  \
                         $(DILIB)/Date/StrSearch.lib
	$(RANLIB) $(DILIB)/lib/libDilib.a
	$(TOUCH)

$(DILIB)/Date/SxmlElement.o: $(DILIB_IMPORT)/SxmlNode/SxmlElement.c \
                                  $(DILIB)/include/SxmlNode.h
	$(CC) $(DILIB_IMPORT)/SxmlNode/SxmlElement.c -Wall   -I$(DILIB)/include   \
	                                             -c -o SxmlElement.o 
	ar ruv $(DILIB)/lib/libDilib.a SxmlElement.o
	$(TOUCH)

$(DILIB)/Date/SxmlNodeKernel.o: $(DILIB_IMPORT)/SxmlNode/SxmlNodeKernel.c \
                                  $(DILIB)/include/SxmlNode.h
	$(CC) $(DILIB_IMPORT)/SxmlNode/SxmlNodeKernel.c    -I$(DILIB)/include   \
	                                             -c -o SxmlNodeKernel.o
	ar ruv $(DILIB)/lib/libDilib.a SxmlNodeKernel.o
	$(TOUCH)

$(DILIB)/Date/SxmlNodeList.o: $(DILIB_IMPORT)/SxmlNode/SxmlNodeList.c \
                                  $(DILIB)/include/SxmlNode.h
	$(CC) $(DILIB_IMPORT)/SxmlNode/SxmlNodeList.c -Wall   -I$(DILIB)/include   \
	                                             -c -o SxmlNodeList.o
	ar ruv $(DILIB)/lib/libDilib.a SxmlNodeList.o
	$(TOUCH)

$(DILIB)/Date/SxmlNodeUnIndent.o: $(DILIB_IMPORT)/SxmlNode/SxmlNodeUnIndent.c \
                                  $(DILIB)/include/SxmlNode.h
	$(CC) $(DILIB_IMPORT)/SxmlNode/SxmlNodeUnIndent.c -Wall   -I$(DILIB)/include   \
	                                             -c -o SxmlNodeUnIndent.o
	ar ruv $(DILIB)/lib/libDilib.a SxmlNodeUnIndent.o
	$(TOUCH)

$(DILIB)/Date/SxmlComment.o: $(DILIB_IMPORT)/SxmlNode/SxmlComment.c \
                                  $(DILIB)/include/SxmlNode.h
	$(CC) $(DILIB_IMPORT)/SxmlNode/SxmlComment.c    -I$(DILIB)/include   \
	                                             -c -o SxmlComment.o 
	ar ruv $(DILIB)/lib/libDilib.a SxmlComment.o
	$(TOUCH)

$(DILIB)/Date/SxmlTree.o: $(DILIB_IMPORT)/SxmlNode/SxmlTree.c \
                                  $(DILIB)/include/SxmlNode.h
	$(CC) $(DILIB_IMPORT)/SxmlNode/SxmlTree.c    -I$(DILIB)/include   \
	                                             -c -o SxmlTree.o 
	ar ruv $(DILIB)/lib/libDilib.a SxmlTree.o
	$(TOUCH)

$(DILIB)/Date/SxmlAtt.o: $(DILIB_IMPORT)/SxmlNode/SxmlAtt.c \
                                  $(DILIB)/include/SxmlNode.h
	$(CC) $(DILIB_IMPORT)/SxmlNode/SxmlAtt.c    -I$(DILIB)/include   \
	                                             -c -o SxmlAtt.o 
	ar ruv $(DILIB)/lib/libDilib.a SxmlAtt.o
	$(TOUCH)


$(DILIB)/Date/SxmlPrint.o: $(DILIB_IMPORT)/SxmlNode/SxmlPrint.c \
                                  $(DILIB)/include/SxmlNode.h
	$(CC) $(DILIB_IMPORT)/SxmlNode/SxmlPrint.c -Wall   -I$(DILIB)/include   \
	                                             -c -o SxmlPrint.o 
	ar ruv $(DILIB)/lib/libDilib.a SxmlPrint.o
	$(TOUCH)

$(DILIB)/Date/SxmlContainer.o: $(DILIB_IMPORT)/SxmlNode/SxmlContainer.c \
                                  $(DILIB)/include/SxmlNode.h    \
                                 $(DILIB)/include/RegExp.h
	$(CC) $(DILIB_IMPORT)/SxmlNode/SxmlContainer.c    -I$(DILIB)/include   \
	                                             -c -o SxmlContainer.o 
	ar ruv $(DILIB)/lib/libDilib.a SxmlContainer.o
	$(TOUCH)

$(DILIB)/Date/SxmlDocument.o: $(DILIB_IMPORT)/SxmlNode/SxmlDocument.c \
                                  $(DILIB)/include/SxmlNode.h    \
                                  $(DILIB)/Date/Buffer.include
	$(CC) $(DILIB_IMPORT)/SxmlNode/SxmlDocument.c    -I$(DILIB)/include   \
	                                             -c -o SxmlDocument.o 
	ar ruv $(DILIB)/lib/libDilib.a SxmlDocument.o
	$(TOUCH)

$(DILIB)/Date/SxmlText.o: $(DILIB_IMPORT)/SxmlNode/SxmlText.c \
                                  $(DILIB)/include/SxmlNode.h
	$(CC) $(DILIB_IMPORT)/SxmlNode/SxmlText.c    -I$(DILIB)/include   \
	                                             -c -o SxmlText.o 
	ar ruv $(DILIB)/lib/libDilib.a SxmlText.o
	$(TOUCH)

$(DILIB)/Date/SxmlRecord.o: $(DILIB_IMPORT)/SxmlNode/SxmlRecord.c \
                                  $(DILIB)/include/SxmlNode.h
	$(CC) $(DILIB_IMPORT)/SxmlNode/SxmlRecord.c    -I$(DILIB)/include   \
	                                             -c -o SxmlRecord.o 
	ar ruv $(DILIB)/lib/libDilib.a SxmlRecord.o
	$(TOUCH)

$(DILIB)/Date/SxmlParser.o: $(DILIB_IMPORT)/SxmlNode/SxmlParser.c \
                                  $(DILIB)/include/SxmlNode.h
	$(CC) $(DILIB_IMPORT)/SxmlNode/SxmlParser.c -Wall   -I$(DILIB)/include   \
	                                             -c -o SxmlParser.o 
	ar ruv $(DILIB)/lib/libDilib.a SxmlParser.o
	$(TOUCH)

$(DILIB)/Date/SxmlDtd.o: $(DILIB_IMPORT)/SxmlNode/SxmlDtd.c \
                                  $(DILIB)/include/SxmlNode.h
	$(CC) $(DILIB_IMPORT)/SxmlNode/SxmlDtd.c    -I$(DILIB)/include   \
	                                             -c -o SxmlDtd.o 
	ar ruv $(DILIB)/lib/libDilib.a SxmlDtd.o
	$(TOUCH)


$(DILIB)/Date/SxmlSearch.o: $(DILIB_IMPORT)/SxmlNode/SxmlSearch.c \
                                  $(DILIB)/include/SxmlNode.h \
                                  $(DILIB)/Date/StrDict.mod
	$(CC) $(DILIB_IMPORT)/SxmlNode/SxmlSearch.c    -I$(DILIB)/include   \
	                                             -c -o SxmlSearch.o 
	ar ruv $(DILIB)/lib/libDilib.a SxmlSearch.o
	$(TOUCH)

$(DILIB)/Date/SxmlClone.o: $(DILIB_IMPORT)/SxmlNode/SxmlClone.c \
                                  $(DILIB)/include/SxmlNode.h
	$(CC) $(DILIB_IMPORT)/SxmlNode/SxmlClone.c    -I$(DILIB)/include   \
	                                             -c -o SxmlClone.o 
	ar ruv $(DILIB)/lib/libDilib.a SxmlClone.o
	$(TOUCH)

#------------------------------------------------------------------
# Les binaires
#

$(DILIB)/Date/SxmlNode.bin: $(DILIB)/bin/SxmlUnIndent         \
                            $(DILIB)/bin/SxmlIndent           \
                            $(DILIB)/bin/SxmlCount            \
                            $(DILIB)/bin/SxmlFromXmlList      \
                            $(DILIB)/bin/SxmlGrouping         \
                            $(DILIB)/bin/SxmlCumul            \
                            $(DILIB)/bin/SxmlFindText               \
                            $(DILIB)/bin/SxmlFindTextBuildDict     \
                            $(DILIB)/bin/SxmlRecordPutKey           \
                            $(DILIB)/bin/SxmlRecordHead             \
                            $(DILIB)/bin/SxmlRecordTail             \
                            $(DILIB)/bin/SxmlFromEd                 \
                            $(DILIB)/bin/SxmlRecordRange
	$(TOUCH)

$(DILIB)/bin/SxmlUnIndent: $(DILIB_IMPORT)/SxmlNode/SxmlUnIndent.c \
                           $(DILIB)/Date/SxmlNode.lib
	$(CC)  $(DILIB_IMPORT)/SxmlNode/SxmlUnIndent.c -Wall -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a  -o $@

$(DILIB)/bin/SxmlCount: $(DILIB_IMPORT)/SxmlNode/SxmlCount.c \
                           $(DILIB)/Date/SxmlNode.lib
	$(CC)  $(DILIB_IMPORT)/SxmlNode/SxmlCount.c -Wall -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a  -o $@

$(DILIB)/bin/SxmlIndent: $(DILIB_IMPORT)/SxmlNode/SxmlIndent.c \
                         $(DILIB)/Date/Buffer.lib              \
                         $(DILIB)/Date/SxmlNode.lib
	$(CC)  $(DILIB_IMPORT)/SxmlNode/SxmlIndent.c -Wall -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a  -o $@

$(DILIB)/bin/SxmlFromEd:$(DILIB_IMPORT)/SxmlNode/SxmlFromEd.lex
	$(LEX) $(DILIB_IMPORT)/SxmlNode/SxmlFromEd.lex
	$(CC) lex.yy.c -ll -o  $@

$(DILIB)/bin/SxmlRecordHead: $(DILIB_IMPORT)/SxmlNode/SxmlRecordHead.c \
                         $(DILIB)/Date/Buffer.lib          
	$(CC)  $(DILIB_IMPORT)/SxmlNode/SxmlRecordHead.c -Wall -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a  -o $@

$(DILIB)/bin/SxmlRecordTail: $(DILIB_IMPORT)/SxmlNode/SxmlRecordTail.c \
                         $(DILIB)/Date/Buffer.lib          
	$(CC)  $(DILIB_IMPORT)/SxmlNode/SxmlRecordTail.c -Wall -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a  -o $@

$(DILIB)/bin/SxmlRecordRange: $(DILIB_IMPORT)/SxmlNode/SxmlRecordRange.c \
                         $(DILIB)/Date/Buffer.lib          
	$(CC)  $(DILIB_IMPORT)/SxmlNode/SxmlRecordRange.c -Wall -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a  -o $@

$(DILIB)/bin/SxmlFindText: $(DILIB_IMPORT)/SxmlNode/SxmlFindText.c \
                         $(DILIB)/Date/Buffer.lib              \
                         $(DILIB)/Date/SxmlNode.lib
	$(CC)  $(DILIB_IMPORT)/SxmlNode/SxmlFindText.c -Wall -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a  -o $@

$(DILIB)/bin/SxmlFindTextBuildDict: $(DILIB_IMPORT)/SxmlNode/SxmlFindTextBuildDict.c \
                         $(DILIB)/Date/Buffer.lib              \
                         $(DILIB)/Date/SxmlNode.lib
	$(CC)  $(DILIB_IMPORT)/SxmlNode/SxmlFindTextBuildDict.c -Wall -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a  -o $@

$(DILIB)/bin/SxmlFromXmlList: $(DILIB_IMPORT)/SxmlNode/SxmlFromXmlList.c \
                     $(DILIB)/Date/SxmlNode.lib
	$(CC)  $(DILIB_IMPORT)/SxmlNode/SxmlFromXmlList.c -Wall -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a  -o $@

$(DILIB)/bin/SxmlGrouping: $(DILIB_IMPORT)/SxmlNode/SxmlGrouping.c \
                     $(DILIB)/Date/SxmlNode.lib
	$(CC)  $(DILIB_IMPORT)/SxmlNode/SxmlGrouping.c -Wall -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a  -o $@

$(DILIB)/bin/SxmlCumul: $(DILIB_IMPORT)/SxmlNode/SxmlCumul.c \
                     $(DILIB)/Date/SxmlNode.lib
	$(CC)  $(DILIB_IMPORT)/SxmlNode/SxmlCumul.c -Wall -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a  -o $@

$(DILIB)/bin/SxmlRecordPutKey: $(DILIB_IMPORT)/SxmlNode/SxmlRecordPutKey.c \
                     $(DILIB)/Date/Buffer.lib
	$(CC)  $(DILIB_IMPORT)/SxmlNode/SxmlRecordPutKey.c -I$(DILIB)/include \
	                         $(DILIB)/lib/libDilib.a  -o $@

#--------------------------------------------------------------------
#    La Documentation par man d'Unix

$(DILIB)/Date/SxmlNode.man:$(DILIB)/man/man3/SxmlNode.3       \
                                  $(DILIB)/man/man1/SxmlRecord.1 \
                                  $(DILIB)/man/man3/SxmlRecord.3       \
                                  $(DILIB)/man/man3/SxmlNodeList.3       \
                                  $(DILIB)/man/man3/SxmlAttribute.3
	$(TOUCH)

$(DILIB)/man/man3/SxmlAttribute.3: $(DILIB_IMPORT)/SxmlNode/SxmlAttribute.3.man
	$(MAKE_MAN) $(DILIB_IMPORT)/SxmlNode/SxmlAttribute.3.man SxmlAttribute  $@

$(DILIB)/man/man1/SxmlRecord.1: $(DILIB_IMPORT)/SxmlNode/SxmlRecord.1.man
	$(MAKE_MAN) $(DILIB_IMPORT)/SxmlNode/SxmlRecord.1.man SxmlNode $@
	cp $(DILIB_IMPORT)/SxmlNode/SxmlRecord.1.rman $(DILIB)/man/man1/SxmlRecordHead.1
	cp $(DILIB_IMPORT)/SxmlNode/SxmlRecord.1.rman $(DILIB)/man/man1/SxmlRecordTail.1
	cp $(DILIB_IMPORT)/SxmlNode/SxmlRecord.1.rman $(DILIB)/man/man1/SxmlRecordRange.1

$(DILIB)/man/man3/SxmlRecord.3: $(DILIB_IMPORT)/SxmlNode/SxmlRecord.3.man
	$(MAKE_MAN) $(DILIB_IMPORT)/SxmlNode/SxmlRecord.3.man SxmlRecord  $@

$(DILIB)/man/man3/SxmlNode.3: $(DILIB_IMPORT)/SxmlNode/SxmlNode.3.man
	$(MAKE_MAN) $(DILIB_IMPORT)/SxmlNode/SxmlNode.3.man SxmlNode  $@
	cp $(DILIB_IMPORT)/SxmlNode/SxmlNode.3.rman $(DILIB)/man/man3/SxmlNodeCreate.3
	cp $(DILIB_IMPORT)/SxmlNode/SxmlNode.3.rman $(DILIB)/man/man3/SxmlFromFile.3
	cp $(DILIB_IMPORT)/SxmlNode/SxmlNode.3.rman $(DILIB)/man/man3/SxmlParent.3
	cp $(DILIB_IMPORT)/SxmlNode/SxmlNode.3.rman $(DILIB)/man/man3/SxmlNodeName.3
	cp $(DILIB_IMPORT)/SxmlNode/SxmlNode.3.rman $(DILIB)/man/man3/SxmlNodeType.3
	cp $(DILIB_IMPORT)/SxmlNode/SxmlNode.3.rman $(DILIB)/man/man3/SxmlNodeValue.3
	cp $(DILIB_IMPORT)/SxmlNode/SxmlNode.3.rman $(DILIB)/man/man3/SxmlFirstChild.3
	cp $(DILIB_IMPORT)/SxmlNode/SxmlNode.3.rman $(DILIB)/man/man3/SxmlLastChild.3
	cp $(DILIB_IMPORT)/SxmlNode/SxmlNode.3.rman $(DILIB)/man/man3/SxmlClone.3
	cp $(DILIB_IMPORT)/SxmlNode/SxmlNode.3.rman $(DILIB)/man/man3/SxmlNextSibling.3
	cp $(DILIB_IMPORT)/SxmlNode/SxmlNode.3.rman $(DILIB)/man/man3/SxmlPreviousSibling.3
	cp $(DILIB_IMPORT)/SxmlNode/SxmlNode.3.rman $(DILIB)/man/man3/SxmlNextNode.3
	cp $(DILIB_IMPORT)/SxmlNode/SxmlNode.3.rman $(DILIB)/man/man3/SxmlIsElement.3
	cp $(DILIB_IMPORT)/SxmlNode/SxmlNode.3.rman $(DILIB)/man/man3/SxmlIsText.3
	cp $(DILIB_IMPORT)/SxmlNode/SxmlNode.3.rman $(DILIB)/man/man3/SxmlIsLeaf.3
	cp $(DILIB_IMPORT)/SxmlNode/SxmlNode.3.rman $(DILIB)/man/man3/SxmlReset.3
	cp $(DILIB_IMPORT)/SxmlNode/SxmlNode.3.rman $(DILIB)/man/man3/SxmlFree.3
	cp $(DILIB_IMPORT)/SxmlNode/SxmlNode.3.rman $(DILIB)/man/man3/SxmlFreeContent.3
	cp $(DILIB_IMPORT)/SxmlNode/SxmlNode.3.rman $(DILIB)/man/man3/SxmlFreeChildren.3
	cp $(DILIB_IMPORT)/SxmlNode/SxmlNode.3.rman $(DILIB)/man/man3/SxmlReplaceName.3
	cp $(DILIB_IMPORT)/SxmlNode/SxmlNode.3.rman $(DILIB)/man/man3/SxmlReplaceValue.3
	cp $(DILIB_IMPORT)/SxmlNode/SxmlNode.3.rman $(DILIB)/man/man3/SxmlNodeHasName.3
	cp $(DILIB_IMPORT)/SxmlNode/SxmlNode.3.rman $(DILIB)/man/man3/SxmlNodeHasValue.3
	cp $(DILIB_IMPORT)/SxmlNode/SxmlNode.3.rman $(DILIB)/man/man3/SxmlGetFirstChildByTagName.3
	cp $(DILIB_IMPORT)/SxmlNode/SxmlNode.3.rman $(DILIB)/man/man3/SxmlGetNextSiblingByTagName.3
	cp $(DILIB_IMPORT)/SxmlNode/SxmlNode.3.rman $(DILIB)/man/man3/SxmlLength.3
	cp $(DILIB_IMPORT)/SxmlNode/SxmlNode.3.rman $(DILIB)/man/man3/SxmlAppendChild.3
	cp $(DILIB_IMPORT)/SxmlNode/SxmlNode.3.rman $(DILIB)/man/man3/SxmlRemoveChild.3
	cp $(DILIB_IMPORT)/SxmlNode/SxmlNode.3.rman $(DILIB)/man/man3/SxmlInsertBefore.3
	cp $(DILIB_IMPORT)/SxmlNode/SxmlNode.3.rman $(DILIB)/man/man3/SxmlInsertAfter.3
	cp $(DILIB_IMPORT)/SxmlNode/SxmlNode.3.rman $(DILIB)/man/man3/SxmlAddFirstChild.3
	cp $(DILIB_IMPORT)/SxmlNode/SxmlNode.3.rman $(DILIB)/man/man3/SxmlSetNodeIntegerValue.3
	cp $(DILIB_IMPORT)/SxmlNode/SxmlNode.3.rman $(DILIB)/man/man3/SxmlNodeIntegerValue.3


$(DILIB)/man/man3/SxmlNodeList.3: $(DILIB_IMPORT)/SxmlNode/SxmlNodeList.3.man
	$(MAKE_MAN) $(DILIB_IMPORT)/SxmlNode/SxmlNodeList.3.man SxmlNodeList  $@
#--------------------------- end SxmlNode.mk ---------------
