/*   -*- coding: utf-8 -*-  */
/***********************************************************************
 
   Module   : Wicri
   Commande : WicriExplorBiblioShell
   Fichier  : WicriExplorBiblioShell.c
   Auteur   : DUCLOY
   Date     : 2012
 
************************************************************************/

#include <stdio.h>     /* for printf */
#include <stdlib.h>    /* for exit */
#include "Explor.h"

extern char *optarg;
extern int   optind;
int getopt();

SxmlNode *ExplorStepNode;
SxmlNode *streamListSteps;

void generWicriShellCorpusBiblio()
{
  char *wicriImportFile;
  char *strListWicriImportFile;
  SxmlNode *listWicriImportFile;

  printf("<?dilib file=\"%s/bin/%sCorpusBiblio.sh\" ?>\n", ExplorAreaDir, ExplorStreamCode );
  printf ("#!/bin/sh\n");
  ExplorGenerDeleteHfd(ExplorStreamCode, "Corpus", "biblio");
  wicriImportFile=ExplorGetFromDictK3("Area", ExplorStreamCode, "Corpus/Wicri:biblioImportFile");
  strListWicriImportFile=ExplorGetFromDictK3("Area", ExplorStreamCode, "Corpus/importFile");
  printf ("( \n");
  if (wicriImportFile) printf ("cat %s/Import/%s   \n", ExplorAreaDir, wicriImportFile);
  if (strListWicriImportFile)
    {
      SxmlNode *nodeFile;
      listWicriImportFile=SxmlFromString(strListWicriImportFile);
      SxmlReset(listWicriImportFile);
      while ((nodeFile=SxmlNextNode(listWicriImportFile)))
	{
	  char *wicriImportUnit;
	  wicriImportUnit=SxmlLeafText(nodeFile);
	  printf (" cat %s/Import/%s   \n", ExplorAreaDir, wicriImportUnit);
	}
    }
  else listWicriImportFile=NULL;
  printf (" )  | SmwCsvToSxml -l \"A pour auteur\"   \\\n");
  printf ("   | SxmlRecordPutKey -b %s/Corpus/biblio  \\\n", ExplorStreamCode);
  printf ("   | WicriBiblioCsv2CorpusTei  \\\n");
  printf ("   | TeiPutRefToIdno -t wicri:Area/%s/Corpus  \\\n", ExplorStreamCode );
  printf ("   | HfdBuild -h %s/Data/%s/Corpus/biblio\n\n",ExplorAreaDir, ExplorStreamCode);

  printf (" echo \"==== \" %s, step Corpus, biblio done\n", ExplorStreamCode);
  printf (" HfdCat %s/Data/%s/Corpus/biblio.hfd | wc \n", ExplorAreaDir, ExplorStreamCode);

  printf("<?dilib appendFile=\"%s/bin/area.mk\" ?>\n", ExplorAreaDir );
  printf("# This part is generated by WicriBiblioExplorDataShells /  generCcsdShellCorpusBiblio() \n");
  printf("%s/Make/%s/Corpus/biblio: ", ExplorAreaDir, ExplorStreamCode);
  if (wicriImportFile) 
    {
      printf (" \\\n");
      printf("                %s/Import/%s \n", ExplorAreaDir, wicriImportFile);
    }
  else if  (strListWicriImportFile)
    {
      SxmlNode *nodeFile;
      SxmlReset(listWicriImportFile);
      while ((nodeFile=SxmlNextNode(listWicriImportFile)))
	{
	  char *wicriImportUnit;
	  wicriImportUnit=SxmlLeafText(nodeFile);
	  printf (" \\\n");
	  printf ("           %s/Import/%s", ExplorAreaDir, wicriImportUnit);
	}
    }
  printf("\n\tsh %s/bin/%sCorpusBiblio.sh \n", ExplorAreaDir, ExplorStreamCode );
  printf("\ttouch %s/Make/%s/Corpus/biblio\n\n", ExplorAreaDir, ExplorStreamCode);
}

void generWicriShellCheckpointBiblio()
{
  SxmlNode *previousStep;
  char *codePrevious;

  printf("<?dilib file=\"%s/bin/%sCheckpointBiblio.sh\" ?>\n", ExplorAreaDir, ExplorStreamCode );
  printf ("#!/bin/sh\n");
  previousStep=SxmlPreviousSibling(ExplorStepNode);
  codePrevious=SxmlLeafText(previousStep);

  printf (" HfdCat %s/Data/%s/%s/biblio.hfd \\\n", ExplorAreaDir, ExplorStreamCode, codePrevious);
  printf ("   | HfdBuild -h %s/Data/%s/Checkpoint/biblio\n\n",ExplorAreaDir, ExplorStreamCode);

  printf (" echo \"==== \" %s, step Checkpoint, biblio done\n", ExplorStreamCode);
  printf (" HfdCat %s/Data/%s/Checkpoint/biblio.hfd | wc \n", ExplorAreaDir, ExplorStreamCode);

  printf("<?dilib appendFile=\"%s/bin/area.mk\" ?>\n", ExplorAreaDir );
  printf("# This part is generated by WicriBiblioExplorDataShells /  generNlmPmcShellCurationBiblio() \n");
  printf("%s/Make/%s/Checkpoint/biblio: \\\n", ExplorAreaDir, ExplorStreamCode);
  printf("                %s/Make/%s/%s.step \n", ExplorAreaDir, ExplorStreamCode, codePrevious);
  printf("\tsh %s/bin/%sCheckpointBiblio.sh \n", ExplorAreaDir, ExplorStreamCode );
  printf("\ttouch %s/Make/%s/Checkpoint/biblio\n\n", ExplorAreaDir, ExplorStreamCode);

}

int main (int argc, char **argv) {
  int cOption;

  char *pathParamFile;

  pathParamFile=NULL;
  
   while((cOption=getopt(argc,argv,"s:t:"))!=EOF)
     {switch (cOption)
	 {
	 case 's':
	   ExplorStreamCode=optarg;
	   break;
	 case 't':
	   pathParamFile=optarg;
	   break;
	 }
     }
   ExplorParamInit(pathParamFile);
   streamListSteps=SxmlFromString(ExplorGetFromDictK3("Area", ExplorStreamCode, "listSteps"));
   ExplorGenerShellCreateData( ExplorStreamCode, streamListSteps);

   SxmlReset(streamListSteps);
   while ((ExplorStepNode=SxmlNextNode(streamListSteps)))
    {
      char *stepCode;
      stepCode=SxmlLeafText(ExplorStepNode);
      if(strcmp(stepCode, "Corpus")==0)
	{
	  ExplorGenerShellCreateStep(ExplorStreamCode , stepCode);
	  generWicriShellCorpusBiblio();
	  continue;
	}
      if(strcmp(stepCode, "Checkpoint")==0)
	{
	  ExplorGenerShellCreateStep(ExplorStreamCode , stepCode);
	  generWicriShellCheckpointBiblio();
	  continue;
	}
    }
   ExplorGenerAllShellsIndex(ExplorStreamCode);
   exit (EXIT_SUCCESS);
}



